// NOBase.h
//
// NOBase: base class (kind of) for NO-objects
//			
//
// (c) NiXPS NV, February 2008

#ifndef _NOBASE_H_
#define _NOBASE_H_

#include "NOException.h"

/*! \file NOBASE.h
    \brief Header file for NOBase class
*/

extern "C"
{
}

#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

/**
 * \class NOImage NOImage.h "NOImage.h"
 * Class representing an image in an XPS package
 */
class NOBase
{
	public:
		NCommon::UInt32 mID;
		NCommon::UInt32 mError;
		NCommon::NXType mType;
		void *mDoc;
		
		NOBase(const NOXHandler &pBase)
		{
			mID = pBase.mCursor;
			mType = (NCommon::NXType) pBase.mType;
			mDoc = pBase.mDoc;
			mError = pBase.mError;
		}
		
		bool hasType(NCommon::NXType pType)
		{
			return mType == pType;
		}
		
		NOXGlyphs asGlyphs()
		{
			NOXGlyphs lGlyphs;
			if (mType == xGlyphs)
			{
				lGlyphs.mHandler.mDoc = (NiXML::XMLDoc*) mDoc;
				lGlyphs.mHandler.mType=xGlyphs;
				lGlyphs.mHandler.mCursor=mID;
				lGlyphs.mHandler.mError=0;
			}
			else
				throw NiXPSObjects::NOException(1);
			return lGlyphs;
		}

		NOXPath asPath()
		{
			NOXPath lPath;
			if (mType == xPath)
			{
				lPath.mHandler.mDoc = (NiXML::XMLDoc*) mDoc;
				lPath.mHandler.mType=xPath;
				lPath.mHandler.mCursor=mID;
				lPath.mHandler.mError=0;
			}
			else
				throw NiXPSObjects::NOException(1);
			return lPath;
		}
};

}

#endif

#endif // _NO_BASE_H_
