// NOCoreProperties.h
//
// NOCoreProperties: CoreProperties class
//			
// (c) NiXPS NV, October 2006

#ifndef _NOCOREPROPERTIES_H_
#define _NOCOREPROPERTIES_H_

/*! \file NOCoreProperties.h
    \brief Header file for NOCoreProperties class
*/

#include "NTypes.h"
#include "NOXMLPartBased.h"
#include "NTCorePropertyType.h"
#include "NOString.h"

extern "C"
{
	DLLIMPORTEXPORT NOCorePropertiesHandler NOCoreProperties_new(NOHandler *pHandler, NCommon::UInt16 pID);
	DLLIMPORTEXPORT NCommon::UInt32 NOCoreProperties_getProperty(NOCorePropertiesHandler *pHandler, NCommon::UInt32 pType, NOStringHandler *pString);
	DLLIMPORTEXPORT void NOCoreProperties_setProperty(NOCorePropertiesHandler *pHandler, NCommon::UInt32 pType, const NCommon::UTF8Char *pString);
}

#ifdef NIXPS_CPP_INTERFACE

namespace NiXPSObjects
{

class NOPackage;

using namespace NiXPSAccess;

/*!
 * \class NOCoreProperties NOCoreProperties.h "NOCoreProperties.h"
 * Class representing the core properties of an XML package
 */
class NOCoreProperties: public NOXMLPartBased
{
	public:	
		NOCoreProperties(NOCorePropertiesHandler pHandler);

		// destructor
		virtual ~NOCoreProperties();

		/// Get property as a UTF8String
		/// @param pType The type of property to get
		const NCommon::UTF8String getProperty(NCommon::CoreProperty::Type pType);
		
		void setProperty(NCommon::CoreProperty::Type pType, const NCommon::UTF8Char *pString);
};

}
#endif // NIXPS_CPP_INTERFACE

#endif
