// Basic exception
//
// (c) NiXPS NV, June 2006

#ifndef _NOEXCEPTION_H_
#define _NOEXCEPTION_H_

/*! \file NOException.h
    \brief Header file for NOException class
*/

#include <exception>

#include "NTypes.h"

namespace NiXPSObjects
{

/**
 * \class NOException NOException.h "NOException.h"
 * Class representing an exception thrown by the NiXPS Library
 */
class NOException: public std::exception
{
	public:
		NOException(const NOHandler &pHandler): mError(pHandler.mError) {};
		NOException(NCommon::UInt32 pError): mError(pError) {};
		~NOException() throw() {};

		/// Returns the error code that was the result of this exception
		NCommon::UInt32 getError() const
		{
			return mError;
		};

	private:
		const NCommon::UInt32 mError;
};

}

#endif
