// NOImageVector
//
// (c) NiXPS NV, May 2007

#ifndef _NOIMAGEVECTOR_H_
#define _NOIMAGEVECTOR_H_

/*! \file NOImageVector.h
    \brief Header file for NOImageVector class
*/

#include "NOVector.h"
#include "NOImage.h"
#include "NOPackage.h"

#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

using namespace NCommon;

class NOPartBased;
class NODocument;

/*!
 * \class NOImageVector NOImageVector.h "NOImageVector.h"
 * Vector of images.
 */
class NOImageVector: public NOVector
{
	friend class NODocument;

	private:
		// constructor: object is always linked to a specific package (and probably also a specific part)
		NOImageVector(NiXPSAccess::NAPackage *pPackage);

	public:
		// constructor
		NOImageVector(NOPackage &pPackage);

		// destructor
		virtual ~NOImageVector();
		
		/// Returns the image at given index represented by an NOImage object
		/// @param pIndex The index of the image to obtain
		NOImage elementAt(const NCommon::UInt32 pIndex) const;
};

}

#endif // NIXPS_CPP_INTERFACE
#endif
