// NOOptions
//
// (c) NiXPS NV, April 2009

#ifndef _NOOptions_H_
#define _NOOptions_H_

/*! \file NOOptions.h
    \brief Header file for NOOptions class
*/

#include "NTypes.h"

extern "C" {
	DLLIMPORTEXPORT NOOptionsHandler NOOptions_new();
	DLLIMPORTEXPORT void NOOptions_setOption(NOOptionsHandler *pHandler, NCommon::UTF8Char *pOption, NCommon::UTF8Char *pValue);
	DLLIMPORTEXPORT void NOOptions_delete(NOOptionsHandler *pHandler);
};

#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOOptions NOOptions.h "NOOptions.h"
 * String class for NiXPS Library
 */
class NOOptions
{
	public:
		mutable NOOptionsHandler mHandler;

		NOOptions();

		// destructor
		virtual ~NOOptions();
		
		// set option
		void setOption(UTF8Char *pSource, UTF8Char *pDestination);
};

}

#endif // NIXPS_CPP_INTERFACE

#endif
