// NOPartBased.h
//
// NOPartBased:	base class for all NiXPSObjects based on a part
//			
//
// (c) NiXPS NV, October 2006

#ifndef _NOPARTBASED_H_
#define _NOPARTBASED_H_

//#include "NOBase.h"
#include "NTPartType.h"
#include "NTypes.h"

// C api
extern "C" {
	DLLIMPORTEXPORT NOHandler NOHandler_empty();
	DLLIMPORTEXPORT NOHandler NOHandler_new(NOHandler* pHandler, NCommon::UInt16 pID, NCommon::UInt32 pType);
	DLLIMPORTEXPORT NOXHandler NOXHandler_empty();
	DLLIMPORTEXPORT NCommon::UInt32 NOHandler_doesExist(NOHandler* pHandler);
	DLLIMPORTEXPORT void NOHandler_getPartName(NOHandler* pHandler, NOStringHandler *pString);
	DLLIMPORTEXPORT NCommon::UInt32 NOHandler_isInMemory(NOHandler* pHandler);
};

// C++ api
#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

class NOPackage;

class NOPartBased
{
	protected:
		// default constructor
		NOPartBased();

	public:
		NOHandler mHandler;		

		// constructor: object is always linked to a specific package and a part ID
		NOPartBased(const NOHandler pHandler);

		// constructor: object is always linked to a specific package and a part ID
		NOPartBased(NOPackage *pPackage, const NCommon::UInt32 pID);

		// destructor
		virtual ~NOPartBased();
		
		// test for emptyness
		bool isEmpty() const;

		// test to find out is the part is in memory
		bool isInMemory() const;

		// get the part id
		NCommon::UInt32 getPartID() const;

		// get the name of this part
		NCommon::UTF8String getPartName() const;

		// get the name of this part
		NCommon::Part::Type getType() const;		
};

}
#endif // NIXPS_CPP_INTERFACE
#endif
