/*
 *  NOProgressReporter.h
 *  NOProgressReporter
 *
 *  Created by Kristof Van Landschoot on 02/07/07.
 *  Copyright 2007 NiXPS NV. All rights reserved.
 *
 */

/*! \file NOProgressReporter.h
    \brief Header file for NOProgressReporter class
*/

#ifndef _NOPROGRESS_REPORTER_H
#define _NOPROGRESS_REPORTER_H

#ifdef NIXPS_CPP_INTERFACE

#include "NTypes.h"

namespace NiXPSObjects
{

/*!
 * \class NOProgressReporter NOProgressReporter.h "NOProgressReporter.h"
 * Class you need to override to get feedback about the progress of an operation.
 */
class NOProgressReporter {

	NCommon::UTF8String mInfo;
	NCommon::UInt32 mMaximum;


	public:

	NOProgressReporterHandler mHandler;

	NOProgressReporter();

	virtual ~NOProgressReporter();

	/// UpdateStatus will get called whenever there has been some progress for the operation
	virtual void UpdateStatus(NCommon::UInt32 pValue);
	
	void setMaximum(NCommon::UInt32 lVal) { mMaximum = lVal; }
	NCommon::UInt32 getMaximum() const { return mMaximum; }

	const NCommon::UTF8String & getInfo() const { return mInfo; }
	void setInfo(const NCommon::UTF8String &pInfo) { mInfo = pInfo; }

	NOProgressReporterHandler getHandler();
};

}

#endif // NIXPS_CPP_INTERFACE

#endif		// _NOPROGRESS_REPORTER_H
