// NOStringVector
//
// (c) NiXPS NV, February 2008

#ifndef _NOSTRINGVECTOR_H_
#define _NOSTRINGVECTOR_H_

/*! \file NOStringVector.h
    \brief Header file for NOStringVector class
*/

#include "NTypes.h"
#include "NOString.h"

extern "C" {
	DLLIMPORTEXPORT NOStringVectorHandler NOStringVector_new();
	DLLIMPORTEXPORT void NOStringVector_delete(NOStringVectorHandler *pHandler);
	DLLIMPORTEXPORT void NOStringVector_getString(NOStringVectorHandler *pHandler1, NCommon::UInt32 pIndex, NOStringHandler *pHandler2);
	DLLIMPORTEXPORT NCommon::UInt32 NOStringVector_getSize(NOStringVectorHandler *pHandler);
	DLLIMPORTEXPORT void NOStringVector_clear(NOStringVectorHandler *pStringVectorHandler);
	DLLIMPORTEXPORT void NOStringVector_pushBack(NOStringVectorHandler *pHandler, const NCommon::UTF8Char *pStringPtr);
};

#ifdef NIXPS_CPP_INTERFACE

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOStringVector NOStringVector.h "NOStringVector.h"
 * Stringvector class for NiXPS Library
 */
class NOStringVector
{
	public:
		NOStringVectorHandler mHandler;

		NOStringVector();
		virtual ~NOStringVector();

		NiXPSObjects::NOString getString(UInt32 pIndex);
		NCommon::UInt32 getSize();
		NOStringVectorHandler getHandler();
		void clear();
};

}

#endif // NIXPS_CPP_INTERFACE

#endif	// _NOSTRINGVECTOR_H_
