// NOThumbnail.h
//
// NOThumbnail: NOThumbnail class
//			
//
// (c) NiXPS NV, November 2006

#ifndef _NOTHUMBNAIL_H_
#define _NOTHUMBNAIL_H_

/*! \file NOThumbnail.h
    \brief Header file for NOThumbnail class
*/

#include "NTypes.h"
#include "NOPartBased.h"

extern "C"
{
	DLLIMPORTEXPORT NCommon::UInt32 NOThumbnail_getImageSize(NOThumbnailHandler* pThumbnail);
	DLLIMPORTEXPORT NCommon::UInt32 NOThumbnail_getImageData(NOThumbnailHandler* pThumbnail, NCommon::UInt8 *pBuffer, NCommon::UInt32 pSize);
}

#ifdef NIXPS_CPP_INTERFACE
namespace NiXPSObjects
{

using namespace NCommon;

class NOPackage;

/*!
 * \class NOThumbnail NOThumbnail.h "NOThumbnail.h"
 * Class representing a thumbnail in an XPS package.
 */
class NOThumbnail: public NOPartBased
{
	public:
		NOThumbnail();

		NOThumbnail(const NOThumbnailHandler pHandler);

		virtual ~NOThumbnail();

		/// Get image size, the size of the data representing the image
		UInt32 getImageSize();

		/// Get image data
		/// @param pBuffer buffer to be filled with the image data
		/// @param pSize the size of the buffer.  Should be bigger than or equal the value returned by getImageSize for the operation to complete successfully
		/// @return wheters operation was successful or not
		bool getImageData(UInt8 *pBuffer, UInt32 pSize);
};

}

#endif // NIXPS_CPP_INTERFACE
#endif
