// NOXArcSegment header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXArcSegment_h_
#define _NOXArcSegment_h_

/*! \file NOXArcSegment.h
	\brief Header file for the NOXArcSegment class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXArcSegment_getPoint(NOXHandler *pHandler, NOXPoint *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_hasPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_removePoint(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXArcSegment_setPoint(NOXHandler *pHandler, NOXPoint pObject);
DLLIMPORTEXPORT void NAXArcSegment_getSize(NOXHandler *pHandler, NOXPointGE0 *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_hasSize(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_removeSize(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXArcSegment_setSize(NOXHandler *pHandler, NOXPointGE0 pObject);
DLLIMPORTEXPORT void NAXArcSegment_getRotationAngle(NOXHandler *pHandler, NOXDouble *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_hasRotationAngle(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_removeRotationAngle(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXArcSegment_setRotationAngle(NOXHandler *pHandler, NOXDouble pObject);
DLLIMPORTEXPORT void NAXArcSegment_getIsLargeArc(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_hasIsLargeArc(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_removeIsLargeArc(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXArcSegment_setIsLargeArc(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT void NAXArcSegment_getSweepDirection(NOXHandler *pHandler, NOXSweepDirection *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_hasSweepDirection(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_removeSweepDirection(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXArcSegment_setSweepDirection(NOXHandler *pHandler, NOXSweepDirection pObject);
DLLIMPORTEXPORT void NAXArcSegment_getIsStroked(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_hasIsStroked(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXArcSegment_removeIsStroked(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXArcSegment_setIsStroked(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT NOXBoolean NAXArcSegment_getDefaultIsStroked();
DLLIMPORTEXPORT void NAXArcSegment_intialize(NOXHandler *pHandler, NOXPoint pPoint, NOXPointGE0 pSize, NOXDouble pRotationAngle, NOXBoolean pIsLargeArc, NOXSweepDirection pSweepDirection);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXArcSegment NOXArcSegment.h "NOXPrefix.h"
 * Class NOXArcSegment
 */
class NOXArcSegment
{
	public:
		NOXHandler mHandler;
		NOXArcSegment()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXArcSegment(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Point attribute
		void NOXArcSegment::getPoint(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXArcSegment_getPoint(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Point attribute
		bool NOXArcSegment::hasPoint()
		{
			return (NAXArcSegment_hasPoint(&mHandler)!=0);
		}

		/// Removes the Point attribute
		bool NOXArcSegment::removePoint()
		{
			return (NAXArcSegment_removePoint(&mHandler)!=0);
		}

		/// Sets the Point attribute
		void NOXArcSegment::setPoint(NOXPoint pObject)
		{
			NAXArcSegment_setPoint(&mHandler, pObject);
		}

		/// Get the Size attribute
		void NOXArcSegment::getSize(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXArcSegment_getSize(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Size attribute
		bool NOXArcSegment::hasSize()
		{
			return (NAXArcSegment_hasSize(&mHandler)!=0);
		}

		/// Removes the Size attribute
		bool NOXArcSegment::removeSize()
		{
			return (NAXArcSegment_removeSize(&mHandler)!=0);
		}

		/// Sets the Size attribute
		void NOXArcSegment::setSize(NOXPointGE0 pObject)
		{
			NAXArcSegment_setSize(&mHandler, pObject);
		}

		/// Get the RotationAngle attribute
		NOXDouble NOXArcSegment::getRotationAngle()
		{
			NOXDouble lHandler;
			NAXArcSegment_getRotationAngle(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the RotationAngle attribute
		bool NOXArcSegment::hasRotationAngle()
		{
			return (NAXArcSegment_hasRotationAngle(&mHandler)!=0);
		}

		/// Removes the RotationAngle attribute
		bool NOXArcSegment::removeRotationAngle()
		{
			return (NAXArcSegment_removeRotationAngle(&mHandler)!=0);
		}

		/// Sets the RotationAngle attribute
		void NOXArcSegment::setRotationAngle(NOXDouble pObject)
		{
			NAXArcSegment_setRotationAngle(&mHandler, pObject);
		}

		/// Get the IsLargeArc attribute
		NOXBoolean NOXArcSegment::getIsLargeArc()
		{
			NOXBoolean lHandler;
			NAXArcSegment_getIsLargeArc(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsLargeArc attribute
		bool NOXArcSegment::hasIsLargeArc()
		{
			return (NAXArcSegment_hasIsLargeArc(&mHandler)!=0);
		}

		/// Removes the IsLargeArc attribute
		bool NOXArcSegment::removeIsLargeArc()
		{
			return (NAXArcSegment_removeIsLargeArc(&mHandler)!=0);
		}

		/// Sets the IsLargeArc attribute
		void NOXArcSegment::setIsLargeArc(NOXBoolean pObject)
		{
			NAXArcSegment_setIsLargeArc(&mHandler, pObject);
		}

		/// Get the SweepDirection attribute
		NOXSweepDirection NOXArcSegment::getSweepDirection()
		{
			NOXSweepDirection lHandler;
			NAXArcSegment_getSweepDirection(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the SweepDirection attribute
		bool NOXArcSegment::hasSweepDirection()
		{
			return (NAXArcSegment_hasSweepDirection(&mHandler)!=0);
		}

		/// Removes the SweepDirection attribute
		bool NOXArcSegment::removeSweepDirection()
		{
			return (NAXArcSegment_removeSweepDirection(&mHandler)!=0);
		}

		/// Sets the SweepDirection attribute
		void NOXArcSegment::setSweepDirection(NOXSweepDirection pObject)
		{
			NAXArcSegment_setSweepDirection(&mHandler, pObject);
		}

		/// Get the IsStroked attribute
		NOXBoolean NOXArcSegment::getIsStroked()
		{
			NOXBoolean lHandler;
			NAXArcSegment_getIsStroked(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsStroked attribute
		bool NOXArcSegment::hasIsStroked()
		{
			return (NAXArcSegment_hasIsStroked(&mHandler)!=0);
		}

		/// Removes the IsStroked attribute
		bool NOXArcSegment::removeIsStroked()
		{
			return (NAXArcSegment_removeIsStroked(&mHandler)!=0);
		}

		/// Sets the IsStroked attribute
		void NOXArcSegment::setIsStroked(NOXBoolean pObject)
		{
			NAXArcSegment_setIsStroked(&mHandler, pObject);
		}

		/// Get the default IsStroked
		NOXBoolean NOXArcSegment::getDefaultIsStroked()
		{
			return NAXArcSegment_getDefaultIsStroked();
		}

		/// Initialize
		/*public*/ void intialize(NOXPoint pPoint, NOXPointGE0 pSize, NOXDouble pRotationAngle, NOXBoolean pIsLargeArc, NOXSweepDirection pSweepDirection)
		{
			NAXArcSegment_intialize(&mHandler, pPoint, pSize, pRotationAngle, pIsLargeArc, pSweepDirection);
		}

};

}

#endif
