// NOXCP_Brush header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_Brush_h_
#define _NOXCP_Brush_h_

/*! \file NOXCP_Brush.h
	\brief Header file for the NOXCP_Brush class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_getImageBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_getNumImageBrush(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_createImageBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_deleteImageBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_getLinearGradientBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_getNumLinearGradientBrush(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_createLinearGradientBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_deleteLinearGradientBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_getRadialGradientBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_getNumRadialGradientBrush(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_createRadialGradientBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_deleteRadialGradientBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_getSolidColorBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_getNumSolidColorBrush(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_createSolidColorBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_deleteSolidColorBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_getVisualBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_getNumVisualBrush(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_createVisualBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_deleteVisualBrush(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_Brush_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Brush_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Brush_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_Brush NOXCP_Brush.h "NOXPrefix.h"
 * Class NOXCP_Brush
 */
class NOXCP_Brush
{
	public:
		NOXHandler mHandler;
		NOXCP_Brush()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_Brush(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ImageBrush element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXImageBrush NOXCP_Brush::getImageBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_getImageBrush(&mHandler, pIndex);
		}

		/// Calculate the number of ImageBrush elements that are present
		NCommon::UInt32 NOXCP_Brush::getNumImageBrush()
		{
			return NAXCP_Brush_getNumImageBrush(&mHandler);
		}

		/// Create an ImageBrush element at index pIndex
		/*public*/ NOXImageBrush NOXCP_Brush::createImageBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_createImageBrush(&mHandler, pIndex);
		}

		/// Delete an ImageBrush element at index pIndex
		NCommon::UInt32 NOXCP_Brush::deleteImageBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_deleteImageBrush(&mHandler, pIndex);
		}

		/// Get LinearGradientBrush element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXLinearGradientBrush NOXCP_Brush::getLinearGradientBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_getLinearGradientBrush(&mHandler, pIndex);
		}

		/// Calculate the number of LinearGradientBrush elements that are present
		NCommon::UInt32 NOXCP_Brush::getNumLinearGradientBrush()
		{
			return NAXCP_Brush_getNumLinearGradientBrush(&mHandler);
		}

		/// Create an LinearGradientBrush element at index pIndex
		/*public*/ NOXLinearGradientBrush NOXCP_Brush::createLinearGradientBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_createLinearGradientBrush(&mHandler, pIndex);
		}

		/// Delete an LinearGradientBrush element at index pIndex
		NCommon::UInt32 NOXCP_Brush::deleteLinearGradientBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_deleteLinearGradientBrush(&mHandler, pIndex);
		}

		/// Get RadialGradientBrush element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXRadialGradientBrush NOXCP_Brush::getRadialGradientBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_getRadialGradientBrush(&mHandler, pIndex);
		}

		/// Calculate the number of RadialGradientBrush elements that are present
		NCommon::UInt32 NOXCP_Brush::getNumRadialGradientBrush()
		{
			return NAXCP_Brush_getNumRadialGradientBrush(&mHandler);
		}

		/// Create an RadialGradientBrush element at index pIndex
		/*public*/ NOXRadialGradientBrush NOXCP_Brush::createRadialGradientBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_createRadialGradientBrush(&mHandler, pIndex);
		}

		/// Delete an RadialGradientBrush element at index pIndex
		NCommon::UInt32 NOXCP_Brush::deleteRadialGradientBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_deleteRadialGradientBrush(&mHandler, pIndex);
		}

		/// Get SolidColorBrush element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXSolidColorBrush NOXCP_Brush::getSolidColorBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_getSolidColorBrush(&mHandler, pIndex);
		}

		/// Calculate the number of SolidColorBrush elements that are present
		NCommon::UInt32 NOXCP_Brush::getNumSolidColorBrush()
		{
			return NAXCP_Brush_getNumSolidColorBrush(&mHandler);
		}

		/// Create an SolidColorBrush element at index pIndex
		/*public*/ NOXSolidColorBrush NOXCP_Brush::createSolidColorBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_createSolidColorBrush(&mHandler, pIndex);
		}

		/// Delete an SolidColorBrush element at index pIndex
		NCommon::UInt32 NOXCP_Brush::deleteSolidColorBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_deleteSolidColorBrush(&mHandler, pIndex);
		}

		/// Get VisualBrush element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXVisualBrush NOXCP_Brush::getVisualBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_getVisualBrush(&mHandler, pIndex);
		}

		/// Calculate the number of VisualBrush elements that are present
		NCommon::UInt32 NOXCP_Brush::getNumVisualBrush()
		{
			return NAXCP_Brush_getNumVisualBrush(&mHandler);
		}

		/// Create an VisualBrush element at index pIndex
		/*public*/ NOXVisualBrush NOXCP_Brush::createVisualBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_createVisualBrush(&mHandler, pIndex);
		}

		/// Delete an VisualBrush element at index pIndex
		NCommon::UInt32 NOXCP_Brush::deleteVisualBrush(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_deleteVisualBrush(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_Brush_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Brush::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_Brush_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_Brush::getNumChilds()
		{
			return NAXCP_Brush_getNumChilds(&mHandler);
		}

};

}

#endif
