// NOXCP_Geometry header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_Geometry_h_
#define _NOXCP_Geometry_h_

/*! \file NOXCP_Geometry.h
	\brief Header file for the NOXCP_Geometry class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_Geometry_getPathGeometry(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Geometry_getNumPathGeometry(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Geometry_createPathGeometry(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Geometry_deletePathGeometry(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_Geometry_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Geometry_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Geometry_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_Geometry NOXCP_Geometry.h "NOXPrefix.h"
 * Class NOXCP_Geometry
 */
class NOXCP_Geometry
{
	public:
		NOXHandler mHandler;
		NOXCP_Geometry()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_Geometry(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get PathGeometry element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPathGeometry NOXCP_Geometry::getPathGeometry(NCommon::UInt32 pIndex)
		{
			return NAXCP_Geometry_getPathGeometry(&mHandler, pIndex);
		}

		/// Calculate the number of PathGeometry elements that are present
		NCommon::UInt32 NOXCP_Geometry::getNumPathGeometry()
		{
			return NAXCP_Geometry_getNumPathGeometry(&mHandler);
		}

		/// Create an PathGeometry element at index pIndex
		/*public*/ NOXPathGeometry NOXCP_Geometry::createPathGeometry(NCommon::UInt32 pIndex)
		{
			return NAXCP_Geometry_createPathGeometry(&mHandler, pIndex);
		}

		/// Delete an PathGeometry element at index pIndex
		NCommon::UInt32 NOXCP_Geometry::deletePathGeometry(NCommon::UInt32 pIndex)
		{
			return NAXCP_Geometry_deletePathGeometry(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_Geometry_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Geometry::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_Geometry_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_Geometry::getNumChilds()
		{
			return NAXCP_Geometry_getNumChilds(&mHandler);
		}

};

}

#endif
