// NOXCP_GradientStops header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_GradientStops_h_
#define _NOXCP_GradientStops_h_

/*! \file NOXCP_GradientStops.h
	\brief Header file for the NOXCP_GradientStops class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_GradientStops_getGradientStop(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_GradientStops_getNumGradientStop(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_GradientStops_createGradientStop(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_GradientStops_deleteGradientStop(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_GradientStops_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_GradientStops_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_GradientStops_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_GradientStops NOXCP_GradientStops.h "NOXPrefix.h"
 * Class NOXCP_GradientStops
 */
class NOXCP_GradientStops
{
	public:
		NOXHandler mHandler;
		NOXCP_GradientStops()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_GradientStops(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get GradientStop element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXGradientStop NOXCP_GradientStops::getGradientStop(NCommon::UInt32 pIndex)
		{
			return NAXCP_GradientStops_getGradientStop(&mHandler, pIndex);
		}

		/// Calculate the number of GradientStop elements that are present
		NCommon::UInt32 NOXCP_GradientStops::getNumGradientStop()
		{
			return NAXCP_GradientStops_getNumGradientStop(&mHandler);
		}

		/// Create an GradientStop element at index pIndex
		/*public*/ NOXGradientStop NOXCP_GradientStops::createGradientStop(NCommon::UInt32 pIndex)
		{
			return NAXCP_GradientStops_createGradientStop(&mHandler, pIndex);
		}

		/// Delete an GradientStop element at index pIndex
		NCommon::UInt32 NOXCP_GradientStops::deleteGradientStop(NCommon::UInt32 pIndex)
		{
			return NAXCP_GradientStops_deleteGradientStop(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_GradientStops_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_GradientStops::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_GradientStops_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_GradientStops::getNumChilds()
		{
			return NAXCP_GradientStops_getNumChilds(&mHandler);
		}

};

}

#endif
