// NOXCP_LinkTargets header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_LinkTargets_h_
#define _NOXCP_LinkTargets_h_

/*! \file NOXCP_LinkTargets.h
	\brief Header file for the NOXCP_LinkTargets class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_LinkTargets_getLinkTarget(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_LinkTargets_getNumLinkTarget(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_LinkTargets_createLinkTarget(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_LinkTargets_deleteLinkTarget(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_LinkTargets_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_LinkTargets_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_LinkTargets_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_LinkTargets NOXCP_LinkTargets.h "NOXPrefix.h"
 * Class NOXCP_LinkTargets
 */
class NOXCP_LinkTargets
{
	public:
		NOXHandler mHandler;
		NOXCP_LinkTargets()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_LinkTargets(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get LinkTarget element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXLinkTarget NOXCP_LinkTargets::getLinkTarget(NCommon::UInt32 pIndex)
		{
			return NAXCP_LinkTargets_getLinkTarget(&mHandler, pIndex);
		}

		/// Calculate the number of LinkTarget elements that are present
		NCommon::UInt32 NOXCP_LinkTargets::getNumLinkTarget()
		{
			return NAXCP_LinkTargets_getNumLinkTarget(&mHandler);
		}

		/// Create an LinkTarget element at index pIndex
		/*public*/ NOXLinkTarget NOXCP_LinkTargets::createLinkTarget(NCommon::UInt32 pIndex)
		{
			return NAXCP_LinkTargets_createLinkTarget(&mHandler, pIndex);
		}

		/// Delete an LinkTarget element at index pIndex
		NCommon::UInt32 NOXCP_LinkTargets::deleteLinkTarget(NCommon::UInt32 pIndex)
		{
			return NAXCP_LinkTargets_deleteLinkTarget(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_LinkTargets_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_LinkTargets::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_LinkTargets_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_LinkTargets::getNumChilds()
		{
			return NAXCP_LinkTargets_getNumChilds(&mHandler);
		}

};

}

#endif
