// NOXCP_Outline header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_Outline_h_
#define _NOXCP_Outline_h_

/*! \file NOXCP_Outline.h
	\brief Header file for the NOXCP_Outline class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_Outline_getDocumentOutline(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Outline_getNumDocumentOutline(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Outline_createDocumentOutline(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Outline_deleteDocumentOutline(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_Outline_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Outline_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Outline_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_Outline NOXCP_Outline.h "NOXPrefix.h"
 * Class NOXCP_Outline
 */
class NOXCP_Outline
{
	public:
		NOXHandler mHandler;
		NOXCP_Outline()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_Outline(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get DocumentOutline element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXDocumentOutline NOXCP_Outline::getDocumentOutline(NCommon::UInt32 pIndex)
		{
			return NAXCP_Outline_getDocumentOutline(&mHandler, pIndex);
		}

		/// Calculate the number of DocumentOutline elements that are present
		NCommon::UInt32 NOXCP_Outline::getNumDocumentOutline()
		{
			return NAXCP_Outline_getNumDocumentOutline(&mHandler);
		}

		/// Create an DocumentOutline element at index pIndex
		/*public*/ NOXDocumentOutline NOXCP_Outline::createDocumentOutline(NCommon::UInt32 pIndex)
		{
			return NAXCP_Outline_createDocumentOutline(&mHandler, pIndex);
		}

		/// Delete an DocumentOutline element at index pIndex
		NCommon::UInt32 NOXCP_Outline::deleteDocumentOutline(NCommon::UInt32 pIndex)
		{
			return NAXCP_Outline_deleteDocumentOutline(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_Outline_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Outline::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_Outline_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_Outline::getNumChilds()
		{
			return NAXCP_Outline_getNumChilds(&mHandler);
		}

};

}

#endif
