// NOXCP_Resources header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_Resources_h_
#define _NOXCP_Resources_h_

/*! \file NOXCP_Resources.h
	\brief Header file for the NOXCP_Resources class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_Resources_getResourceDictionary(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Resources_getNumResourceDictionary(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Resources_createResourceDictionary(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Resources_deleteResourceDictionary(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_Resources_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Resources_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Resources_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_Resources NOXCP_Resources.h "NOXPrefix.h"
 * Class NOXCP_Resources
 */
class NOXCP_Resources
{
	public:
		NOXHandler mHandler;
		NOXCP_Resources()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_Resources(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ResourceDictionary element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Resources::getResourceDictionary(NCommon::UInt32 pIndex)
		{
			return NAXCP_Resources_getResourceDictionary(&mHandler, pIndex);
		}

		/// Calculate the number of ResourceDictionary elements that are present
		NCommon::UInt32 NOXCP_Resources::getNumResourceDictionary()
		{
			return NAXCP_Resources_getNumResourceDictionary(&mHandler);
		}

		/// Create an ResourceDictionary element at index pIndex
		/*public*/ NOXBase NOXCP_Resources::createResourceDictionary(NCommon::UInt32 pIndex)
		{
			return NAXCP_Resources_createResourceDictionary(&mHandler, pIndex);
		}

		/// Delete an ResourceDictionary element at index pIndex
		NCommon::UInt32 NOXCP_Resources::deleteResourceDictionary(NCommon::UInt32 pIndex)
		{
			return NAXCP_Resources_deleteResourceDictionary(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_Resources_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Resources::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_Resources_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_Resources::getNumChilds()
		{
			return NAXCP_Resources_getNumChilds(&mHandler);
		}

};

}

#endif
