// NOXCP_Transform header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_Transform_h_
#define _NOXCP_Transform_h_

/*! \file NOXCP_Transform.h
	\brief Header file for the NOXCP_Transform class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_Transform_getMatrixTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Transform_getNumMatrixTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Transform_createMatrixTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Transform_deleteMatrixTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_Transform_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Transform_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Transform_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_Transform NOXCP_Transform.h "NOXPrefix.h"
 * Class NOXCP_Transform
 */
class NOXCP_Transform
{
	public:
		NOXHandler mHandler;
		NOXCP_Transform()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_Transform(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get MatrixTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXMatrixTransform NOXCP_Transform::getMatrixTransform(NCommon::UInt32 pIndex)
		{
			return NAXCP_Transform_getMatrixTransform(&mHandler, pIndex);
		}

		/// Calculate the number of MatrixTransform elements that are present
		NCommon::UInt32 NOXCP_Transform::getNumMatrixTransform()
		{
			return NAXCP_Transform_getNumMatrixTransform(&mHandler);
		}

		/// Create an MatrixTransform element at index pIndex
		/*public*/ NOXMatrixTransform NOXCP_Transform::createMatrixTransform(NCommon::UInt32 pIndex)
		{
			return NAXCP_Transform_createMatrixTransform(&mHandler, pIndex);
		}

		/// Delete an MatrixTransform element at index pIndex
		NCommon::UInt32 NOXCP_Transform::deleteMatrixTransform(NCommon::UInt32 pIndex)
		{
			return NAXCP_Transform_deleteMatrixTransform(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_Transform_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Transform::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_Transform_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_Transform::getNumChilds()
		{
			return NAXCP_Transform_getNumChilds(&mHandler);
		}

};

}

#endif
