// NOXCP_Visual header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCP_Visual_h_
#define _NOXCP_Visual_h_

/*! \file NOXCP_Visual.h
	\brief Header file for the NOXCP_Visual class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_getPath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_getNumPath(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_createPath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_deletePath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_getGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_getNumGlyphs(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_createGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_deleteGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_getCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_getNumCanvas(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_createCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_deleteCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCP_Visual_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCP_Visual_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCP_Visual_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCP_Visual NOXCP_Visual.h "NOXPrefix.h"
 * Class NOXCP_Visual
 */
class NOXCP_Visual
{
	public:
		NOXHandler mHandler;
		NOXCP_Visual()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCP_Visual(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get Path element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Visual::getPath(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_getPath(&mHandler, pIndex);
		}

		/// Calculate the number of Path elements that are present
		NCommon::UInt32 NOXCP_Visual::getNumPath()
		{
			return NAXCP_Visual_getNumPath(&mHandler);
		}

		/// Create an Path element at index pIndex
		/*public*/ NOXBase NOXCP_Visual::createPath(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_createPath(&mHandler, pIndex);
		}

		/// Delete an Path element at index pIndex
		NCommon::UInt32 NOXCP_Visual::deletePath(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_deletePath(&mHandler, pIndex);
		}

		/// Get Glyphs element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Visual::getGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_getGlyphs(&mHandler, pIndex);
		}

		/// Calculate the number of Glyphs elements that are present
		NCommon::UInt32 NOXCP_Visual::getNumGlyphs()
		{
			return NAXCP_Visual_getNumGlyphs(&mHandler);
		}

		/// Create an Glyphs element at index pIndex
		/*public*/ NOXBase NOXCP_Visual::createGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_createGlyphs(&mHandler, pIndex);
		}

		/// Delete an Glyphs element at index pIndex
		NCommon::UInt32 NOXCP_Visual::deleteGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_deleteGlyphs(&mHandler, pIndex);
		}

		/// Get Canvas element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Visual::getCanvas(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_getCanvas(&mHandler, pIndex);
		}

		/// Calculate the number of Canvas elements that are present
		NCommon::UInt32 NOXCP_Visual::getNumCanvas()
		{
			return NAXCP_Visual_getNumCanvas(&mHandler);
		}

		/// Create an Canvas element at index pIndex
		/*public*/ NOXBase NOXCP_Visual::createCanvas(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_createCanvas(&mHandler, pIndex);
		}

		/// Delete an Canvas element at index pIndex
		NCommon::UInt32 NOXCP_Visual::deleteCanvas(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_deleteCanvas(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCP_Visual_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCP_Visual::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCP_Visual_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCP_Visual::getNumChilds()
		{
			return NAXCP_Visual_getNumChilds(&mHandler);
		}

};

}

#endif
