// NOXCanvas header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXCanvas_h_
#define _NOXCanvas_h_

/*! \file NOXCanvas.h
	\brief Header file for the NOXCanvas class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXCanvas_getCanvasResources(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumCanvasResources(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createCanvasResources(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deleteCanvasResources(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getCanvasRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumCanvasRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createCanvasRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deleteCanvasRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getCanvasClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumCanvasClip(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createCanvasClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deleteCanvasClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getCanvasOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumCanvasOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createCanvasOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deleteCanvasOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getPath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumPath(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createPath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deletePath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumGlyphs(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deleteGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumCanvas(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_createCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_deleteCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXCanvas_getRenderTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setRenderTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXCanvas_getClip(NOXHandler *pHandler, NOXRscRefAbbrGeomF *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasClip(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeClip(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setClip(NOXHandler *pHandler, NOXRscRefAbbrGeomF pObject);
DLLIMPORTEXPORT void NAXCanvas_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXCanvas_getDefaultOpacity();
DLLIMPORTEXPORT void NAXCanvas_getOpacityMask(NOXHandler *pHandler, NOXRscRef *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setOpacityMask(NOXHandler *pHandler, NOXRscRef pObject);
DLLIMPORTEXPORT void NAXCanvas_getName(NOXHandler *pHandler, NOXName *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setName(NOXHandler *pHandler, NOXName pObject);
DLLIMPORTEXPORT void NAXCanvas_getRenderOptionsEdgeMode(NOXHandler *pHandler, NOXEdgeMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasRenderOptionsEdgeMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeRenderOptionsEdgeMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setRenderOptionsEdgeMode(NOXHandler *pHandler, NOXEdgeMode pObject);
DLLIMPORTEXPORT void NAXCanvas_getFixedPageNavigateUri(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasFixedPageNavigateUri(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeFixedPageNavigateUri(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setFixedPageNavigateUri(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXCanvas_getAutomationPropertiesName(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasAutomationPropertiesName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeAutomationPropertiesName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setAutomationPropertiesName(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXCanvas_getAutomationPropertiesHelpText(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_hasAutomationPropertiesHelpText(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_removeAutomationPropertiesHelpText(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXCanvas_setAutomationPropertiesHelpText(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXCanvas_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXCanvas_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXCanvas_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXCanvas NOXCanvas.h "NOXPrefix.h"
 * Class NOXCanvas
 */
class NOXCanvas
{
	public:
		NOXHandler mHandler;
		NOXCanvas()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXCanvas(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get CanvasResources element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Resources NOXCanvas::getCanvasResources(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getCanvasResources(&mHandler, pIndex);
		}

		/// Calculate the number of CanvasResources elements that are present
		NCommon::UInt32 NOXCanvas::getNumCanvasResources()
		{
			return NAXCanvas_getNumCanvasResources(&mHandler);
		}

		/// Create an CanvasResources element at index pIndex
		/*public*/ NOXCP_Resources NOXCanvas::createCanvasResources(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createCanvasResources(&mHandler, pIndex);
		}

		/// Delete an CanvasResources element at index pIndex
		NCommon::UInt32 NOXCanvas::deleteCanvasResources(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deleteCanvasResources(&mHandler, pIndex);
		}

		/// Get CanvasRenderTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXCanvas::getCanvasRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getCanvasRenderTransform(&mHandler, pIndex);
		}

		/// Calculate the number of CanvasRenderTransform elements that are present
		NCommon::UInt32 NOXCanvas::getNumCanvasRenderTransform()
		{
			return NAXCanvas_getNumCanvasRenderTransform(&mHandler);
		}

		/// Create an CanvasRenderTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXCanvas::createCanvasRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createCanvasRenderTransform(&mHandler, pIndex);
		}

		/// Delete an CanvasRenderTransform element at index pIndex
		NCommon::UInt32 NOXCanvas::deleteCanvasRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deleteCanvasRenderTransform(&mHandler, pIndex);
		}

		/// Get CanvasClip element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Geometry NOXCanvas::getCanvasClip(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getCanvasClip(&mHandler, pIndex);
		}

		/// Calculate the number of CanvasClip elements that are present
		NCommon::UInt32 NOXCanvas::getNumCanvasClip()
		{
			return NAXCanvas_getNumCanvasClip(&mHandler);
		}

		/// Create an CanvasClip element at index pIndex
		/*public*/ NOXCP_Geometry NOXCanvas::createCanvasClip(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createCanvasClip(&mHandler, pIndex);
		}

		/// Delete an CanvasClip element at index pIndex
		NCommon::UInt32 NOXCanvas::deleteCanvasClip(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deleteCanvasClip(&mHandler, pIndex);
		}

		/// Get CanvasOpacityMask element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Brush NOXCanvas::getCanvasOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getCanvasOpacityMask(&mHandler, pIndex);
		}

		/// Calculate the number of CanvasOpacityMask elements that are present
		NCommon::UInt32 NOXCanvas::getNumCanvasOpacityMask()
		{
			return NAXCanvas_getNumCanvasOpacityMask(&mHandler);
		}

		/// Create an CanvasOpacityMask element at index pIndex
		/*public*/ NOXCP_Brush NOXCanvas::createCanvasOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createCanvasOpacityMask(&mHandler, pIndex);
		}

		/// Delete an CanvasOpacityMask element at index pIndex
		NCommon::UInt32 NOXCanvas::deleteCanvasOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deleteCanvasOpacityMask(&mHandler, pIndex);
		}

		/// Get Path element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPath NOXCanvas::getPath(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getPath(&mHandler, pIndex);
		}

		/// Calculate the number of Path elements that are present
		NCommon::UInt32 NOXCanvas::getNumPath()
		{
			return NAXCanvas_getNumPath(&mHandler);
		}

		/// Create an Path element at index pIndex
		/*public*/ NOXPath NOXCanvas::createPath(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createPath(&mHandler, pIndex);
		}

		/// Delete an Path element at index pIndex
		NCommon::UInt32 NOXCanvas::deletePath(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deletePath(&mHandler, pIndex);
		}

		/// Get Glyphs element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXGlyphs NOXCanvas::getGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getGlyphs(&mHandler, pIndex);
		}

		/// Calculate the number of Glyphs elements that are present
		NCommon::UInt32 NOXCanvas::getNumGlyphs()
		{
			return NAXCanvas_getNumGlyphs(&mHandler);
		}

		/// Create an Glyphs element at index pIndex
		/*public*/ NOXGlyphs NOXCanvas::createGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createGlyphs(&mHandler, pIndex);
		}

		/// Delete an Glyphs element at index pIndex
		NCommon::UInt32 NOXCanvas::deleteGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deleteGlyphs(&mHandler, pIndex);
		}

		/// Get Canvas element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCanvas NOXCanvas::getCanvas(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getCanvas(&mHandler, pIndex);
		}

		/// Calculate the number of Canvas elements that are present
		NCommon::UInt32 NOXCanvas::getNumCanvas()
		{
			return NAXCanvas_getNumCanvas(&mHandler);
		}

		/// Create an Canvas element at index pIndex
		/*public*/ NOXCanvas NOXCanvas::createCanvas(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_createCanvas(&mHandler, pIndex);
		}

		/// Delete an Canvas element at index pIndex
		NCommon::UInt32 NOXCanvas::deleteCanvas(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_deleteCanvas(&mHandler, pIndex);
		}

		/// Get the RenderTransform attribute
		void NOXCanvas::getRenderTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getRenderTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the RenderTransform attribute
		bool NOXCanvas::hasRenderTransform()
		{
			return (NAXCanvas_hasRenderTransform(&mHandler)!=0);
		}

		/// Removes the RenderTransform attribute
		bool NOXCanvas::removeRenderTransform()
		{
			return (NAXCanvas_removeRenderTransform(&mHandler)!=0);
		}

		/// Sets the RenderTransform attribute
		void NOXCanvas::setRenderTransform(NOXRscRefMatrix pObject)
		{
			NAXCanvas_setRenderTransform(&mHandler, pObject);
		}

		/// Get the Clip attribute
		void NOXCanvas::getClip(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getClip(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Clip attribute
		bool NOXCanvas::hasClip()
		{
			return (NAXCanvas_hasClip(&mHandler)!=0);
		}

		/// Removes the Clip attribute
		bool NOXCanvas::removeClip()
		{
			return (NAXCanvas_removeClip(&mHandler)!=0);
		}

		/// Sets the Clip attribute
		void NOXCanvas::setClip(NOXRscRefAbbrGeomF pObject)
		{
			NAXCanvas_setClip(&mHandler, pObject);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXCanvas::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXCanvas_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXCanvas::hasOpacity()
		{
			return (NAXCanvas_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXCanvas::removeOpacity()
		{
			return (NAXCanvas_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXCanvas::setOpacity(NOXZeroOne pObject)
		{
			NAXCanvas_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXCanvas::getDefaultOpacity()
		{
			return NAXCanvas_getDefaultOpacity();
		}

		/// Get the OpacityMask attribute
		void NOXCanvas::getOpacityMask(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getOpacityMask(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the OpacityMask attribute
		bool NOXCanvas::hasOpacityMask()
		{
			return (NAXCanvas_hasOpacityMask(&mHandler)!=0);
		}

		/// Removes the OpacityMask attribute
		bool NOXCanvas::removeOpacityMask()
		{
			return (NAXCanvas_removeOpacityMask(&mHandler)!=0);
		}

		/// Sets the OpacityMask attribute
		void NOXCanvas::setOpacityMask(NOXRscRef pObject)
		{
			NAXCanvas_setOpacityMask(&mHandler, pObject);
		}

		/// Get the Name attribute
		void NOXCanvas::getName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Name attribute
		bool NOXCanvas::hasName()
		{
			return (NAXCanvas_hasName(&mHandler)!=0);
		}

		/// Removes the Name attribute
		bool NOXCanvas::removeName()
		{
			return (NAXCanvas_removeName(&mHandler)!=0);
		}

		/// Sets the Name attribute
		void NOXCanvas::setName(NOXName pObject)
		{
			NAXCanvas_setName(&mHandler, pObject);
		}

		/// Get the RenderOptions.EdgeMode attribute
		NOXEdgeMode NOXCanvas::getRenderOptionsEdgeMode()
		{
			NOXEdgeMode lHandler;
			NAXCanvas_getRenderOptionsEdgeMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the RenderOptionsEdgeMode attribute
		bool NOXCanvas::hasRenderOptionsEdgeMode()
		{
			return (NAXCanvas_hasRenderOptionsEdgeMode(&mHandler)!=0);
		}

		/// Removes the RenderOptionsEdgeMode attribute
		bool NOXCanvas::removeRenderOptionsEdgeMode()
		{
			return (NAXCanvas_removeRenderOptionsEdgeMode(&mHandler)!=0);
		}

		/// Sets the RenderOptions.EdgeMode attribute
		void NOXCanvas::setRenderOptionsEdgeMode(NOXEdgeMode pObject)
		{
			NAXCanvas_setRenderOptionsEdgeMode(&mHandler, pObject);
		}

		/// Get the FixedPage.NavigateUri attribute
		void NOXCanvas::getFixedPageNavigateUri(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getFixedPageNavigateUri(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the FixedPageNavigateUri attribute
		bool NOXCanvas::hasFixedPageNavigateUri()
		{
			return (NAXCanvas_hasFixedPageNavigateUri(&mHandler)!=0);
		}

		/// Removes the FixedPageNavigateUri attribute
		bool NOXCanvas::removeFixedPageNavigateUri()
		{
			return (NAXCanvas_removeFixedPageNavigateUri(&mHandler)!=0);
		}

		/// Sets the FixedPage.NavigateUri attribute
		void NOXCanvas::setFixedPageNavigateUri(NOXUriBase pObject)
		{
			NAXCanvas_setFixedPageNavigateUri(&mHandler, pObject);
		}

		/// Get the AutomationProperties.Name attribute
		void NOXCanvas::getAutomationPropertiesName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getAutomationPropertiesName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the AutomationPropertiesName attribute
		bool NOXCanvas::hasAutomationPropertiesName()
		{
			return (NAXCanvas_hasAutomationPropertiesName(&mHandler)!=0);
		}

		/// Removes the AutomationPropertiesName attribute
		bool NOXCanvas::removeAutomationPropertiesName()
		{
			return (NAXCanvas_removeAutomationPropertiesName(&mHandler)!=0);
		}

		/// Sets the AutomationProperties.Name attribute
		void NOXCanvas::setAutomationPropertiesName(NOXStringBase pObject)
		{
			NAXCanvas_setAutomationPropertiesName(&mHandler, pObject);
		}

		/// Get the AutomationProperties.HelpText attribute
		void NOXCanvas::getAutomationPropertiesHelpText(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXCanvas_getAutomationPropertiesHelpText(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the AutomationPropertiesHelpText attribute
		bool NOXCanvas::hasAutomationPropertiesHelpText()
		{
			return (NAXCanvas_hasAutomationPropertiesHelpText(&mHandler)!=0);
		}

		/// Removes the AutomationPropertiesHelpText attribute
		bool NOXCanvas::removeAutomationPropertiesHelpText()
		{
			return (NAXCanvas_removeAutomationPropertiesHelpText(&mHandler)!=0);
		}

		/// Sets the AutomationProperties.HelpText attribute
		void NOXCanvas::setAutomationPropertiesHelpText(NOXStringBase pObject)
		{
			NAXCanvas_setAutomationPropertiesHelpText(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXCanvas_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXCanvas::getChild(NCommon::UInt32 pIndex)
		{
			return NAXCanvas_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXCanvas::getNumChilds()
		{
			return NAXCanvas_getNumChilds(&mHandler);
		}

};

}

#endif
