// NOXDocumentOutline header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXDocumentOutline_h_
#define _NOXDocumentOutline_h_

/*! \file NOXDocumentOutline.h
	\brief Header file for the NOXDocumentOutline class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXDocumentOutline_getOutlineEntry(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentOutline_getNumOutlineEntry(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXDocumentOutline_createOutlineEntry(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentOutline_deleteOutlineEntry(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXDocumentOutline_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXDocumentOutline_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentOutline_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXDocumentOutline NOXDocumentOutline.h "NOXPrefix.h"
 * Class NOXDocumentOutline
 */
class NOXDocumentOutline
{
	public:
		NOXHandler mHandler;
		NOXDocumentOutline()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXDocumentOutline(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get OutlineEntry element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXOutlineEntry NOXDocumentOutline::getOutlineEntry(NCommon::UInt32 pIndex)
		{
			return NAXDocumentOutline_getOutlineEntry(&mHandler, pIndex);
		}

		/// Calculate the number of OutlineEntry elements that are present
		NCommon::UInt32 NOXDocumentOutline::getNumOutlineEntry()
		{
			return NAXDocumentOutline_getNumOutlineEntry(&mHandler);
		}

		/// Create an OutlineEntry element at index pIndex
		/*public*/ NOXOutlineEntry NOXDocumentOutline::createOutlineEntry(NCommon::UInt32 pIndex)
		{
			return NAXDocumentOutline_createOutlineEntry(&mHandler, pIndex);
		}

		/// Delete an OutlineEntry element at index pIndex
		NCommon::UInt32 NOXDocumentOutline::deleteOutlineEntry(NCommon::UInt32 pIndex)
		{
			return NAXDocumentOutline_deleteOutlineEntry(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXDocumentOutline_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXDocumentOutline::getChild(NCommon::UInt32 pIndex)
		{
			return NAXDocumentOutline_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXDocumentOutline::getNumChilds()
		{
			return NAXDocumentOutline_getNumChilds(&mHandler);
		}

};

}

#endif
