// NOXDocumentReference header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXDocumentReference_h_
#define _NOXDocumentReference_h_

/*! \file NOXDocumentReference.h
	\brief Header file for the NOXDocumentReference class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXDocumentReference_getSource(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentReference_hasSource(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentReference_removeSource(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXDocumentReference_setSource(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXDocumentReference_intialize(NOXHandler *pHandler, NOXUriBase pSource);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXDocumentReference NOXDocumentReference.h "NOXPrefix.h"
 * Class NOXDocumentReference
 */
class NOXDocumentReference
{
	public:
		NOXHandler mHandler;
		NOXDocumentReference()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXDocumentReference(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Source attribute
		void NOXDocumentReference::getSource(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXDocumentReference_getSource(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Source attribute
		bool NOXDocumentReference::hasSource()
		{
			return (NAXDocumentReference_hasSource(&mHandler)!=0);
		}

		/// Removes the Source attribute
		bool NOXDocumentReference::removeSource()
		{
			return (NAXDocumentReference_removeSource(&mHandler)!=0);
		}

		/// Sets the Source attribute
		void NOXDocumentReference::setSource(NOXUriBase pObject)
		{
			NAXDocumentReference_setSource(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXUriBase pSource)
		{
			NAXDocumentReference_intialize(&mHandler, pSource);
		}

};

}

#endif
