// NOXDocumentStructure header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXDocumentStructure_h_
#define _NOXDocumentStructure_h_

/*! \file NOXDocumentStructure.h
	\brief Header file for the NOXDocumentStructure class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXDocumentStructure_getDocumentStructureOutline(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentStructure_getNumDocumentStructureOutline(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXDocumentStructure_createDocumentStructureOutline(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentStructure_deleteDocumentStructureOutline(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXDocumentStructure_getStory(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentStructure_getNumStory(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXDocumentStructure_createStory(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentStructure_deleteStory(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXDocumentStructure_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXDocumentStructure_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXDocumentStructure_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXDocumentStructure NOXDocumentStructure.h "NOXPrefix.h"
 * Class NOXDocumentStructure
 */
class NOXDocumentStructure
{
	public:
		NOXHandler mHandler;
		NOXDocumentStructure()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXDocumentStructure(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get DocumentStructureOutline element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Outline NOXDocumentStructure::getDocumentStructureOutline(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_getDocumentStructureOutline(&mHandler, pIndex);
		}

		/// Calculate the number of DocumentStructureOutline elements that are present
		NCommon::UInt32 NOXDocumentStructure::getNumDocumentStructureOutline()
		{
			return NAXDocumentStructure_getNumDocumentStructureOutline(&mHandler);
		}

		/// Create an DocumentStructureOutline element at index pIndex
		/*public*/ NOXCP_Outline NOXDocumentStructure::createDocumentStructureOutline(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_createDocumentStructureOutline(&mHandler, pIndex);
		}

		/// Delete an DocumentStructureOutline element at index pIndex
		NCommon::UInt32 NOXDocumentStructure::deleteDocumentStructureOutline(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_deleteDocumentStructureOutline(&mHandler, pIndex);
		}

		/// Get Story element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXStory NOXDocumentStructure::getStory(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_getStory(&mHandler, pIndex);
		}

		/// Calculate the number of Story elements that are present
		NCommon::UInt32 NOXDocumentStructure::getNumStory()
		{
			return NAXDocumentStructure_getNumStory(&mHandler);
		}

		/// Create an Story element at index pIndex
		/*public*/ NOXStory NOXDocumentStructure::createStory(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_createStory(&mHandler, pIndex);
		}

		/// Delete an Story element at index pIndex
		NCommon::UInt32 NOXDocumentStructure::deleteStory(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_deleteStory(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXDocumentStructure_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXDocumentStructure::getChild(NCommon::UInt32 pIndex)
		{
			return NAXDocumentStructure_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXDocumentStructure::getNumChilds()
		{
			return NAXDocumentStructure_getNumChilds(&mHandler);
		}

};

}

#endif
