// NOXFigure header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXFigure_h_
#define _NOXFigure_h_

/*! \file NOXFigure.h
	\brief Header file for the NOXFigure class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXFigure_getNamedElement(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFigure_getNumNamedElement(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFigure_createNamedElement(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFigure_deleteNamedElement(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXFigure_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFigure_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFigure_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXFigure NOXFigure.h "NOXPrefix.h"
 * Class NOXFigure
 */
class NOXFigure
{
	public:
		NOXHandler mHandler;
		NOXFigure()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXFigure(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get NamedElement element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXNamedElement NOXFigure::getNamedElement(NCommon::UInt32 pIndex)
		{
			return NAXFigure_getNamedElement(&mHandler, pIndex);
		}

		/// Calculate the number of NamedElement elements that are present
		NCommon::UInt32 NOXFigure::getNumNamedElement()
		{
			return NAXFigure_getNumNamedElement(&mHandler);
		}

		/// Create an NamedElement element at index pIndex
		/*public*/ NOXNamedElement NOXFigure::createNamedElement(NCommon::UInt32 pIndex)
		{
			return NAXFigure_createNamedElement(&mHandler, pIndex);
		}

		/// Delete an NamedElement element at index pIndex
		NCommon::UInt32 NOXFigure::deleteNamedElement(NCommon::UInt32 pIndex)
		{
			return NAXFigure_deleteNamedElement(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXFigure_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXFigure::getChild(NCommon::UInt32 pIndex)
		{
			return NAXFigure_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXFigure::getNumChilds()
		{
			return NAXFigure_getNumChilds(&mHandler);
		}

};

}

#endif
