// NOXFixedDocument header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXFixedDocument_h_
#define _NOXFixedDocument_h_

/*! \file NOXFixedDocument.h
	\brief Header file for the NOXFixedDocument class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXFixedDocument_getPageContent(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedDocument_getNumPageContent(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedDocument_createPageContent(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedDocument_deletePageContent(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXFixedDocument_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedDocument_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedDocument_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXFixedDocument NOXFixedDocument.h "NOXPrefix.h"
 * Class NOXFixedDocument
 */
class NOXFixedDocument
{
	public:
		NOXHandler mHandler;
		NOXFixedDocument()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXFixedDocument(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get PageContent element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPageContent NOXFixedDocument::getPageContent(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocument_getPageContent(&mHandler, pIndex);
		}

		/// Calculate the number of PageContent elements that are present
		NCommon::UInt32 NOXFixedDocument::getNumPageContent()
		{
			return NAXFixedDocument_getNumPageContent(&mHandler);
		}

		/// Create an PageContent element at index pIndex
		/*public*/ NOXPageContent NOXFixedDocument::createPageContent(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocument_createPageContent(&mHandler, pIndex);
		}

		/// Delete an PageContent element at index pIndex
		NCommon::UInt32 NOXFixedDocument::deletePageContent(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocument_deletePageContent(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXFixedDocument_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXFixedDocument::getChild(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocument_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXFixedDocument::getNumChilds()
		{
			return NAXFixedDocument_getNumChilds(&mHandler);
		}

};

}

#endif
