// NOXFixedDocumentSequence header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXFixedDocumentSequence_h_
#define _NOXFixedDocumentSequence_h_

/*! \file NOXFixedDocumentSequence.h
	\brief Header file for the NOXFixedDocumentSequence class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXFixedDocumentSequence_getDocumentReference(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedDocumentSequence_getNumDocumentReference(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedDocumentSequence_createDocumentReference(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedDocumentSequence_deleteDocumentReference(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXFixedDocumentSequence_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedDocumentSequence_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedDocumentSequence_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXFixedDocumentSequence NOXFixedDocumentSequence.h "NOXPrefix.h"
 * Class NOXFixedDocumentSequence
 */
class NOXFixedDocumentSequence
{
	public:
		NOXHandler mHandler;
		NOXFixedDocumentSequence()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXFixedDocumentSequence(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get DocumentReference element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXDocumentReference NOXFixedDocumentSequence::getDocumentReference(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocumentSequence_getDocumentReference(&mHandler, pIndex);
		}

		/// Calculate the number of DocumentReference elements that are present
		NCommon::UInt32 NOXFixedDocumentSequence::getNumDocumentReference()
		{
			return NAXFixedDocumentSequence_getNumDocumentReference(&mHandler);
		}

		/// Create an DocumentReference element at index pIndex
		/*public*/ NOXDocumentReference NOXFixedDocumentSequence::createDocumentReference(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocumentSequence_createDocumentReference(&mHandler, pIndex);
		}

		/// Delete an DocumentReference element at index pIndex
		NCommon::UInt32 NOXFixedDocumentSequence::deleteDocumentReference(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocumentSequence_deleteDocumentReference(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXFixedDocumentSequence_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXFixedDocumentSequence::getChild(NCommon::UInt32 pIndex)
		{
			return NAXFixedDocumentSequence_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXFixedDocumentSequence::getNumChilds()
		{
			return NAXFixedDocumentSequence_getNumChilds(&mHandler);
		}

};

}

#endif
