// NOXFixedPage header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXFixedPage_h_
#define _NOXFixedPage_h_

/*! \file NOXFixedPage.h
	\brief Header file for the NOXFixedPage class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXFixedPage_getFixedPageResources(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_getNumFixedPageResources(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_createFixedPageResources(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_deleteFixedPageResources(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_getPath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_getNumPath(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_createPath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_deletePath(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_getGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_getNumGlyphs(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_createGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_deleteGlyphs(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_getCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_getNumCanvas(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_createCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_deleteCanvas(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXFixedPage_getWidth(NOXHandler *pHandler, NOXGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_hasWidth(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_removeWidth(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXFixedPage_setWidth(NOXHandler *pHandler, NOXGEOne pObject);
DLLIMPORTEXPORT void NAXFixedPage_getHeight(NOXHandler *pHandler, NOXGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_hasHeight(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_removeHeight(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXFixedPage_setHeight(NOXHandler *pHandler, NOXGEOne pObject);
DLLIMPORTEXPORT void NAXFixedPage_getContentBox(NOXHandler *pHandler, NOXContentBox *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_hasContentBox(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_removeContentBox(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXFixedPage_setContentBox(NOXHandler *pHandler, NOXContentBox pObject);
DLLIMPORTEXPORT void NAXFixedPage_getBleedBox(NOXHandler *pHandler, NOXBleedBox *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_hasBleedBox(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_removeBleedBox(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXFixedPage_setBleedBox(NOXHandler *pHandler, NOXBleedBox pObject);
DLLIMPORTEXPORT void NAXFixedPage_getName(NOXHandler *pHandler, NOXName *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_hasName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_removeName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXFixedPage_setName(NOXHandler *pHandler, NOXName pObject);
DLLIMPORTEXPORT void NAXFixedPage_intialize(NOXHandler *pHandler, NOXGEOne pWidth, NOXGEOne pHeight);
DLLIMPORTEXPORT NOXHandler NAXFixedPage_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXFixedPage_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXFixedPage NOXFixedPage.h "NOXPrefix.h"
 * Class NOXFixedPage
 */
class NOXFixedPage
{
	public:
		NOXHandler mHandler;
		NOXFixedPage()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXFixedPage(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get FixedPageResources element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Resources NOXFixedPage::getFixedPageResources(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_getFixedPageResources(&mHandler, pIndex);
		}

		/// Calculate the number of FixedPageResources elements that are present
		NCommon::UInt32 NOXFixedPage::getNumFixedPageResources()
		{
			return NAXFixedPage_getNumFixedPageResources(&mHandler);
		}

		/// Create an FixedPageResources element at index pIndex
		/*public*/ NOXCP_Resources NOXFixedPage::createFixedPageResources(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_createFixedPageResources(&mHandler, pIndex);
		}

		/// Delete an FixedPageResources element at index pIndex
		NCommon::UInt32 NOXFixedPage::deleteFixedPageResources(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_deleteFixedPageResources(&mHandler, pIndex);
		}

		/// Get Path element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPath NOXFixedPage::getPath(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_getPath(&mHandler, pIndex);
		}

		/// Calculate the number of Path elements that are present
		NCommon::UInt32 NOXFixedPage::getNumPath()
		{
			return NAXFixedPage_getNumPath(&mHandler);
		}

		/// Create an Path element at index pIndex
		/*public*/ NOXPath NOXFixedPage::createPath(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_createPath(&mHandler, pIndex);
		}

		/// Delete an Path element at index pIndex
		NCommon::UInt32 NOXFixedPage::deletePath(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_deletePath(&mHandler, pIndex);
		}

		/// Get Glyphs element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXGlyphs NOXFixedPage::getGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_getGlyphs(&mHandler, pIndex);
		}

		/// Calculate the number of Glyphs elements that are present
		NCommon::UInt32 NOXFixedPage::getNumGlyphs()
		{
			return NAXFixedPage_getNumGlyphs(&mHandler);
		}

		/// Create an Glyphs element at index pIndex
		/*public*/ NOXGlyphs NOXFixedPage::createGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_createGlyphs(&mHandler, pIndex);
		}

		/// Delete an Glyphs element at index pIndex
		NCommon::UInt32 NOXFixedPage::deleteGlyphs(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_deleteGlyphs(&mHandler, pIndex);
		}

		/// Get Canvas element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCanvas NOXFixedPage::getCanvas(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_getCanvas(&mHandler, pIndex);
		}

		/// Calculate the number of Canvas elements that are present
		NCommon::UInt32 NOXFixedPage::getNumCanvas()
		{
			return NAXFixedPage_getNumCanvas(&mHandler);
		}

		/// Create an Canvas element at index pIndex
		/*public*/ NOXCanvas NOXFixedPage::createCanvas(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_createCanvas(&mHandler, pIndex);
		}

		/// Delete an Canvas element at index pIndex
		NCommon::UInt32 NOXFixedPage::deleteCanvas(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_deleteCanvas(&mHandler, pIndex);
		}

		/// Get the Width attribute
		NOXGEOne NOXFixedPage::getWidth()
		{
			NOXGEOne lHandler;
			NAXFixedPage_getWidth(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Width attribute
		bool NOXFixedPage::hasWidth()
		{
			return (NAXFixedPage_hasWidth(&mHandler)!=0);
		}

		/// Removes the Width attribute
		bool NOXFixedPage::removeWidth()
		{
			return (NAXFixedPage_removeWidth(&mHandler)!=0);
		}

		/// Sets the Width attribute
		void NOXFixedPage::setWidth(NOXGEOne pObject)
		{
			NAXFixedPage_setWidth(&mHandler, pObject);
		}

		/// Get the Height attribute
		NOXGEOne NOXFixedPage::getHeight()
		{
			NOXGEOne lHandler;
			NAXFixedPage_getHeight(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Height attribute
		bool NOXFixedPage::hasHeight()
		{
			return (NAXFixedPage_hasHeight(&mHandler)!=0);
		}

		/// Removes the Height attribute
		bool NOXFixedPage::removeHeight()
		{
			return (NAXFixedPage_removeHeight(&mHandler)!=0);
		}

		/// Sets the Height attribute
		void NOXFixedPage::setHeight(NOXGEOne pObject)
		{
			NAXFixedPage_setHeight(&mHandler, pObject);
		}

		/// Get the ContentBox attribute
		void NOXFixedPage::getContentBox(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXFixedPage_getContentBox(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the ContentBox attribute
		bool NOXFixedPage::hasContentBox()
		{
			return (NAXFixedPage_hasContentBox(&mHandler)!=0);
		}

		/// Removes the ContentBox attribute
		bool NOXFixedPage::removeContentBox()
		{
			return (NAXFixedPage_removeContentBox(&mHandler)!=0);
		}

		/// Sets the ContentBox attribute
		void NOXFixedPage::setContentBox(NOXContentBox pObject)
		{
			NAXFixedPage_setContentBox(&mHandler, pObject);
		}

		/// Get the BleedBox attribute
		void NOXFixedPage::getBleedBox(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXFixedPage_getBleedBox(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the BleedBox attribute
		bool NOXFixedPage::hasBleedBox()
		{
			return (NAXFixedPage_hasBleedBox(&mHandler)!=0);
		}

		/// Removes the BleedBox attribute
		bool NOXFixedPage::removeBleedBox()
		{
			return (NAXFixedPage_removeBleedBox(&mHandler)!=0);
		}

		/// Sets the BleedBox attribute
		void NOXFixedPage::setBleedBox(NOXBleedBox pObject)
		{
			NAXFixedPage_setBleedBox(&mHandler, pObject);
		}

		/// Get the Name attribute
		void NOXFixedPage::getName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXFixedPage_getName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Name attribute
		bool NOXFixedPage::hasName()
		{
			return (NAXFixedPage_hasName(&mHandler)!=0);
		}

		/// Removes the Name attribute
		bool NOXFixedPage::removeName()
		{
			return (NAXFixedPage_removeName(&mHandler)!=0);
		}

		/// Sets the Name attribute
		void NOXFixedPage::setName(NOXName pObject)
		{
			NAXFixedPage_setName(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXGEOne pWidth, NOXGEOne pHeight)
		{
			NAXFixedPage_intialize(&mHandler, pWidth, pHeight);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXFixedPage::getChild(NCommon::UInt32 pIndex)
		{
			return NAXFixedPage_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXFixedPage::getNumChilds()
		{
			return NAXFixedPage_getNumChilds(&mHandler);
		}

};

}

#endif
