// NOXGlyphs header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXGlyphs_h_
#define _NOXGlyphs_h_

/*! \file NOXGlyphs.h
	\brief Header file for the NOXGlyphs class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXGlyphs_getGlyphsRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_getNumGlyphsRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_createGlyphsRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_deleteGlyphsRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_getGlyphsClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_getNumGlyphsClip(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_createGlyphsClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_deleteGlyphsClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_getGlyphsOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_getNumGlyphsOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_createGlyphsOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_deleteGlyphsOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_getGlyphsFill(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_getNumGlyphsFill(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_createGlyphsFill(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_deleteGlyphsFill(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXGlyphs_getBidiLevel(NOXHandler *pHandler, NOXIntBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasBidiLevel(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeBidiLevel(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setBidiLevel(NOXHandler *pHandler, NOXIntBase pObject);
DLLIMPORTEXPORT NOXIntBase NAXGlyphs_getDefaultBidiLevel();
DLLIMPORTEXPORT void NAXGlyphs_getCaretStops(NOXHandler *pHandler, NOXCaretStops *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasCaretStops(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeCaretStops(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setCaretStops(NOXHandler *pHandler, NOXCaretStops pObject);
DLLIMPORTEXPORT void NAXGlyphs_getDeviceFontName(NOXHandler *pHandler, NOXUnicodeString *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasDeviceFontName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeDeviceFontName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setDeviceFontName(NOXHandler *pHandler, NOXUnicodeString pObject);
DLLIMPORTEXPORT void NAXGlyphs_getFill(NOXHandler *pHandler, NOXRscRefColor *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasFill(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeFill(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setFill(NOXHandler *pHandler, NOXRscRefColor pObject);
DLLIMPORTEXPORT void NAXGlyphs_getFontRenderingEmSize(NOXHandler *pHandler, NOXGEZero *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasFontRenderingEmSize(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeFontRenderingEmSize(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setFontRenderingEmSize(NOXHandler *pHandler, NOXGEZero pObject);
DLLIMPORTEXPORT void NAXGlyphs_getFontUri(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasFontUri(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeFontUri(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setFontUri(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXGlyphs_getOriginX(NOXHandler *pHandler, NOXDouble *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasOriginX(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeOriginX(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setOriginX(NOXHandler *pHandler, NOXDouble pObject);
DLLIMPORTEXPORT void NAXGlyphs_getOriginY(NOXHandler *pHandler, NOXDouble *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasOriginY(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeOriginY(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setOriginY(NOXHandler *pHandler, NOXDouble pObject);
DLLIMPORTEXPORT void NAXGlyphs_getIsSideways(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasIsSideways(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeIsSideways(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setIsSideways(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT NOXBoolean NAXGlyphs_getDefaultIsSideways();
DLLIMPORTEXPORT void NAXGlyphs_getIndices(NOXHandler *pHandler, NOXIndices *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasIndices(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeIndices(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setIndices(NOXHandler *pHandler, NOXIndices pObject);
DLLIMPORTEXPORT void NAXGlyphs_getUnicodeString(NOXHandler *pHandler, NOXUnicodeString *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasUnicodeString(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeUnicodeString(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setUnicodeString(NOXHandler *pHandler, NOXUnicodeString pObject);
DLLIMPORTEXPORT void NAXGlyphs_getStyleSimulations(NOXHandler *pHandler, NOXStyleSimulations *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasStyleSimulations(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeStyleSimulations(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setStyleSimulations(NOXHandler *pHandler, NOXStyleSimulations pObject);
DLLIMPORTEXPORT NOXStyleSimulations NAXGlyphs_getDefaultStyleSimulations();
DLLIMPORTEXPORT void NAXGlyphs_getRenderTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setRenderTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXGlyphs_getClip(NOXHandler *pHandler, NOXRscRefAbbrGeomF *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasClip(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeClip(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setClip(NOXHandler *pHandler, NOXRscRefAbbrGeomF pObject);
DLLIMPORTEXPORT void NAXGlyphs_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXGlyphs_getDefaultOpacity();
DLLIMPORTEXPORT void NAXGlyphs_getOpacityMask(NOXHandler *pHandler, NOXRscRef *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setOpacityMask(NOXHandler *pHandler, NOXRscRef pObject);
DLLIMPORTEXPORT void NAXGlyphs_getName(NOXHandler *pHandler, NOXName *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setName(NOXHandler *pHandler, NOXName pObject);
DLLIMPORTEXPORT void NAXGlyphs_getFixedPageNavigateUri(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_hasFixedPageNavigateUri(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_removeFixedPageNavigateUri(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGlyphs_setFixedPageNavigateUri(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXGlyphs_intialize(NOXHandler *pHandler, NOXGEZero pFontRenderingEmSize, NOXUriBase pFontUri, NOXDouble pOriginX, NOXDouble pOriginY);
DLLIMPORTEXPORT NOXHandler NAXGlyphs_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXGlyphs_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXGlyphs NOXGlyphs.h "NOXPrefix.h"
 * Class NOXGlyphs
 */
class NOXGlyphs
{
	public:
		NOXHandler mHandler;
		NOXGlyphs()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXGlyphs(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get GlyphsRenderTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXGlyphs::getGlyphsRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_getGlyphsRenderTransform(&mHandler, pIndex);
		}

		/// Calculate the number of GlyphsRenderTransform elements that are present
		NCommon::UInt32 NOXGlyphs::getNumGlyphsRenderTransform()
		{
			return NAXGlyphs_getNumGlyphsRenderTransform(&mHandler);
		}

		/// Create an GlyphsRenderTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXGlyphs::createGlyphsRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_createGlyphsRenderTransform(&mHandler, pIndex);
		}

		/// Delete an GlyphsRenderTransform element at index pIndex
		NCommon::UInt32 NOXGlyphs::deleteGlyphsRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_deleteGlyphsRenderTransform(&mHandler, pIndex);
		}

		/// Get GlyphsClip element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Geometry NOXGlyphs::getGlyphsClip(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_getGlyphsClip(&mHandler, pIndex);
		}

		/// Calculate the number of GlyphsClip elements that are present
		NCommon::UInt32 NOXGlyphs::getNumGlyphsClip()
		{
			return NAXGlyphs_getNumGlyphsClip(&mHandler);
		}

		/// Create an GlyphsClip element at index pIndex
		/*public*/ NOXCP_Geometry NOXGlyphs::createGlyphsClip(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_createGlyphsClip(&mHandler, pIndex);
		}

		/// Delete an GlyphsClip element at index pIndex
		NCommon::UInt32 NOXGlyphs::deleteGlyphsClip(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_deleteGlyphsClip(&mHandler, pIndex);
		}

		/// Get GlyphsOpacityMask element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Brush NOXGlyphs::getGlyphsOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_getGlyphsOpacityMask(&mHandler, pIndex);
		}

		/// Calculate the number of GlyphsOpacityMask elements that are present
		NCommon::UInt32 NOXGlyphs::getNumGlyphsOpacityMask()
		{
			return NAXGlyphs_getNumGlyphsOpacityMask(&mHandler);
		}

		/// Create an GlyphsOpacityMask element at index pIndex
		/*public*/ NOXCP_Brush NOXGlyphs::createGlyphsOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_createGlyphsOpacityMask(&mHandler, pIndex);
		}

		/// Delete an GlyphsOpacityMask element at index pIndex
		NCommon::UInt32 NOXGlyphs::deleteGlyphsOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_deleteGlyphsOpacityMask(&mHandler, pIndex);
		}

		/// Get GlyphsFill element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Brush NOXGlyphs::getGlyphsFill(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_getGlyphsFill(&mHandler, pIndex);
		}

		/// Calculate the number of GlyphsFill elements that are present
		NCommon::UInt32 NOXGlyphs::getNumGlyphsFill()
		{
			return NAXGlyphs_getNumGlyphsFill(&mHandler);
		}

		/// Create an GlyphsFill element at index pIndex
		/*public*/ NOXCP_Brush NOXGlyphs::createGlyphsFill(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_createGlyphsFill(&mHandler, pIndex);
		}

		/// Delete an GlyphsFill element at index pIndex
		NCommon::UInt32 NOXGlyphs::deleteGlyphsFill(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_deleteGlyphsFill(&mHandler, pIndex);
		}

		/// Get the BidiLevel attribute
		NOXIntBase NOXGlyphs::getBidiLevel()
		{
			NOXIntBase lHandler;
			NAXGlyphs_getBidiLevel(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the BidiLevel attribute
		bool NOXGlyphs::hasBidiLevel()
		{
			return (NAXGlyphs_hasBidiLevel(&mHandler)!=0);
		}

		/// Removes the BidiLevel attribute
		bool NOXGlyphs::removeBidiLevel()
		{
			return (NAXGlyphs_removeBidiLevel(&mHandler)!=0);
		}

		/// Sets the BidiLevel attribute
		void NOXGlyphs::setBidiLevel(NOXIntBase pObject)
		{
			NAXGlyphs_setBidiLevel(&mHandler, pObject);
		}

		/// Get the default BidiLevel
		NOXIntBase NOXGlyphs::getDefaultBidiLevel()
		{
			return NAXGlyphs_getDefaultBidiLevel();
		}

		/// Get the CaretStops attribute
		void NOXGlyphs::getCaretStops(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getCaretStops(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the CaretStops attribute
		bool NOXGlyphs::hasCaretStops()
		{
			return (NAXGlyphs_hasCaretStops(&mHandler)!=0);
		}

		/// Removes the CaretStops attribute
		bool NOXGlyphs::removeCaretStops()
		{
			return (NAXGlyphs_removeCaretStops(&mHandler)!=0);
		}

		/// Sets the CaretStops attribute
		void NOXGlyphs::setCaretStops(NOXCaretStops pObject)
		{
			NAXGlyphs_setCaretStops(&mHandler, pObject);
		}

		/// Get the DeviceFontName attribute
		void NOXGlyphs::getDeviceFontName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getDeviceFontName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the DeviceFontName attribute
		bool NOXGlyphs::hasDeviceFontName()
		{
			return (NAXGlyphs_hasDeviceFontName(&mHandler)!=0);
		}

		/// Removes the DeviceFontName attribute
		bool NOXGlyphs::removeDeviceFontName()
		{
			return (NAXGlyphs_removeDeviceFontName(&mHandler)!=0);
		}

		/// Sets the DeviceFontName attribute
		void NOXGlyphs::setDeviceFontName(NOXUnicodeString pObject)
		{
			NAXGlyphs_setDeviceFontName(&mHandler, pObject);
		}

		/// Get the Fill attribute
		void NOXGlyphs::getFill(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getFill(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Fill attribute
		bool NOXGlyphs::hasFill()
		{
			return (NAXGlyphs_hasFill(&mHandler)!=0);
		}

		/// Removes the Fill attribute
		bool NOXGlyphs::removeFill()
		{
			return (NAXGlyphs_removeFill(&mHandler)!=0);
		}

		/// Sets the Fill attribute
		void NOXGlyphs::setFill(NOXRscRefColor pObject)
		{
			NAXGlyphs_setFill(&mHandler, pObject);
		}

		/// Get the FontRenderingEmSize attribute
		NOXGEZero NOXGlyphs::getFontRenderingEmSize()
		{
			NOXGEZero lHandler;
			NAXGlyphs_getFontRenderingEmSize(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the FontRenderingEmSize attribute
		bool NOXGlyphs::hasFontRenderingEmSize()
		{
			return (NAXGlyphs_hasFontRenderingEmSize(&mHandler)!=0);
		}

		/// Removes the FontRenderingEmSize attribute
		bool NOXGlyphs::removeFontRenderingEmSize()
		{
			return (NAXGlyphs_removeFontRenderingEmSize(&mHandler)!=0);
		}

		/// Sets the FontRenderingEmSize attribute
		void NOXGlyphs::setFontRenderingEmSize(NOXGEZero pObject)
		{
			NAXGlyphs_setFontRenderingEmSize(&mHandler, pObject);
		}

		/// Get the FontUri attribute
		void NOXGlyphs::getFontUri(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getFontUri(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the FontUri attribute
		bool NOXGlyphs::hasFontUri()
		{
			return (NAXGlyphs_hasFontUri(&mHandler)!=0);
		}

		/// Removes the FontUri attribute
		bool NOXGlyphs::removeFontUri()
		{
			return (NAXGlyphs_removeFontUri(&mHandler)!=0);
		}

		/// Sets the FontUri attribute
		void NOXGlyphs::setFontUri(NOXUriBase pObject)
		{
			NAXGlyphs_setFontUri(&mHandler, pObject);
		}

		/// Get the OriginX attribute
		NOXDouble NOXGlyphs::getOriginX()
		{
			NOXDouble lHandler;
			NAXGlyphs_getOriginX(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the OriginX attribute
		bool NOXGlyphs::hasOriginX()
		{
			return (NAXGlyphs_hasOriginX(&mHandler)!=0);
		}

		/// Removes the OriginX attribute
		bool NOXGlyphs::removeOriginX()
		{
			return (NAXGlyphs_removeOriginX(&mHandler)!=0);
		}

		/// Sets the OriginX attribute
		void NOXGlyphs::setOriginX(NOXDouble pObject)
		{
			NAXGlyphs_setOriginX(&mHandler, pObject);
		}

		/// Get the OriginY attribute
		NOXDouble NOXGlyphs::getOriginY()
		{
			NOXDouble lHandler;
			NAXGlyphs_getOriginY(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the OriginY attribute
		bool NOXGlyphs::hasOriginY()
		{
			return (NAXGlyphs_hasOriginY(&mHandler)!=0);
		}

		/// Removes the OriginY attribute
		bool NOXGlyphs::removeOriginY()
		{
			return (NAXGlyphs_removeOriginY(&mHandler)!=0);
		}

		/// Sets the OriginY attribute
		void NOXGlyphs::setOriginY(NOXDouble pObject)
		{
			NAXGlyphs_setOriginY(&mHandler, pObject);
		}

		/// Get the IsSideways attribute
		NOXBoolean NOXGlyphs::getIsSideways()
		{
			NOXBoolean lHandler;
			NAXGlyphs_getIsSideways(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsSideways attribute
		bool NOXGlyphs::hasIsSideways()
		{
			return (NAXGlyphs_hasIsSideways(&mHandler)!=0);
		}

		/// Removes the IsSideways attribute
		bool NOXGlyphs::removeIsSideways()
		{
			return (NAXGlyphs_removeIsSideways(&mHandler)!=0);
		}

		/// Sets the IsSideways attribute
		void NOXGlyphs::setIsSideways(NOXBoolean pObject)
		{
			NAXGlyphs_setIsSideways(&mHandler, pObject);
		}

		/// Get the default IsSideways
		NOXBoolean NOXGlyphs::getDefaultIsSideways()
		{
			return NAXGlyphs_getDefaultIsSideways();
		}

		/// Get the Indices attribute
		void NOXGlyphs::getIndices(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getIndices(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Indices attribute
		bool NOXGlyphs::hasIndices()
		{
			return (NAXGlyphs_hasIndices(&mHandler)!=0);
		}

		/// Removes the Indices attribute
		bool NOXGlyphs::removeIndices()
		{
			return (NAXGlyphs_removeIndices(&mHandler)!=0);
		}

		/// Sets the Indices attribute
		void NOXGlyphs::setIndices(NOXIndices pObject)
		{
			NAXGlyphs_setIndices(&mHandler, pObject);
		}

		/// Get the UnicodeString attribute
		void NOXGlyphs::getUnicodeString(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getUnicodeString(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the UnicodeString attribute
		bool NOXGlyphs::hasUnicodeString()
		{
			return (NAXGlyphs_hasUnicodeString(&mHandler)!=0);
		}

		/// Removes the UnicodeString attribute
		bool NOXGlyphs::removeUnicodeString()
		{
			return (NAXGlyphs_removeUnicodeString(&mHandler)!=0);
		}

		/// Sets the UnicodeString attribute
		void NOXGlyphs::setUnicodeString(NOXUnicodeString pObject)
		{
			NAXGlyphs_setUnicodeString(&mHandler, pObject);
		}

		/// Get the StyleSimulations attribute
		NOXStyleSimulations NOXGlyphs::getStyleSimulations()
		{
			NOXStyleSimulations lHandler;
			NAXGlyphs_getStyleSimulations(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StyleSimulations attribute
		bool NOXGlyphs::hasStyleSimulations()
		{
			return (NAXGlyphs_hasStyleSimulations(&mHandler)!=0);
		}

		/// Removes the StyleSimulations attribute
		bool NOXGlyphs::removeStyleSimulations()
		{
			return (NAXGlyphs_removeStyleSimulations(&mHandler)!=0);
		}

		/// Sets the StyleSimulations attribute
		void NOXGlyphs::setStyleSimulations(NOXStyleSimulations pObject)
		{
			NAXGlyphs_setStyleSimulations(&mHandler, pObject);
		}

		/// Get the default StyleSimulations
		NOXStyleSimulations NOXGlyphs::getDefaultStyleSimulations()
		{
			return NAXGlyphs_getDefaultStyleSimulations();
		}

		/// Get the RenderTransform attribute
		void NOXGlyphs::getRenderTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getRenderTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the RenderTransform attribute
		bool NOXGlyphs::hasRenderTransform()
		{
			return (NAXGlyphs_hasRenderTransform(&mHandler)!=0);
		}

		/// Removes the RenderTransform attribute
		bool NOXGlyphs::removeRenderTransform()
		{
			return (NAXGlyphs_removeRenderTransform(&mHandler)!=0);
		}

		/// Sets the RenderTransform attribute
		void NOXGlyphs::setRenderTransform(NOXRscRefMatrix pObject)
		{
			NAXGlyphs_setRenderTransform(&mHandler, pObject);
		}

		/// Get the Clip attribute
		void NOXGlyphs::getClip(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getClip(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Clip attribute
		bool NOXGlyphs::hasClip()
		{
			return (NAXGlyphs_hasClip(&mHandler)!=0);
		}

		/// Removes the Clip attribute
		bool NOXGlyphs::removeClip()
		{
			return (NAXGlyphs_removeClip(&mHandler)!=0);
		}

		/// Sets the Clip attribute
		void NOXGlyphs::setClip(NOXRscRefAbbrGeomF pObject)
		{
			NAXGlyphs_setClip(&mHandler, pObject);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXGlyphs::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXGlyphs_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXGlyphs::hasOpacity()
		{
			return (NAXGlyphs_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXGlyphs::removeOpacity()
		{
			return (NAXGlyphs_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXGlyphs::setOpacity(NOXZeroOne pObject)
		{
			NAXGlyphs_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXGlyphs::getDefaultOpacity()
		{
			return NAXGlyphs_getDefaultOpacity();
		}

		/// Get the OpacityMask attribute
		void NOXGlyphs::getOpacityMask(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getOpacityMask(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the OpacityMask attribute
		bool NOXGlyphs::hasOpacityMask()
		{
			return (NAXGlyphs_hasOpacityMask(&mHandler)!=0);
		}

		/// Removes the OpacityMask attribute
		bool NOXGlyphs::removeOpacityMask()
		{
			return (NAXGlyphs_removeOpacityMask(&mHandler)!=0);
		}

		/// Sets the OpacityMask attribute
		void NOXGlyphs::setOpacityMask(NOXRscRef pObject)
		{
			NAXGlyphs_setOpacityMask(&mHandler, pObject);
		}

		/// Get the Name attribute
		void NOXGlyphs::getName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Name attribute
		bool NOXGlyphs::hasName()
		{
			return (NAXGlyphs_hasName(&mHandler)!=0);
		}

		/// Removes the Name attribute
		bool NOXGlyphs::removeName()
		{
			return (NAXGlyphs_removeName(&mHandler)!=0);
		}

		/// Sets the Name attribute
		void NOXGlyphs::setName(NOXName pObject)
		{
			NAXGlyphs_setName(&mHandler, pObject);
		}

		/// Get the FixedPage.NavigateUri attribute
		void NOXGlyphs::getFixedPageNavigateUri(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGlyphs_getFixedPageNavigateUri(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the FixedPageNavigateUri attribute
		bool NOXGlyphs::hasFixedPageNavigateUri()
		{
			return (NAXGlyphs_hasFixedPageNavigateUri(&mHandler)!=0);
		}

		/// Removes the FixedPageNavigateUri attribute
		bool NOXGlyphs::removeFixedPageNavigateUri()
		{
			return (NAXGlyphs_removeFixedPageNavigateUri(&mHandler)!=0);
		}

		/// Sets the FixedPage.NavigateUri attribute
		void NOXGlyphs::setFixedPageNavigateUri(NOXUriBase pObject)
		{
			NAXGlyphs_setFixedPageNavigateUri(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXGEZero pFontRenderingEmSize, NOXUriBase pFontUri, NOXDouble pOriginX, NOXDouble pOriginY)
		{
			NAXGlyphs_intialize(&mHandler, pFontRenderingEmSize, pFontUri, pOriginX, pOriginY);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXGlyphs::getChild(NCommon::UInt32 pIndex)
		{
			return NAXGlyphs_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXGlyphs::getNumChilds()
		{
			return NAXGlyphs_getNumChilds(&mHandler);
		}

};

}

#endif
