// NOXGradientStop header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXGradientStop_h_
#define _NOXGradientStop_h_

/*! \file NOXGradientStop.h
	\brief Header file for the NOXGradientStop class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXGradientStop_getColor(NOXHandler *pHandler, NOXColor *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGradientStop_hasColor(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGradientStop_removeColor(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGradientStop_setColor(NOXHandler *pHandler, NOXColor pObject);
DLLIMPORTEXPORT void NAXGradientStop_getOffset(NOXHandler *pHandler, NOXDouble *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXGradientStop_hasOffset(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXGradientStop_removeOffset(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXGradientStop_setOffset(NOXHandler *pHandler, NOXDouble pObject);
DLLIMPORTEXPORT void NAXGradientStop_intialize(NOXHandler *pHandler, NOXColor pColor, NOXDouble pOffset);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXGradientStop NOXGradientStop.h "NOXPrefix.h"
 * Class NOXGradientStop
 */
class NOXGradientStop
{
	public:
		NOXHandler mHandler;
		NOXGradientStop()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXGradientStop(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Color attribute
		void NOXGradientStop::getColor(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXGradientStop_getColor(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Color attribute
		bool NOXGradientStop::hasColor()
		{
			return (NAXGradientStop_hasColor(&mHandler)!=0);
		}

		/// Removes the Color attribute
		bool NOXGradientStop::removeColor()
		{
			return (NAXGradientStop_removeColor(&mHandler)!=0);
		}

		/// Sets the Color attribute
		void NOXGradientStop::setColor(NOXColor pObject)
		{
			NAXGradientStop_setColor(&mHandler, pObject);
		}

		/// Get the Offset attribute
		NOXDouble NOXGradientStop::getOffset()
		{
			NOXDouble lHandler;
			NAXGradientStop_getOffset(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Offset attribute
		bool NOXGradientStop::hasOffset()
		{
			return (NAXGradientStop_hasOffset(&mHandler)!=0);
		}

		/// Removes the Offset attribute
		bool NOXGradientStop::removeOffset()
		{
			return (NAXGradientStop_removeOffset(&mHandler)!=0);
		}

		/// Sets the Offset attribute
		void NOXGradientStop::setOffset(NOXDouble pObject)
		{
			NAXGradientStop_setOffset(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXColor pColor, NOXDouble pOffset)
		{
			NAXGradientStop_intialize(&mHandler, pColor, pOffset);
		}

};

}

#endif
