// NOXImageBrush header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXImageBrush_h_
#define _NOXImageBrush_h_

/*! \file NOXImageBrush.h
	\brief Header file for the NOXImageBrush class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXImageBrush_getImageBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_getNumImageBrushTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXImageBrush_createImageBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_deleteImageBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXImageBrush_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXImageBrush_getDefaultOpacity();
DLLIMPORTEXPORT void NAXImageBrush_getTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXImageBrush_getViewbox(NOXHandler *pHandler, NOXViewBox *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasViewbox(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeViewbox(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setViewbox(NOXHandler *pHandler, NOXViewBox pObject);
DLLIMPORTEXPORT void NAXImageBrush_getViewport(NOXHandler *pHandler, NOXViewBox *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasViewport(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeViewport(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setViewport(NOXHandler *pHandler, NOXViewBox pObject);
DLLIMPORTEXPORT void NAXImageBrush_getTileMode(NOXHandler *pHandler, NOXTileMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasTileMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeTileMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setTileMode(NOXHandler *pHandler, NOXTileMode pObject);
DLLIMPORTEXPORT NOXTileMode NAXImageBrush_getDefaultTileMode();
DLLIMPORTEXPORT void NAXImageBrush_getViewboxUnits(NOXHandler *pHandler, NOXViewUnits *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasViewboxUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeViewboxUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setViewboxUnits(NOXHandler *pHandler, NOXViewUnits pObject);
DLLIMPORTEXPORT void NAXImageBrush_getViewportUnits(NOXHandler *pHandler, NOXViewUnits *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasViewportUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeViewportUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setViewportUnits(NOXHandler *pHandler, NOXViewUnits pObject);
DLLIMPORTEXPORT void NAXImageBrush_getImageSource(NOXHandler *pHandler, NOXUriCtxBmp *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_hasImageSource(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_removeImageSource(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXImageBrush_setImageSource(NOXHandler *pHandler, NOXUriCtxBmp pObject);
DLLIMPORTEXPORT void NAXImageBrush_intialize(NOXHandler *pHandler, NOXViewBox pViewbox, NOXViewBox pViewport, NOXViewUnits pViewboxUnits, NOXViewUnits pViewportUnits, NOXUriCtxBmp pImageSource);
DLLIMPORTEXPORT NOXHandler NAXImageBrush_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXImageBrush_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXImageBrush NOXImageBrush.h "NOXPrefix.h"
 * Class NOXImageBrush
 */
class NOXImageBrush
{
	public:
		NOXHandler mHandler;
		NOXImageBrush()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXImageBrush(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ImageBrushTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXImageBrush::getImageBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXImageBrush_getImageBrushTransform(&mHandler, pIndex);
		}

		/// Calculate the number of ImageBrushTransform elements that are present
		NCommon::UInt32 NOXImageBrush::getNumImageBrushTransform()
		{
			return NAXImageBrush_getNumImageBrushTransform(&mHandler);
		}

		/// Create an ImageBrushTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXImageBrush::createImageBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXImageBrush_createImageBrushTransform(&mHandler, pIndex);
		}

		/// Delete an ImageBrushTransform element at index pIndex
		NCommon::UInt32 NOXImageBrush::deleteImageBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXImageBrush_deleteImageBrushTransform(&mHandler, pIndex);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXImageBrush::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXImageBrush_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXImageBrush::hasOpacity()
		{
			return (NAXImageBrush_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXImageBrush::removeOpacity()
		{
			return (NAXImageBrush_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXImageBrush::setOpacity(NOXZeroOne pObject)
		{
			NAXImageBrush_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXImageBrush::getDefaultOpacity()
		{
			return NAXImageBrush_getDefaultOpacity();
		}

		/// Get the Transform attribute
		void NOXImageBrush::getTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXImageBrush_getTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Transform attribute
		bool NOXImageBrush::hasTransform()
		{
			return (NAXImageBrush_hasTransform(&mHandler)!=0);
		}

		/// Removes the Transform attribute
		bool NOXImageBrush::removeTransform()
		{
			return (NAXImageBrush_removeTransform(&mHandler)!=0);
		}

		/// Sets the Transform attribute
		void NOXImageBrush::setTransform(NOXRscRefMatrix pObject)
		{
			NAXImageBrush_setTransform(&mHandler, pObject);
		}

		/// Get the Viewbox attribute
		void NOXImageBrush::getViewbox(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXImageBrush_getViewbox(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Viewbox attribute
		bool NOXImageBrush::hasViewbox()
		{
			return (NAXImageBrush_hasViewbox(&mHandler)!=0);
		}

		/// Removes the Viewbox attribute
		bool NOXImageBrush::removeViewbox()
		{
			return (NAXImageBrush_removeViewbox(&mHandler)!=0);
		}

		/// Sets the Viewbox attribute
		void NOXImageBrush::setViewbox(NOXViewBox pObject)
		{
			NAXImageBrush_setViewbox(&mHandler, pObject);
		}

		/// Get the Viewport attribute
		void NOXImageBrush::getViewport(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXImageBrush_getViewport(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Viewport attribute
		bool NOXImageBrush::hasViewport()
		{
			return (NAXImageBrush_hasViewport(&mHandler)!=0);
		}

		/// Removes the Viewport attribute
		bool NOXImageBrush::removeViewport()
		{
			return (NAXImageBrush_removeViewport(&mHandler)!=0);
		}

		/// Sets the Viewport attribute
		void NOXImageBrush::setViewport(NOXViewBox pObject)
		{
			NAXImageBrush_setViewport(&mHandler, pObject);
		}

		/// Get the TileMode attribute
		NOXTileMode NOXImageBrush::getTileMode()
		{
			NOXTileMode lHandler;
			NAXImageBrush_getTileMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the TileMode attribute
		bool NOXImageBrush::hasTileMode()
		{
			return (NAXImageBrush_hasTileMode(&mHandler)!=0);
		}

		/// Removes the TileMode attribute
		bool NOXImageBrush::removeTileMode()
		{
			return (NAXImageBrush_removeTileMode(&mHandler)!=0);
		}

		/// Sets the TileMode attribute
		void NOXImageBrush::setTileMode(NOXTileMode pObject)
		{
			NAXImageBrush_setTileMode(&mHandler, pObject);
		}

		/// Get the default TileMode
		NOXTileMode NOXImageBrush::getDefaultTileMode()
		{
			return NAXImageBrush_getDefaultTileMode();
		}

		/// Get the ViewboxUnits attribute
		NOXViewUnits NOXImageBrush::getViewboxUnits()
		{
			NOXViewUnits lHandler;
			NAXImageBrush_getViewboxUnits(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ViewboxUnits attribute
		bool NOXImageBrush::hasViewboxUnits()
		{
			return (NAXImageBrush_hasViewboxUnits(&mHandler)!=0);
		}

		/// Removes the ViewboxUnits attribute
		bool NOXImageBrush::removeViewboxUnits()
		{
			return (NAXImageBrush_removeViewboxUnits(&mHandler)!=0);
		}

		/// Sets the ViewboxUnits attribute
		void NOXImageBrush::setViewboxUnits(NOXViewUnits pObject)
		{
			NAXImageBrush_setViewboxUnits(&mHandler, pObject);
		}

		/// Get the ViewportUnits attribute
		NOXViewUnits NOXImageBrush::getViewportUnits()
		{
			NOXViewUnits lHandler;
			NAXImageBrush_getViewportUnits(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ViewportUnits attribute
		bool NOXImageBrush::hasViewportUnits()
		{
			return (NAXImageBrush_hasViewportUnits(&mHandler)!=0);
		}

		/// Removes the ViewportUnits attribute
		bool NOXImageBrush::removeViewportUnits()
		{
			return (NAXImageBrush_removeViewportUnits(&mHandler)!=0);
		}

		/// Sets the ViewportUnits attribute
		void NOXImageBrush::setViewportUnits(NOXViewUnits pObject)
		{
			NAXImageBrush_setViewportUnits(&mHandler, pObject);
		}

		/// Get the ImageSource attribute
		void NOXImageBrush::getImageSource(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXImageBrush_getImageSource(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the ImageSource attribute
		bool NOXImageBrush::hasImageSource()
		{
			return (NAXImageBrush_hasImageSource(&mHandler)!=0);
		}

		/// Removes the ImageSource attribute
		bool NOXImageBrush::removeImageSource()
		{
			return (NAXImageBrush_removeImageSource(&mHandler)!=0);
		}

		/// Sets the ImageSource attribute
		void NOXImageBrush::setImageSource(NOXUriCtxBmp pObject)
		{
			NAXImageBrush_setImageSource(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXViewBox pViewbox, NOXViewBox pViewport, NOXViewUnits pViewboxUnits, NOXViewUnits pViewportUnits, NOXUriCtxBmp pImageSource)
		{
			NAXImageBrush_intialize(&mHandler, pViewbox, pViewport, pViewboxUnits, pViewportUnits, pImageSource);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXImageBrush::getChild(NCommon::UInt32 pIndex)
		{
			return NAXImageBrush_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXImageBrush::getNumChilds()
		{
			return NAXImageBrush_getNumChilds(&mHandler);
		}

};

}

#endif
