// NOXLinearGradientBrush header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXLinearGradientBrush_h_
#define _NOXLinearGradientBrush_h_

/*! \file NOXLinearGradientBrush.h
	\brief Header file for the NOXLinearGradientBrush class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXLinearGradientBrush_getLinearGradientBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_getNumLinearGradientBrushTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXLinearGradientBrush_createLinearGradientBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_deleteLinearGradientBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXLinearGradientBrush_getLinearGradientBrushGradientStops(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_getNumLinearGradientBrushGradientStops(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXLinearGradientBrush_createLinearGradientBrushGradientStops(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_deleteLinearGradientBrushGradientStops(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXLinearGradientBrush_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXLinearGradientBrush_getDefaultOpacity();
DLLIMPORTEXPORT void NAXLinearGradientBrush_getColorInterpolationMode(NOXHandler *pHandler, NOXClrIntMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasColorInterpolationMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeColorInterpolationMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setColorInterpolationMode(NOXHandler *pHandler, NOXClrIntMode pObject);
DLLIMPORTEXPORT NOXClrIntMode NAXLinearGradientBrush_getDefaultColorInterpolationMode();
DLLIMPORTEXPORT void NAXLinearGradientBrush_getSpreadMethod(NOXHandler *pHandler, NOXSpreadMethod *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasSpreadMethod(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeSpreadMethod(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setSpreadMethod(NOXHandler *pHandler, NOXSpreadMethod pObject);
DLLIMPORTEXPORT NOXSpreadMethod NAXLinearGradientBrush_getDefaultSpreadMethod();
DLLIMPORTEXPORT void NAXLinearGradientBrush_getMappingMode(NOXHandler *pHandler, NOXMappingMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasMappingMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeMappingMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setMappingMode(NOXHandler *pHandler, NOXMappingMode pObject);
DLLIMPORTEXPORT void NAXLinearGradientBrush_getTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXLinearGradientBrush_getStartPoint(NOXHandler *pHandler, NOXPoint *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasStartPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeStartPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setStartPoint(NOXHandler *pHandler, NOXPoint pObject);
DLLIMPORTEXPORT void NAXLinearGradientBrush_getEndPoint(NOXHandler *pHandler, NOXPoint *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_hasEndPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_removeEndPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinearGradientBrush_setEndPoint(NOXHandler *pHandler, NOXPoint pObject);
DLLIMPORTEXPORT void NAXLinearGradientBrush_intialize(NOXHandler *pHandler, NOXMappingMode pMappingMode, NOXPoint pStartPoint, NOXPoint pEndPoint);
DLLIMPORTEXPORT NOXHandler NAXLinearGradientBrush_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinearGradientBrush_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXLinearGradientBrush NOXLinearGradientBrush.h "NOXPrefix.h"
 * Class NOXLinearGradientBrush
 */
class NOXLinearGradientBrush
{
	public:
		NOXHandler mHandler;
		NOXLinearGradientBrush()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXLinearGradientBrush(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get LinearGradientBrushTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXLinearGradientBrush::getLinearGradientBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_getLinearGradientBrushTransform(&mHandler, pIndex);
		}

		/// Calculate the number of LinearGradientBrushTransform elements that are present
		NCommon::UInt32 NOXLinearGradientBrush::getNumLinearGradientBrushTransform()
		{
			return NAXLinearGradientBrush_getNumLinearGradientBrushTransform(&mHandler);
		}

		/// Create an LinearGradientBrushTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXLinearGradientBrush::createLinearGradientBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_createLinearGradientBrushTransform(&mHandler, pIndex);
		}

		/// Delete an LinearGradientBrushTransform element at index pIndex
		NCommon::UInt32 NOXLinearGradientBrush::deleteLinearGradientBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_deleteLinearGradientBrushTransform(&mHandler, pIndex);
		}

		/// Get LinearGradientBrushGradientStops element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_GradientStops NOXLinearGradientBrush::getLinearGradientBrushGradientStops(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_getLinearGradientBrushGradientStops(&mHandler, pIndex);
		}

		/// Calculate the number of LinearGradientBrushGradientStops elements that are present
		NCommon::UInt32 NOXLinearGradientBrush::getNumLinearGradientBrushGradientStops()
		{
			return NAXLinearGradientBrush_getNumLinearGradientBrushGradientStops(&mHandler);
		}

		/// Create an LinearGradientBrushGradientStops element at index pIndex
		/*public*/ NOXCP_GradientStops NOXLinearGradientBrush::createLinearGradientBrushGradientStops(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_createLinearGradientBrushGradientStops(&mHandler, pIndex);
		}

		/// Delete an LinearGradientBrushGradientStops element at index pIndex
		NCommon::UInt32 NOXLinearGradientBrush::deleteLinearGradientBrushGradientStops(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_deleteLinearGradientBrushGradientStops(&mHandler, pIndex);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXLinearGradientBrush::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXLinearGradientBrush_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXLinearGradientBrush::hasOpacity()
		{
			return (NAXLinearGradientBrush_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXLinearGradientBrush::removeOpacity()
		{
			return (NAXLinearGradientBrush_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXLinearGradientBrush::setOpacity(NOXZeroOne pObject)
		{
			NAXLinearGradientBrush_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXLinearGradientBrush::getDefaultOpacity()
		{
			return NAXLinearGradientBrush_getDefaultOpacity();
		}

		/// Get the ColorInterpolationMode attribute
		NOXClrIntMode NOXLinearGradientBrush::getColorInterpolationMode()
		{
			NOXClrIntMode lHandler;
			NAXLinearGradientBrush_getColorInterpolationMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ColorInterpolationMode attribute
		bool NOXLinearGradientBrush::hasColorInterpolationMode()
		{
			return (NAXLinearGradientBrush_hasColorInterpolationMode(&mHandler)!=0);
		}

		/// Removes the ColorInterpolationMode attribute
		bool NOXLinearGradientBrush::removeColorInterpolationMode()
		{
			return (NAXLinearGradientBrush_removeColorInterpolationMode(&mHandler)!=0);
		}

		/// Sets the ColorInterpolationMode attribute
		void NOXLinearGradientBrush::setColorInterpolationMode(NOXClrIntMode pObject)
		{
			NAXLinearGradientBrush_setColorInterpolationMode(&mHandler, pObject);
		}

		/// Get the default ColorInterpolationMode
		NOXClrIntMode NOXLinearGradientBrush::getDefaultColorInterpolationMode()
		{
			return NAXLinearGradientBrush_getDefaultColorInterpolationMode();
		}

		/// Get the SpreadMethod attribute
		NOXSpreadMethod NOXLinearGradientBrush::getSpreadMethod()
		{
			NOXSpreadMethod lHandler;
			NAXLinearGradientBrush_getSpreadMethod(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the SpreadMethod attribute
		bool NOXLinearGradientBrush::hasSpreadMethod()
		{
			return (NAXLinearGradientBrush_hasSpreadMethod(&mHandler)!=0);
		}

		/// Removes the SpreadMethod attribute
		bool NOXLinearGradientBrush::removeSpreadMethod()
		{
			return (NAXLinearGradientBrush_removeSpreadMethod(&mHandler)!=0);
		}

		/// Sets the SpreadMethod attribute
		void NOXLinearGradientBrush::setSpreadMethod(NOXSpreadMethod pObject)
		{
			NAXLinearGradientBrush_setSpreadMethod(&mHandler, pObject);
		}

		/// Get the default SpreadMethod
		NOXSpreadMethod NOXLinearGradientBrush::getDefaultSpreadMethod()
		{
			return NAXLinearGradientBrush_getDefaultSpreadMethod();
		}

		/// Get the MappingMode attribute
		NOXMappingMode NOXLinearGradientBrush::getMappingMode()
		{
			NOXMappingMode lHandler;
			NAXLinearGradientBrush_getMappingMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the MappingMode attribute
		bool NOXLinearGradientBrush::hasMappingMode()
		{
			return (NAXLinearGradientBrush_hasMappingMode(&mHandler)!=0);
		}

		/// Removes the MappingMode attribute
		bool NOXLinearGradientBrush::removeMappingMode()
		{
			return (NAXLinearGradientBrush_removeMappingMode(&mHandler)!=0);
		}

		/// Sets the MappingMode attribute
		void NOXLinearGradientBrush::setMappingMode(NOXMappingMode pObject)
		{
			NAXLinearGradientBrush_setMappingMode(&mHandler, pObject);
		}

		/// Get the Transform attribute
		void NOXLinearGradientBrush::getTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXLinearGradientBrush_getTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Transform attribute
		bool NOXLinearGradientBrush::hasTransform()
		{
			return (NAXLinearGradientBrush_hasTransform(&mHandler)!=0);
		}

		/// Removes the Transform attribute
		bool NOXLinearGradientBrush::removeTransform()
		{
			return (NAXLinearGradientBrush_removeTransform(&mHandler)!=0);
		}

		/// Sets the Transform attribute
		void NOXLinearGradientBrush::setTransform(NOXRscRefMatrix pObject)
		{
			NAXLinearGradientBrush_setTransform(&mHandler, pObject);
		}

		/// Get the StartPoint attribute
		void NOXLinearGradientBrush::getStartPoint(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXLinearGradientBrush_getStartPoint(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the StartPoint attribute
		bool NOXLinearGradientBrush::hasStartPoint()
		{
			return (NAXLinearGradientBrush_hasStartPoint(&mHandler)!=0);
		}

		/// Removes the StartPoint attribute
		bool NOXLinearGradientBrush::removeStartPoint()
		{
			return (NAXLinearGradientBrush_removeStartPoint(&mHandler)!=0);
		}

		/// Sets the StartPoint attribute
		void NOXLinearGradientBrush::setStartPoint(NOXPoint pObject)
		{
			NAXLinearGradientBrush_setStartPoint(&mHandler, pObject);
		}

		/// Get the EndPoint attribute
		void NOXLinearGradientBrush::getEndPoint(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXLinearGradientBrush_getEndPoint(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the EndPoint attribute
		bool NOXLinearGradientBrush::hasEndPoint()
		{
			return (NAXLinearGradientBrush_hasEndPoint(&mHandler)!=0);
		}

		/// Removes the EndPoint attribute
		bool NOXLinearGradientBrush::removeEndPoint()
		{
			return (NAXLinearGradientBrush_removeEndPoint(&mHandler)!=0);
		}

		/// Sets the EndPoint attribute
		void NOXLinearGradientBrush::setEndPoint(NOXPoint pObject)
		{
			NAXLinearGradientBrush_setEndPoint(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXMappingMode pMappingMode, NOXPoint pStartPoint, NOXPoint pEndPoint)
		{
			NAXLinearGradientBrush_intialize(&mHandler, pMappingMode, pStartPoint, pEndPoint);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXLinearGradientBrush::getChild(NCommon::UInt32 pIndex)
		{
			return NAXLinearGradientBrush_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXLinearGradientBrush::getNumChilds()
		{
			return NAXLinearGradientBrush_getNumChilds(&mHandler);
		}

};

}

#endif
