// NOXLinkTarget header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXLinkTarget_h_
#define _NOXLinkTarget_h_

/*! \file NOXLinkTarget.h
	\brief Header file for the NOXLinkTarget class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXLinkTarget_getName(NOXHandler *pHandler, NOXName *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinkTarget_hasName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXLinkTarget_removeName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXLinkTarget_setName(NOXHandler *pHandler, NOXName pObject);
DLLIMPORTEXPORT void NAXLinkTarget_intialize(NOXHandler *pHandler, NOXName pName);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXLinkTarget NOXLinkTarget.h "NOXPrefix.h"
 * Class NOXLinkTarget
 */
class NOXLinkTarget
{
	public:
		NOXHandler mHandler;
		NOXLinkTarget()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXLinkTarget(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Name attribute
		void NOXLinkTarget::getName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXLinkTarget_getName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Name attribute
		bool NOXLinkTarget::hasName()
		{
			return (NAXLinkTarget_hasName(&mHandler)!=0);
		}

		/// Removes the Name attribute
		bool NOXLinkTarget::removeName()
		{
			return (NAXLinkTarget_removeName(&mHandler)!=0);
		}

		/// Sets the Name attribute
		void NOXLinkTarget::setName(NOXName pObject)
		{
			NAXLinkTarget_setName(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXName pName)
		{
			NAXLinkTarget_intialize(&mHandler, pName);
		}

};

}

#endif
