// NOXList header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXList_h_
#define _NOXList_h_

/*! \file NOXList.h
	\brief Header file for the NOXList class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXList_getListItemStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXList_getNumListItemStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXList_createListItemStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXList_deleteListItemStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXList_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXList_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXList_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXList NOXList.h "NOXPrefix.h"
 * Class NOXList
 */
class NOXList
{
	public:
		NOXHandler mHandler;
		NOXList()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXList(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ListItemStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXListItem NOXList::getListItemStructure(NCommon::UInt32 pIndex)
		{
			return NAXList_getListItemStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ListItemStructure elements that are present
		NCommon::UInt32 NOXList::getNumListItemStructure()
		{
			return NAXList_getNumListItemStructure(&mHandler);
		}

		/// Create an ListItemStructure element at index pIndex
		/*public*/ NOXListItem NOXList::createListItemStructure(NCommon::UInt32 pIndex)
		{
			return NAXList_createListItemStructure(&mHandler, pIndex);
		}

		/// Delete an ListItemStructure element at index pIndex
		NCommon::UInt32 NOXList::deleteListItemStructure(NCommon::UInt32 pIndex)
		{
			return NAXList_deleteListItemStructure(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXList_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXList::getChild(NCommon::UInt32 pIndex)
		{
			return NAXList_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXList::getNumChilds()
		{
			return NAXList_getNumChilds(&mHandler);
		}

};

}

#endif
