// NOXListItem header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXListItem_h_
#define _NOXListItem_h_

/*! \file NOXListItem.h
	\brief Header file for the NOXListItem class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXListItem_getParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_getNumParagraphStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXListItem_createParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_deleteParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXListItem_getListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_getNumListStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXListItem_createListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_deleteListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXListItem_getTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_getNumTableStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXListItem_createTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_deleteTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXListItem_getFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_getNumFigureStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXListItem_createFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_deleteFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXListItem_getMarker(NOXHandler *pHandler, NOXNameUnique *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_hasMarker(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_removeMarker(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXListItem_setMarker(NOXHandler *pHandler, NOXNameUnique pObject);
DLLIMPORTEXPORT void NAXListItem_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXListItem_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXListItem_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXListItem NOXListItem.h "NOXPrefix.h"
 * Class NOXListItem
 */
class NOXListItem
{
	public:
		NOXHandler mHandler;
		NOXListItem()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXListItem(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ParagraphStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXParagraph NOXListItem::getParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_getParagraphStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ParagraphStructure elements that are present
		NCommon::UInt32 NOXListItem::getNumParagraphStructure()
		{
			return NAXListItem_getNumParagraphStructure(&mHandler);
		}

		/// Create an ParagraphStructure element at index pIndex
		/*public*/ NOXParagraph NOXListItem::createParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_createParagraphStructure(&mHandler, pIndex);
		}

		/// Delete an ParagraphStructure element at index pIndex
		NCommon::UInt32 NOXListItem::deleteParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_deleteParagraphStructure(&mHandler, pIndex);
		}

		/// Get ListStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXList*/ NOXHandler NOXListItem::getListStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_getListStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ListStructure elements that are present
		NCommon::UInt32 NOXListItem::getNumListStructure()
		{
			return NAXListItem_getNumListStructure(&mHandler);
		}

		/// Create an ListStructure element at index pIndex
		/*public*/ /*NOXList*/ NOXHandler NOXListItem::createListStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_createListStructure(&mHandler, pIndex);
		}

		/// Delete an ListStructure element at index pIndex
		NCommon::UInt32 NOXListItem::deleteListStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_deleteListStructure(&mHandler, pIndex);
		}

		/// Get TableStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXTable*/ NOXHandler NOXListItem::getTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_getTableStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableStructure elements that are present
		NCommon::UInt32 NOXListItem::getNumTableStructure()
		{
			return NAXListItem_getNumTableStructure(&mHandler);
		}

		/// Create an TableStructure element at index pIndex
		/*public*/ /*NOXTable*/ NOXHandler NOXListItem::createTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_createTableStructure(&mHandler, pIndex);
		}

		/// Delete an TableStructure element at index pIndex
		NCommon::UInt32 NOXListItem::deleteTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_deleteTableStructure(&mHandler, pIndex);
		}

		/// Get FigureStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXFigure NOXListItem::getFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_getFigureStructure(&mHandler, pIndex);
		}

		/// Calculate the number of FigureStructure elements that are present
		NCommon::UInt32 NOXListItem::getNumFigureStructure()
		{
			return NAXListItem_getNumFigureStructure(&mHandler);
		}

		/// Create an FigureStructure element at index pIndex
		/*public*/ NOXFigure NOXListItem::createFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_createFigureStructure(&mHandler, pIndex);
		}

		/// Delete an FigureStructure element at index pIndex
		NCommon::UInt32 NOXListItem::deleteFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXListItem_deleteFigureStructure(&mHandler, pIndex);
		}

		/// Get the Marker attribute
		void NOXListItem::getMarker(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXListItem_getMarker(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Marker attribute
		bool NOXListItem::hasMarker()
		{
			return (NAXListItem_hasMarker(&mHandler)!=0);
		}

		/// Removes the Marker attribute
		bool NOXListItem::removeMarker()
		{
			return (NAXListItem_removeMarker(&mHandler)!=0);
		}

		/// Sets the Marker attribute
		void NOXListItem::setMarker(NOXNameUnique pObject)
		{
			NAXListItem_setMarker(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXListItem_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXListItem::getChild(NCommon::UInt32 pIndex)
		{
			return NAXListItem_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXListItem::getNumChilds()
		{
			return NAXListItem_getNumChilds(&mHandler);
		}

};

}

#endif
