// NOXMatrixTransform header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXMatrixTransform_h_
#define _NOXMatrixTransform_h_

/*! \file NOXMatrixTransform.h
	\brief Header file for the NOXMatrixTransform class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXMatrixTransform_getMatrix(NOXHandler *pHandler, NOXMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXMatrixTransform_hasMatrix(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXMatrixTransform_removeMatrix(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXMatrixTransform_setMatrix(NOXHandler *pHandler, NOXMatrix pObject);
DLLIMPORTEXPORT void NAXMatrixTransform_intialize(NOXHandler *pHandler, NOXMatrix pMatrix);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXMatrixTransform NOXMatrixTransform.h "NOXPrefix.h"
 * Class NOXMatrixTransform
 */
class NOXMatrixTransform
{
	public:
		NOXHandler mHandler;
		NOXMatrixTransform()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXMatrixTransform(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Matrix attribute
		void NOXMatrixTransform::getMatrix(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXMatrixTransform_getMatrix(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Matrix attribute
		bool NOXMatrixTransform::hasMatrix()
		{
			return (NAXMatrixTransform_hasMatrix(&mHandler)!=0);
		}

		/// Removes the Matrix attribute
		bool NOXMatrixTransform::removeMatrix()
		{
			return (NAXMatrixTransform_removeMatrix(&mHandler)!=0);
		}

		/// Sets the Matrix attribute
		void NOXMatrixTransform::setMatrix(NOXMatrix pObject)
		{
			NAXMatrixTransform_setMatrix(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXMatrix pMatrix)
		{
			NAXMatrixTransform_intialize(&mHandler, pMatrix);
		}

};

}

#endif
