// NOXNamedElement header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXNamedElement_h_
#define _NOXNamedElement_h_

/*! \file NOXNamedElement.h
	\brief Header file for the NOXNamedElement class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXNamedElement_getNameReference(NOXHandler *pHandler, NOXName *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXNamedElement_hasNameReference(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXNamedElement_removeNameReference(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXNamedElement_setNameReference(NOXHandler *pHandler, NOXName pObject);
DLLIMPORTEXPORT void NAXNamedElement_intialize(NOXHandler *pHandler, NOXName pNameReference);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXNamedElement NOXNamedElement.h "NOXPrefix.h"
 * Class NOXNamedElement
 */
class NOXNamedElement
{
	public:
		NOXHandler mHandler;
		NOXNamedElement()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXNamedElement(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the NameReference attribute
		void NOXNamedElement::getNameReference(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXNamedElement_getNameReference(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the NameReference attribute
		bool NOXNamedElement::hasNameReference()
		{
			return (NAXNamedElement_hasNameReference(&mHandler)!=0);
		}

		/// Removes the NameReference attribute
		bool NOXNamedElement::removeNameReference()
		{
			return (NAXNamedElement_removeNameReference(&mHandler)!=0);
		}

		/// Sets the NameReference attribute
		void NOXNamedElement::setNameReference(NOXName pObject)
		{
			NAXNamedElement_setNameReference(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXName pNameReference)
		{
			NAXNamedElement_intialize(&mHandler, pNameReference);
		}

};

}

#endif
