// NOXOutlineEntry header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXOutlineEntry_h_
#define _NOXOutlineEntry_h_

/*! \file NOXOutlineEntry.h
	\brief Header file for the NOXOutlineEntry class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXOutlineEntry_getOutlineLevel(NOXHandler *pHandler, NOXIntGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXOutlineEntry_hasOutlineLevel(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXOutlineEntry_removeOutlineLevel(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXOutlineEntry_setOutlineLevel(NOXHandler *pHandler, NOXIntGEOne pObject);
DLLIMPORTEXPORT NOXIntGEOne NAXOutlineEntry_getDefaultOutlineLevel();
DLLIMPORTEXPORT void NAXOutlineEntry_getOutlineTarget(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXOutlineEntry_hasOutlineTarget(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXOutlineEntry_removeOutlineTarget(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXOutlineEntry_setOutlineTarget(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXOutlineEntry_getDescription(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXOutlineEntry_hasDescription(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXOutlineEntry_removeDescription(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXOutlineEntry_setDescription(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXOutlineEntry_intialize(NOXHandler *pHandler, NOXUriBase pOutlineTarget, NOXStringBase pDescription);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXOutlineEntry NOXOutlineEntry.h "NOXPrefix.h"
 * Class NOXOutlineEntry
 */
class NOXOutlineEntry
{
	public:
		NOXHandler mHandler;
		NOXOutlineEntry()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXOutlineEntry(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the OutlineLevel attribute
		NOXIntGEOne NOXOutlineEntry::getOutlineLevel()
		{
			NOXIntGEOne lHandler;
			NAXOutlineEntry_getOutlineLevel(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the OutlineLevel attribute
		bool NOXOutlineEntry::hasOutlineLevel()
		{
			return (NAXOutlineEntry_hasOutlineLevel(&mHandler)!=0);
		}

		/// Removes the OutlineLevel attribute
		bool NOXOutlineEntry::removeOutlineLevel()
		{
			return (NAXOutlineEntry_removeOutlineLevel(&mHandler)!=0);
		}

		/// Sets the OutlineLevel attribute
		void NOXOutlineEntry::setOutlineLevel(NOXIntGEOne pObject)
		{
			NAXOutlineEntry_setOutlineLevel(&mHandler, pObject);
		}

		/// Get the default OutlineLevel
		NOXIntGEOne NOXOutlineEntry::getDefaultOutlineLevel()
		{
			return NAXOutlineEntry_getDefaultOutlineLevel();
		}

		/// Get the OutlineTarget attribute
		void NOXOutlineEntry::getOutlineTarget(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXOutlineEntry_getOutlineTarget(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the OutlineTarget attribute
		bool NOXOutlineEntry::hasOutlineTarget()
		{
			return (NAXOutlineEntry_hasOutlineTarget(&mHandler)!=0);
		}

		/// Removes the OutlineTarget attribute
		bool NOXOutlineEntry::removeOutlineTarget()
		{
			return (NAXOutlineEntry_removeOutlineTarget(&mHandler)!=0);
		}

		/// Sets the OutlineTarget attribute
		void NOXOutlineEntry::setOutlineTarget(NOXUriBase pObject)
		{
			NAXOutlineEntry_setOutlineTarget(&mHandler, pObject);
		}

		/// Get the Description attribute
		void NOXOutlineEntry::getDescription(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXOutlineEntry_getDescription(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Description attribute
		bool NOXOutlineEntry::hasDescription()
		{
			return (NAXOutlineEntry_hasDescription(&mHandler)!=0);
		}

		/// Removes the Description attribute
		bool NOXOutlineEntry::removeDescription()
		{
			return (NAXOutlineEntry_removeDescription(&mHandler)!=0);
		}

		/// Sets the Description attribute
		void NOXOutlineEntry::setDescription(NOXStringBase pObject)
		{
			NAXOutlineEntry_setDescription(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXUriBase pOutlineTarget, NOXStringBase pDescription)
		{
			NAXOutlineEntry_intialize(&mHandler, pOutlineTarget, pDescription);
		}

};

}

#endif
