// NOXPageContent header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXPageContent_h_
#define _NOXPageContent_h_

/*! \file NOXPageContent.h
	\brief Header file for the NOXPageContent class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXPageContent_getPageContentLinkTargets(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_getNumPageContentLinkTargets(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPageContent_createPageContentLinkTargets(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_deletePageContentLinkTargets(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXPageContent_getSource(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_hasSource(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_removeSource(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPageContent_setSource(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXPageContent_getWidth(NOXHandler *pHandler, NOXGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_hasWidth(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_removeWidth(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPageContent_setWidth(NOXHandler *pHandler, NOXGEOne pObject);
DLLIMPORTEXPORT void NAXPageContent_getHeight(NOXHandler *pHandler, NOXGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_hasHeight(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_removeHeight(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPageContent_setHeight(NOXHandler *pHandler, NOXGEOne pObject);
DLLIMPORTEXPORT void NAXPageContent_intialize(NOXHandler *pHandler, NOXUriBase pSource);
DLLIMPORTEXPORT NOXHandler NAXPageContent_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPageContent_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXPageContent NOXPageContent.h "NOXPrefix.h"
 * Class NOXPageContent
 */
class NOXPageContent
{
	public:
		NOXHandler mHandler;
		NOXPageContent()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXPageContent(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get PageContentLinkTargets element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_LinkTargets NOXPageContent::getPageContentLinkTargets(NCommon::UInt32 pIndex)
		{
			return NAXPageContent_getPageContentLinkTargets(&mHandler, pIndex);
		}

		/// Calculate the number of PageContentLinkTargets elements that are present
		NCommon::UInt32 NOXPageContent::getNumPageContentLinkTargets()
		{
			return NAXPageContent_getNumPageContentLinkTargets(&mHandler);
		}

		/// Create an PageContentLinkTargets element at index pIndex
		/*public*/ NOXCP_LinkTargets NOXPageContent::createPageContentLinkTargets(NCommon::UInt32 pIndex)
		{
			return NAXPageContent_createPageContentLinkTargets(&mHandler, pIndex);
		}

		/// Delete an PageContentLinkTargets element at index pIndex
		NCommon::UInt32 NOXPageContent::deletePageContentLinkTargets(NCommon::UInt32 pIndex)
		{
			return NAXPageContent_deletePageContentLinkTargets(&mHandler, pIndex);
		}

		/// Get the Source attribute
		void NOXPageContent::getSource(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPageContent_getSource(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Source attribute
		bool NOXPageContent::hasSource()
		{
			return (NAXPageContent_hasSource(&mHandler)!=0);
		}

		/// Removes the Source attribute
		bool NOXPageContent::removeSource()
		{
			return (NAXPageContent_removeSource(&mHandler)!=0);
		}

		/// Sets the Source attribute
		void NOXPageContent::setSource(NOXUriBase pObject)
		{
			NAXPageContent_setSource(&mHandler, pObject);
		}

		/// Get the Width attribute
		NOXGEOne NOXPageContent::getWidth()
		{
			NOXGEOne lHandler;
			NAXPageContent_getWidth(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Width attribute
		bool NOXPageContent::hasWidth()
		{
			return (NAXPageContent_hasWidth(&mHandler)!=0);
		}

		/// Removes the Width attribute
		bool NOXPageContent::removeWidth()
		{
			return (NAXPageContent_removeWidth(&mHandler)!=0);
		}

		/// Sets the Width attribute
		void NOXPageContent::setWidth(NOXGEOne pObject)
		{
			NAXPageContent_setWidth(&mHandler, pObject);
		}

		/// Get the Height attribute
		NOXGEOne NOXPageContent::getHeight()
		{
			NOXGEOne lHandler;
			NAXPageContent_getHeight(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Height attribute
		bool NOXPageContent::hasHeight()
		{
			return (NAXPageContent_hasHeight(&mHandler)!=0);
		}

		/// Removes the Height attribute
		bool NOXPageContent::removeHeight()
		{
			return (NAXPageContent_removeHeight(&mHandler)!=0);
		}

		/// Sets the Height attribute
		void NOXPageContent::setHeight(NOXGEOne pObject)
		{
			NAXPageContent_setHeight(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXUriBase pSource)
		{
			NAXPageContent_intialize(&mHandler, pSource);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXPageContent::getChild(NCommon::UInt32 pIndex)
		{
			return NAXPageContent_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXPageContent::getNumChilds()
		{
			return NAXPageContent_getNumChilds(&mHandler);
		}

};

}

#endif
