// NOXParagraph header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXParagraph_h_
#define _NOXParagraph_h_

/*! \file NOXParagraph.h
	\brief Header file for the NOXParagraph class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXParagraph_getNamedElement(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXParagraph_getNumNamedElement(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXParagraph_createNamedElement(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXParagraph_deleteNamedElement(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXParagraph_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXParagraph_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXParagraph_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXParagraph NOXParagraph.h "NOXPrefix.h"
 * Class NOXParagraph
 */
class NOXParagraph
{
	public:
		NOXHandler mHandler;
		NOXParagraph()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXParagraph(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get NamedElement element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXNamedElement NOXParagraph::getNamedElement(NCommon::UInt32 pIndex)
		{
			return NAXParagraph_getNamedElement(&mHandler, pIndex);
		}

		/// Calculate the number of NamedElement elements that are present
		NCommon::UInt32 NOXParagraph::getNumNamedElement()
		{
			return NAXParagraph_getNumNamedElement(&mHandler);
		}

		/// Create an NamedElement element at index pIndex
		/*public*/ NOXNamedElement NOXParagraph::createNamedElement(NCommon::UInt32 pIndex)
		{
			return NAXParagraph_createNamedElement(&mHandler, pIndex);
		}

		/// Delete an NamedElement element at index pIndex
		NCommon::UInt32 NOXParagraph::deleteNamedElement(NCommon::UInt32 pIndex)
		{
			return NAXParagraph_deleteNamedElement(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXParagraph_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXParagraph::getChild(NCommon::UInt32 pIndex)
		{
			return NAXParagraph_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXParagraph::getNumChilds()
		{
			return NAXParagraph_getNumChilds(&mHandler);
		}

};

}

#endif
