// NOXPath header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXPath_h_
#define _NOXPath_h_

/*! \file NOXPath.h
	\brief Header file for the NOXPath class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXPath_getPathRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumPathRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_createPathRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_deletePathRenderTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPath_getPathClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumPathClip(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_createPathClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_deletePathClip(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPath_getPathOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumPathOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_createPathOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_deletePathOpacityMask(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPath_getPathFill(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumPathFill(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_createPathFill(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_deletePathFill(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPath_getPathStroke(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumPathStroke(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_createPathStroke(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_deletePathStroke(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPath_getPathData(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumPathData(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_createPathData(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_deletePathData(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXPath_getData(NOXHandler *pHandler, NOXRscRefAbbrGeomF *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasData(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeData(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setData(NOXHandler *pHandler, NOXRscRefAbbrGeomF pObject);
DLLIMPORTEXPORT void NAXPath_getFill(NOXHandler *pHandler, NOXRscRefColor *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasFill(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeFill(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setFill(NOXHandler *pHandler, NOXRscRefColor pObject);
DLLIMPORTEXPORT void NAXPath_getRenderTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeRenderTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setRenderTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXPath_getClip(NOXHandler *pHandler, NOXRscRefAbbrGeomF *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasClip(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeClip(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setClip(NOXHandler *pHandler, NOXRscRefAbbrGeomF pObject);
DLLIMPORTEXPORT void NAXPath_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXPath_getDefaultOpacity();
DLLIMPORTEXPORT void NAXPath_getOpacityMask(NOXHandler *pHandler, NOXRscRef *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeOpacityMask(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setOpacityMask(NOXHandler *pHandler, NOXRscRef pObject);
DLLIMPORTEXPORT void NAXPath_getStroke(NOXHandler *pHandler, NOXRscRefColor *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStroke(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStroke(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStroke(NOXHandler *pHandler, NOXRscRefColor pObject);
DLLIMPORTEXPORT void NAXPath_getStrokeDashArray(NOXHandler *pHandler, NOXEvenArrayPos *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeDashArray(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeDashArray(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeDashArray(NOXHandler *pHandler, NOXEvenArrayPos pObject);
DLLIMPORTEXPORT void NAXPath_getStrokeDashCap(NOXHandler *pHandler, NOXDashCap *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeDashCap(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeDashCap(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeDashCap(NOXHandler *pHandler, NOXDashCap pObject);
DLLIMPORTEXPORT NOXDashCap NAXPath_getDefaultStrokeDashCap();
DLLIMPORTEXPORT void NAXPath_getStrokeDashOffset(NOXHandler *pHandler, NOXDouble *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeDashOffset(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeDashOffset(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeDashOffset(NOXHandler *pHandler, NOXDouble pObject);
DLLIMPORTEXPORT NOXDouble NAXPath_getDefaultStrokeDashOffset();
DLLIMPORTEXPORT void NAXPath_getStrokeEndLineCap(NOXHandler *pHandler, NOXLineCap *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeEndLineCap(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeEndLineCap(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeEndLineCap(NOXHandler *pHandler, NOXLineCap pObject);
DLLIMPORTEXPORT NOXLineCap NAXPath_getDefaultStrokeEndLineCap();
DLLIMPORTEXPORT void NAXPath_getStrokeStartLineCap(NOXHandler *pHandler, NOXLineCap *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeStartLineCap(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeStartLineCap(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeStartLineCap(NOXHandler *pHandler, NOXLineCap pObject);
DLLIMPORTEXPORT NOXLineCap NAXPath_getDefaultStrokeStartLineCap();
DLLIMPORTEXPORT void NAXPath_getStrokeLineJoin(NOXHandler *pHandler, NOXLineJoin *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeLineJoin(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeLineJoin(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeLineJoin(NOXHandler *pHandler, NOXLineJoin pObject);
DLLIMPORTEXPORT NOXLineJoin NAXPath_getDefaultStrokeLineJoin();
DLLIMPORTEXPORT void NAXPath_getStrokeMiterLimit(NOXHandler *pHandler, NOXGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeMiterLimit(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeMiterLimit(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeMiterLimit(NOXHandler *pHandler, NOXGEOne pObject);
DLLIMPORTEXPORT NOXGEOne NAXPath_getDefaultStrokeMiterLimit();
DLLIMPORTEXPORT void NAXPath_getStrokeThickness(NOXHandler *pHandler, NOXGEZero *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasStrokeThickness(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeStrokeThickness(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setStrokeThickness(NOXHandler *pHandler, NOXGEZero pObject);
DLLIMPORTEXPORT NOXGEZero NAXPath_getDefaultStrokeThickness();
DLLIMPORTEXPORT void NAXPath_getName(NOXHandler *pHandler, NOXName *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setName(NOXHandler *pHandler, NOXName pObject);
DLLIMPORTEXPORT void NAXPath_getFixedPageNavigateUri(NOXHandler *pHandler, NOXUriBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasFixedPageNavigateUri(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeFixedPageNavigateUri(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setFixedPageNavigateUri(NOXHandler *pHandler, NOXUriBase pObject);
DLLIMPORTEXPORT void NAXPath_getAutomationPropertiesName(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasAutomationPropertiesName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeAutomationPropertiesName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setAutomationPropertiesName(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXPath_getAutomationPropertiesHelpText(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasAutomationPropertiesHelpText(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeAutomationPropertiesHelpText(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setAutomationPropertiesHelpText(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXPath_getSnapsToDevicePixels(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_hasSnapsToDevicePixels(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_removeSnapsToDevicePixels(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPath_setSnapsToDevicePixels(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT void NAXPath_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPath_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPath_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXPath NOXPath.h "NOXPrefix.h"
 * Class NOXPath
 */
class NOXPath
{
	public:
		NOXHandler mHandler;
		NOXPath()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXPath(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get PathRenderTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXPath::getPathRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXPath_getPathRenderTransform(&mHandler, pIndex);
		}

		/// Calculate the number of PathRenderTransform elements that are present
		NCommon::UInt32 NOXPath::getNumPathRenderTransform()
		{
			return NAXPath_getNumPathRenderTransform(&mHandler);
		}

		/// Create an PathRenderTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXPath::createPathRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXPath_createPathRenderTransform(&mHandler, pIndex);
		}

		/// Delete an PathRenderTransform element at index pIndex
		NCommon::UInt32 NOXPath::deletePathRenderTransform(NCommon::UInt32 pIndex)
		{
			return NAXPath_deletePathRenderTransform(&mHandler, pIndex);
		}

		/// Get PathClip element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Geometry NOXPath::getPathClip(NCommon::UInt32 pIndex)
		{
			return NAXPath_getPathClip(&mHandler, pIndex);
		}

		/// Calculate the number of PathClip elements that are present
		NCommon::UInt32 NOXPath::getNumPathClip()
		{
			return NAXPath_getNumPathClip(&mHandler);
		}

		/// Create an PathClip element at index pIndex
		/*public*/ NOXCP_Geometry NOXPath::createPathClip(NCommon::UInt32 pIndex)
		{
			return NAXPath_createPathClip(&mHandler, pIndex);
		}

		/// Delete an PathClip element at index pIndex
		NCommon::UInt32 NOXPath::deletePathClip(NCommon::UInt32 pIndex)
		{
			return NAXPath_deletePathClip(&mHandler, pIndex);
		}

		/// Get PathOpacityMask element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Brush NOXPath::getPathOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXPath_getPathOpacityMask(&mHandler, pIndex);
		}

		/// Calculate the number of PathOpacityMask elements that are present
		NCommon::UInt32 NOXPath::getNumPathOpacityMask()
		{
			return NAXPath_getNumPathOpacityMask(&mHandler);
		}

		/// Create an PathOpacityMask element at index pIndex
		/*public*/ NOXCP_Brush NOXPath::createPathOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXPath_createPathOpacityMask(&mHandler, pIndex);
		}

		/// Delete an PathOpacityMask element at index pIndex
		NCommon::UInt32 NOXPath::deletePathOpacityMask(NCommon::UInt32 pIndex)
		{
			return NAXPath_deletePathOpacityMask(&mHandler, pIndex);
		}

		/// Get PathFill element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Brush NOXPath::getPathFill(NCommon::UInt32 pIndex)
		{
			return NAXPath_getPathFill(&mHandler, pIndex);
		}

		/// Calculate the number of PathFill elements that are present
		NCommon::UInt32 NOXPath::getNumPathFill()
		{
			return NAXPath_getNumPathFill(&mHandler);
		}

		/// Create an PathFill element at index pIndex
		/*public*/ NOXCP_Brush NOXPath::createPathFill(NCommon::UInt32 pIndex)
		{
			return NAXPath_createPathFill(&mHandler, pIndex);
		}

		/// Delete an PathFill element at index pIndex
		NCommon::UInt32 NOXPath::deletePathFill(NCommon::UInt32 pIndex)
		{
			return NAXPath_deletePathFill(&mHandler, pIndex);
		}

		/// Get PathStroke element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Brush NOXPath::getPathStroke(NCommon::UInt32 pIndex)
		{
			return NAXPath_getPathStroke(&mHandler, pIndex);
		}

		/// Calculate the number of PathStroke elements that are present
		NCommon::UInt32 NOXPath::getNumPathStroke()
		{
			return NAXPath_getNumPathStroke(&mHandler);
		}

		/// Create an PathStroke element at index pIndex
		/*public*/ NOXCP_Brush NOXPath::createPathStroke(NCommon::UInt32 pIndex)
		{
			return NAXPath_createPathStroke(&mHandler, pIndex);
		}

		/// Delete an PathStroke element at index pIndex
		NCommon::UInt32 NOXPath::deletePathStroke(NCommon::UInt32 pIndex)
		{
			return NAXPath_deletePathStroke(&mHandler, pIndex);
		}

		/// Get PathData element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Geometry NOXPath::getPathData(NCommon::UInt32 pIndex)
		{
			return NAXPath_getPathData(&mHandler, pIndex);
		}

		/// Calculate the number of PathData elements that are present
		NCommon::UInt32 NOXPath::getNumPathData()
		{
			return NAXPath_getNumPathData(&mHandler);
		}

		/// Create an PathData element at index pIndex
		/*public*/ NOXCP_Geometry NOXPath::createPathData(NCommon::UInt32 pIndex)
		{
			return NAXPath_createPathData(&mHandler, pIndex);
		}

		/// Delete an PathData element at index pIndex
		NCommon::UInt32 NOXPath::deletePathData(NCommon::UInt32 pIndex)
		{
			return NAXPath_deletePathData(&mHandler, pIndex);
		}

		/// Get the Data attribute
		void NOXPath::getData(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getData(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Data attribute
		bool NOXPath::hasData()
		{
			return (NAXPath_hasData(&mHandler)!=0);
		}

		/// Removes the Data attribute
		bool NOXPath::removeData()
		{
			return (NAXPath_removeData(&mHandler)!=0);
		}

		/// Sets the Data attribute
		void NOXPath::setData(NOXRscRefAbbrGeomF pObject)
		{
			NAXPath_setData(&mHandler, pObject);
		}

		/// Get the Fill attribute
		void NOXPath::getFill(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getFill(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Fill attribute
		bool NOXPath::hasFill()
		{
			return (NAXPath_hasFill(&mHandler)!=0);
		}

		/// Removes the Fill attribute
		bool NOXPath::removeFill()
		{
			return (NAXPath_removeFill(&mHandler)!=0);
		}

		/// Sets the Fill attribute
		void NOXPath::setFill(NOXRscRefColor pObject)
		{
			NAXPath_setFill(&mHandler, pObject);
		}

		/// Get the RenderTransform attribute
		void NOXPath::getRenderTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getRenderTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the RenderTransform attribute
		bool NOXPath::hasRenderTransform()
		{
			return (NAXPath_hasRenderTransform(&mHandler)!=0);
		}

		/// Removes the RenderTransform attribute
		bool NOXPath::removeRenderTransform()
		{
			return (NAXPath_removeRenderTransform(&mHandler)!=0);
		}

		/// Sets the RenderTransform attribute
		void NOXPath::setRenderTransform(NOXRscRefMatrix pObject)
		{
			NAXPath_setRenderTransform(&mHandler, pObject);
		}

		/// Get the Clip attribute
		void NOXPath::getClip(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getClip(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Clip attribute
		bool NOXPath::hasClip()
		{
			return (NAXPath_hasClip(&mHandler)!=0);
		}

		/// Removes the Clip attribute
		bool NOXPath::removeClip()
		{
			return (NAXPath_removeClip(&mHandler)!=0);
		}

		/// Sets the Clip attribute
		void NOXPath::setClip(NOXRscRefAbbrGeomF pObject)
		{
			NAXPath_setClip(&mHandler, pObject);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXPath::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXPath_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXPath::hasOpacity()
		{
			return (NAXPath_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXPath::removeOpacity()
		{
			return (NAXPath_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXPath::setOpacity(NOXZeroOne pObject)
		{
			NAXPath_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXPath::getDefaultOpacity()
		{
			return NAXPath_getDefaultOpacity();
		}

		/// Get the OpacityMask attribute
		void NOXPath::getOpacityMask(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getOpacityMask(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the OpacityMask attribute
		bool NOXPath::hasOpacityMask()
		{
			return (NAXPath_hasOpacityMask(&mHandler)!=0);
		}

		/// Removes the OpacityMask attribute
		bool NOXPath::removeOpacityMask()
		{
			return (NAXPath_removeOpacityMask(&mHandler)!=0);
		}

		/// Sets the OpacityMask attribute
		void NOXPath::setOpacityMask(NOXRscRef pObject)
		{
			NAXPath_setOpacityMask(&mHandler, pObject);
		}

		/// Get the Stroke attribute
		void NOXPath::getStroke(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getStroke(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Stroke attribute
		bool NOXPath::hasStroke()
		{
			return (NAXPath_hasStroke(&mHandler)!=0);
		}

		/// Removes the Stroke attribute
		bool NOXPath::removeStroke()
		{
			return (NAXPath_removeStroke(&mHandler)!=0);
		}

		/// Sets the Stroke attribute
		void NOXPath::setStroke(NOXRscRefColor pObject)
		{
			NAXPath_setStroke(&mHandler, pObject);
		}

		/// Get the StrokeDashArray attribute
		void NOXPath::getStrokeDashArray(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getStrokeDashArray(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the StrokeDashArray attribute
		bool NOXPath::hasStrokeDashArray()
		{
			return (NAXPath_hasStrokeDashArray(&mHandler)!=0);
		}

		/// Removes the StrokeDashArray attribute
		bool NOXPath::removeStrokeDashArray()
		{
			return (NAXPath_removeStrokeDashArray(&mHandler)!=0);
		}

		/// Sets the StrokeDashArray attribute
		void NOXPath::setStrokeDashArray(NOXEvenArrayPos pObject)
		{
			NAXPath_setStrokeDashArray(&mHandler, pObject);
		}

		/// Get the StrokeDashCap attribute
		NOXDashCap NOXPath::getStrokeDashCap()
		{
			NOXDashCap lHandler;
			NAXPath_getStrokeDashCap(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeDashCap attribute
		bool NOXPath::hasStrokeDashCap()
		{
			return (NAXPath_hasStrokeDashCap(&mHandler)!=0);
		}

		/// Removes the StrokeDashCap attribute
		bool NOXPath::removeStrokeDashCap()
		{
			return (NAXPath_removeStrokeDashCap(&mHandler)!=0);
		}

		/// Sets the StrokeDashCap attribute
		void NOXPath::setStrokeDashCap(NOXDashCap pObject)
		{
			NAXPath_setStrokeDashCap(&mHandler, pObject);
		}

		/// Get the default StrokeDashCap
		NOXDashCap NOXPath::getDefaultStrokeDashCap()
		{
			return NAXPath_getDefaultStrokeDashCap();
		}

		/// Get the StrokeDashOffset attribute
		NOXDouble NOXPath::getStrokeDashOffset()
		{
			NOXDouble lHandler;
			NAXPath_getStrokeDashOffset(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeDashOffset attribute
		bool NOXPath::hasStrokeDashOffset()
		{
			return (NAXPath_hasStrokeDashOffset(&mHandler)!=0);
		}

		/// Removes the StrokeDashOffset attribute
		bool NOXPath::removeStrokeDashOffset()
		{
			return (NAXPath_removeStrokeDashOffset(&mHandler)!=0);
		}

		/// Sets the StrokeDashOffset attribute
		void NOXPath::setStrokeDashOffset(NOXDouble pObject)
		{
			NAXPath_setStrokeDashOffset(&mHandler, pObject);
		}

		/// Get the default StrokeDashOffset
		NOXDouble NOXPath::getDefaultStrokeDashOffset()
		{
			return NAXPath_getDefaultStrokeDashOffset();
		}

		/// Get the StrokeEndLineCap attribute
		NOXLineCap NOXPath::getStrokeEndLineCap()
		{
			NOXLineCap lHandler;
			NAXPath_getStrokeEndLineCap(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeEndLineCap attribute
		bool NOXPath::hasStrokeEndLineCap()
		{
			return (NAXPath_hasStrokeEndLineCap(&mHandler)!=0);
		}

		/// Removes the StrokeEndLineCap attribute
		bool NOXPath::removeStrokeEndLineCap()
		{
			return (NAXPath_removeStrokeEndLineCap(&mHandler)!=0);
		}

		/// Sets the StrokeEndLineCap attribute
		void NOXPath::setStrokeEndLineCap(NOXLineCap pObject)
		{
			NAXPath_setStrokeEndLineCap(&mHandler, pObject);
		}

		/// Get the default StrokeEndLineCap
		NOXLineCap NOXPath::getDefaultStrokeEndLineCap()
		{
			return NAXPath_getDefaultStrokeEndLineCap();
		}

		/// Get the StrokeStartLineCap attribute
		NOXLineCap NOXPath::getStrokeStartLineCap()
		{
			NOXLineCap lHandler;
			NAXPath_getStrokeStartLineCap(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeStartLineCap attribute
		bool NOXPath::hasStrokeStartLineCap()
		{
			return (NAXPath_hasStrokeStartLineCap(&mHandler)!=0);
		}

		/// Removes the StrokeStartLineCap attribute
		bool NOXPath::removeStrokeStartLineCap()
		{
			return (NAXPath_removeStrokeStartLineCap(&mHandler)!=0);
		}

		/// Sets the StrokeStartLineCap attribute
		void NOXPath::setStrokeStartLineCap(NOXLineCap pObject)
		{
			NAXPath_setStrokeStartLineCap(&mHandler, pObject);
		}

		/// Get the default StrokeStartLineCap
		NOXLineCap NOXPath::getDefaultStrokeStartLineCap()
		{
			return NAXPath_getDefaultStrokeStartLineCap();
		}

		/// Get the StrokeLineJoin attribute
		NOXLineJoin NOXPath::getStrokeLineJoin()
		{
			NOXLineJoin lHandler;
			NAXPath_getStrokeLineJoin(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeLineJoin attribute
		bool NOXPath::hasStrokeLineJoin()
		{
			return (NAXPath_hasStrokeLineJoin(&mHandler)!=0);
		}

		/// Removes the StrokeLineJoin attribute
		bool NOXPath::removeStrokeLineJoin()
		{
			return (NAXPath_removeStrokeLineJoin(&mHandler)!=0);
		}

		/// Sets the StrokeLineJoin attribute
		void NOXPath::setStrokeLineJoin(NOXLineJoin pObject)
		{
			NAXPath_setStrokeLineJoin(&mHandler, pObject);
		}

		/// Get the default StrokeLineJoin
		NOXLineJoin NOXPath::getDefaultStrokeLineJoin()
		{
			return NAXPath_getDefaultStrokeLineJoin();
		}

		/// Get the StrokeMiterLimit attribute
		NOXGEOne NOXPath::getStrokeMiterLimit()
		{
			NOXGEOne lHandler;
			NAXPath_getStrokeMiterLimit(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeMiterLimit attribute
		bool NOXPath::hasStrokeMiterLimit()
		{
			return (NAXPath_hasStrokeMiterLimit(&mHandler)!=0);
		}

		/// Removes the StrokeMiterLimit attribute
		bool NOXPath::removeStrokeMiterLimit()
		{
			return (NAXPath_removeStrokeMiterLimit(&mHandler)!=0);
		}

		/// Sets the StrokeMiterLimit attribute
		void NOXPath::setStrokeMiterLimit(NOXGEOne pObject)
		{
			NAXPath_setStrokeMiterLimit(&mHandler, pObject);
		}

		/// Get the default StrokeMiterLimit
		NOXGEOne NOXPath::getDefaultStrokeMiterLimit()
		{
			return NAXPath_getDefaultStrokeMiterLimit();
		}

		/// Get the StrokeThickness attribute
		NOXGEZero NOXPath::getStrokeThickness()
		{
			NOXGEZero lHandler;
			NAXPath_getStrokeThickness(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the StrokeThickness attribute
		bool NOXPath::hasStrokeThickness()
		{
			return (NAXPath_hasStrokeThickness(&mHandler)!=0);
		}

		/// Removes the StrokeThickness attribute
		bool NOXPath::removeStrokeThickness()
		{
			return (NAXPath_removeStrokeThickness(&mHandler)!=0);
		}

		/// Sets the StrokeThickness attribute
		void NOXPath::setStrokeThickness(NOXGEZero pObject)
		{
			NAXPath_setStrokeThickness(&mHandler, pObject);
		}

		/// Get the default StrokeThickness
		NOXGEZero NOXPath::getDefaultStrokeThickness()
		{
			return NAXPath_getDefaultStrokeThickness();
		}

		/// Get the Name attribute
		void NOXPath::getName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Name attribute
		bool NOXPath::hasName()
		{
			return (NAXPath_hasName(&mHandler)!=0);
		}

		/// Removes the Name attribute
		bool NOXPath::removeName()
		{
			return (NAXPath_removeName(&mHandler)!=0);
		}

		/// Sets the Name attribute
		void NOXPath::setName(NOXName pObject)
		{
			NAXPath_setName(&mHandler, pObject);
		}

		/// Get the FixedPage.NavigateUri attribute
		void NOXPath::getFixedPageNavigateUri(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getFixedPageNavigateUri(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the FixedPageNavigateUri attribute
		bool NOXPath::hasFixedPageNavigateUri()
		{
			return (NAXPath_hasFixedPageNavigateUri(&mHandler)!=0);
		}

		/// Removes the FixedPageNavigateUri attribute
		bool NOXPath::removeFixedPageNavigateUri()
		{
			return (NAXPath_removeFixedPageNavigateUri(&mHandler)!=0);
		}

		/// Sets the FixedPage.NavigateUri attribute
		void NOXPath::setFixedPageNavigateUri(NOXUriBase pObject)
		{
			NAXPath_setFixedPageNavigateUri(&mHandler, pObject);
		}

		/// Get the AutomationProperties.Name attribute
		void NOXPath::getAutomationPropertiesName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getAutomationPropertiesName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the AutomationPropertiesName attribute
		bool NOXPath::hasAutomationPropertiesName()
		{
			return (NAXPath_hasAutomationPropertiesName(&mHandler)!=0);
		}

		/// Removes the AutomationPropertiesName attribute
		bool NOXPath::removeAutomationPropertiesName()
		{
			return (NAXPath_removeAutomationPropertiesName(&mHandler)!=0);
		}

		/// Sets the AutomationProperties.Name attribute
		void NOXPath::setAutomationPropertiesName(NOXStringBase pObject)
		{
			NAXPath_setAutomationPropertiesName(&mHandler, pObject);
		}

		/// Get the AutomationProperties.HelpText attribute
		void NOXPath::getAutomationPropertiesHelpText(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPath_getAutomationPropertiesHelpText(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the AutomationPropertiesHelpText attribute
		bool NOXPath::hasAutomationPropertiesHelpText()
		{
			return (NAXPath_hasAutomationPropertiesHelpText(&mHandler)!=0);
		}

		/// Removes the AutomationPropertiesHelpText attribute
		bool NOXPath::removeAutomationPropertiesHelpText()
		{
			return (NAXPath_removeAutomationPropertiesHelpText(&mHandler)!=0);
		}

		/// Sets the AutomationProperties.HelpText attribute
		void NOXPath::setAutomationPropertiesHelpText(NOXStringBase pObject)
		{
			NAXPath_setAutomationPropertiesHelpText(&mHandler, pObject);
		}

		/// Get the SnapsToDevicePixels attribute
		NOXBoolean NOXPath::getSnapsToDevicePixels()
		{
			NOXBoolean lHandler;
			NAXPath_getSnapsToDevicePixels(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the SnapsToDevicePixels attribute
		bool NOXPath::hasSnapsToDevicePixels()
		{
			return (NAXPath_hasSnapsToDevicePixels(&mHandler)!=0);
		}

		/// Removes the SnapsToDevicePixels attribute
		bool NOXPath::removeSnapsToDevicePixels()
		{
			return (NAXPath_removeSnapsToDevicePixels(&mHandler)!=0);
		}

		/// Sets the SnapsToDevicePixels attribute
		void NOXPath::setSnapsToDevicePixels(NOXBoolean pObject)
		{
			NAXPath_setSnapsToDevicePixels(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXPath_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXPath::getChild(NCommon::UInt32 pIndex)
		{
			return NAXPath_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXPath::getNumChilds()
		{
			return NAXPath_getNumChilds(&mHandler);
		}

};

}

#endif
