// NOXPathFigure header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXPathFigure_h_
#define _NOXPathFigure_h_

/*! \file NOXPathFigure.h
	\brief Header file for the NOXPathFigure class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXPathFigure_getPolyLineSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_getNumPolyLineSegment(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_createPolyLineSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_deletePolyLineSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_getPolyBezierSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_getNumPolyBezierSegment(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_createPolyBezierSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_deletePolyBezierSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_getArcSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_getNumArcSegment(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_createArcSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_deleteArcSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_getPolyQuadraticBezierSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_getNumPolyQuadraticBezierSegment(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_createPolyQuadraticBezierSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_deletePolyQuadraticBezierSegment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXPathFigure_getIsClosed(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_hasIsClosed(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_removeIsClosed(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPathFigure_setIsClosed(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT NOXBoolean NAXPathFigure_getDefaultIsClosed();
DLLIMPORTEXPORT void NAXPathFigure_getStartPoint(NOXHandler *pHandler, NOXPoint *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_hasStartPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_removeStartPoint(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPathFigure_setStartPoint(NOXHandler *pHandler, NOXPoint pObject);
DLLIMPORTEXPORT void NAXPathFigure_getIsFilled(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_hasIsFilled(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_removeIsFilled(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPathFigure_setIsFilled(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT NOXBoolean NAXPathFigure_getDefaultIsFilled();
DLLIMPORTEXPORT void NAXPathFigure_intialize(NOXHandler *pHandler, NOXPoint pStartPoint);
DLLIMPORTEXPORT NOXHandler NAXPathFigure_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXPathFigure_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXPathFigure NOXPathFigure.h "NOXPrefix.h"
 * Class NOXPathFigure
 */
class NOXPathFigure
{
	public:
		NOXHandler mHandler;
		NOXPathFigure()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXPathFigure(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get PolyLineSegment element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPolyLineSegment NOXPathFigure::getPolyLineSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_getPolyLineSegment(&mHandler, pIndex);
		}

		/// Calculate the number of PolyLineSegment elements that are present
		NCommon::UInt32 NOXPathFigure::getNumPolyLineSegment()
		{
			return NAXPathFigure_getNumPolyLineSegment(&mHandler);
		}

		/// Create an PolyLineSegment element at index pIndex
		/*public*/ NOXPolyLineSegment NOXPathFigure::createPolyLineSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_createPolyLineSegment(&mHandler, pIndex);
		}

		/// Delete an PolyLineSegment element at index pIndex
		NCommon::UInt32 NOXPathFigure::deletePolyLineSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_deletePolyLineSegment(&mHandler, pIndex);
		}

		/// Get PolyBezierSegment element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPolyBezierSegment NOXPathFigure::getPolyBezierSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_getPolyBezierSegment(&mHandler, pIndex);
		}

		/// Calculate the number of PolyBezierSegment elements that are present
		NCommon::UInt32 NOXPathFigure::getNumPolyBezierSegment()
		{
			return NAXPathFigure_getNumPolyBezierSegment(&mHandler);
		}

		/// Create an PolyBezierSegment element at index pIndex
		/*public*/ NOXPolyBezierSegment NOXPathFigure::createPolyBezierSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_createPolyBezierSegment(&mHandler, pIndex);
		}

		/// Delete an PolyBezierSegment element at index pIndex
		NCommon::UInt32 NOXPathFigure::deletePolyBezierSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_deletePolyBezierSegment(&mHandler, pIndex);
		}

		/// Get ArcSegment element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXArcSegment NOXPathFigure::getArcSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_getArcSegment(&mHandler, pIndex);
		}

		/// Calculate the number of ArcSegment elements that are present
		NCommon::UInt32 NOXPathFigure::getNumArcSegment()
		{
			return NAXPathFigure_getNumArcSegment(&mHandler);
		}

		/// Create an ArcSegment element at index pIndex
		/*public*/ NOXArcSegment NOXPathFigure::createArcSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_createArcSegment(&mHandler, pIndex);
		}

		/// Delete an ArcSegment element at index pIndex
		NCommon::UInt32 NOXPathFigure::deleteArcSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_deleteArcSegment(&mHandler, pIndex);
		}

		/// Get PolyQuadraticBezierSegment element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXPolyQuadraticBezierSegment NOXPathFigure::getPolyQuadraticBezierSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_getPolyQuadraticBezierSegment(&mHandler, pIndex);
		}

		/// Calculate the number of PolyQuadraticBezierSegment elements that are present
		NCommon::UInt32 NOXPathFigure::getNumPolyQuadraticBezierSegment()
		{
			return NAXPathFigure_getNumPolyQuadraticBezierSegment(&mHandler);
		}

		/// Create an PolyQuadraticBezierSegment element at index pIndex
		/*public*/ NOXPolyQuadraticBezierSegment NOXPathFigure::createPolyQuadraticBezierSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_createPolyQuadraticBezierSegment(&mHandler, pIndex);
		}

		/// Delete an PolyQuadraticBezierSegment element at index pIndex
		NCommon::UInt32 NOXPathFigure::deletePolyQuadraticBezierSegment(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_deletePolyQuadraticBezierSegment(&mHandler, pIndex);
		}

		/// Get the IsClosed attribute
		NOXBoolean NOXPathFigure::getIsClosed()
		{
			NOXBoolean lHandler;
			NAXPathFigure_getIsClosed(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsClosed attribute
		bool NOXPathFigure::hasIsClosed()
		{
			return (NAXPathFigure_hasIsClosed(&mHandler)!=0);
		}

		/// Removes the IsClosed attribute
		bool NOXPathFigure::removeIsClosed()
		{
			return (NAXPathFigure_removeIsClosed(&mHandler)!=0);
		}

		/// Sets the IsClosed attribute
		void NOXPathFigure::setIsClosed(NOXBoolean pObject)
		{
			NAXPathFigure_setIsClosed(&mHandler, pObject);
		}

		/// Get the default IsClosed
		NOXBoolean NOXPathFigure::getDefaultIsClosed()
		{
			return NAXPathFigure_getDefaultIsClosed();
		}

		/// Get the StartPoint attribute
		void NOXPathFigure::getStartPoint(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPathFigure_getStartPoint(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the StartPoint attribute
		bool NOXPathFigure::hasStartPoint()
		{
			return (NAXPathFigure_hasStartPoint(&mHandler)!=0);
		}

		/// Removes the StartPoint attribute
		bool NOXPathFigure::removeStartPoint()
		{
			return (NAXPathFigure_removeStartPoint(&mHandler)!=0);
		}

		/// Sets the StartPoint attribute
		void NOXPathFigure::setStartPoint(NOXPoint pObject)
		{
			NAXPathFigure_setStartPoint(&mHandler, pObject);
		}

		/// Get the IsFilled attribute
		NOXBoolean NOXPathFigure::getIsFilled()
		{
			NOXBoolean lHandler;
			NAXPathFigure_getIsFilled(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsFilled attribute
		bool NOXPathFigure::hasIsFilled()
		{
			return (NAXPathFigure_hasIsFilled(&mHandler)!=0);
		}

		/// Removes the IsFilled attribute
		bool NOXPathFigure::removeIsFilled()
		{
			return (NAXPathFigure_removeIsFilled(&mHandler)!=0);
		}

		/// Sets the IsFilled attribute
		void NOXPathFigure::setIsFilled(NOXBoolean pObject)
		{
			NAXPathFigure_setIsFilled(&mHandler, pObject);
		}

		/// Get the default IsFilled
		NOXBoolean NOXPathFigure::getDefaultIsFilled()
		{
			return NAXPathFigure_getDefaultIsFilled();
		}

		/// Initialize
		/*public*/ void intialize(NOXPoint pStartPoint)
		{
			NAXPathFigure_intialize(&mHandler, pStartPoint);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXPathFigure::getChild(NCommon::UInt32 pIndex)
		{
			return NAXPathFigure_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXPathFigure::getNumChilds()
		{
			return NAXPathFigure_getNumChilds(&mHandler);
		}

};

}

#endif
