// NOXPolyLineSegment header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXPolyLineSegment_h_
#define _NOXPolyLineSegment_h_

/*! \file NOXPolyLineSegment.h
	\brief Header file for the NOXPolyLineSegment class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXPolyLineSegment_getPoints(NOXHandler *pHandler, NOXPoints *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyLineSegment_hasPoints(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyLineSegment_removePoints(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPolyLineSegment_setPoints(NOXHandler *pHandler, NOXPoints pObject);
DLLIMPORTEXPORT void NAXPolyLineSegment_getIsStroked(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyLineSegment_hasIsStroked(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyLineSegment_removeIsStroked(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPolyLineSegment_setIsStroked(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT NOXBoolean NAXPolyLineSegment_getDefaultIsStroked();
DLLIMPORTEXPORT void NAXPolyLineSegment_intialize(NOXHandler *pHandler, NOXPoints pPoints);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXPolyLineSegment NOXPolyLineSegment.h "NOXPrefix.h"
 * Class NOXPolyLineSegment
 */
class NOXPolyLineSegment
{
	public:
		NOXHandler mHandler;
		NOXPolyLineSegment()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXPolyLineSegment(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Points attribute
		void NOXPolyLineSegment::getPoints(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPolyLineSegment_getPoints(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Points attribute
		bool NOXPolyLineSegment::hasPoints()
		{
			return (NAXPolyLineSegment_hasPoints(&mHandler)!=0);
		}

		/// Removes the Points attribute
		bool NOXPolyLineSegment::removePoints()
		{
			return (NAXPolyLineSegment_removePoints(&mHandler)!=0);
		}

		/// Sets the Points attribute
		void NOXPolyLineSegment::setPoints(NOXPoints pObject)
		{
			NAXPolyLineSegment_setPoints(&mHandler, pObject);
		}

		/// Get the IsStroked attribute
		NOXBoolean NOXPolyLineSegment::getIsStroked()
		{
			NOXBoolean lHandler;
			NAXPolyLineSegment_getIsStroked(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsStroked attribute
		bool NOXPolyLineSegment::hasIsStroked()
		{
			return (NAXPolyLineSegment_hasIsStroked(&mHandler)!=0);
		}

		/// Removes the IsStroked attribute
		bool NOXPolyLineSegment::removeIsStroked()
		{
			return (NAXPolyLineSegment_removeIsStroked(&mHandler)!=0);
		}

		/// Sets the IsStroked attribute
		void NOXPolyLineSegment::setIsStroked(NOXBoolean pObject)
		{
			NAXPolyLineSegment_setIsStroked(&mHandler, pObject);
		}

		/// Get the default IsStroked
		NOXBoolean NOXPolyLineSegment::getDefaultIsStroked()
		{
			return NAXPolyLineSegment_getDefaultIsStroked();
		}

		/// Initialize
		/*public*/ void intialize(NOXPoints pPoints)
		{
			NAXPolyLineSegment_intialize(&mHandler, pPoints);
		}

};

}

#endif
