// NOXPolyQuadraticBezierSegment header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXPolyQuadraticBezierSegment_h_
#define _NOXPolyQuadraticBezierSegment_h_

/*! \file NOXPolyQuadraticBezierSegment.h
	\brief Header file for the NOXPolyQuadraticBezierSegment class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXPolyQuadraticBezierSegment_getPoints(NOXHandler *pHandler, NOXPoints *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyQuadraticBezierSegment_hasPoints(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyQuadraticBezierSegment_removePoints(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPolyQuadraticBezierSegment_setPoints(NOXHandler *pHandler, NOXPoints pObject);
DLLIMPORTEXPORT void NAXPolyQuadraticBezierSegment_getIsStroked(NOXHandler *pHandler, NOXBoolean *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyQuadraticBezierSegment_hasIsStroked(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXPolyQuadraticBezierSegment_removeIsStroked(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXPolyQuadraticBezierSegment_setIsStroked(NOXHandler *pHandler, NOXBoolean pObject);
DLLIMPORTEXPORT NOXBoolean NAXPolyQuadraticBezierSegment_getDefaultIsStroked();
DLLIMPORTEXPORT void NAXPolyQuadraticBezierSegment_intialize(NOXHandler *pHandler, NOXPoints pPoints);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXPolyQuadraticBezierSegment NOXPolyQuadraticBezierSegment.h "NOXPrefix.h"
 * Class NOXPolyQuadraticBezierSegment
 */
class NOXPolyQuadraticBezierSegment
{
	public:
		NOXHandler mHandler;
		NOXPolyQuadraticBezierSegment()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXPolyQuadraticBezierSegment(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Points attribute
		void NOXPolyQuadraticBezierSegment::getPoints(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXPolyQuadraticBezierSegment_getPoints(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Points attribute
		bool NOXPolyQuadraticBezierSegment::hasPoints()
		{
			return (NAXPolyQuadraticBezierSegment_hasPoints(&mHandler)!=0);
		}

		/// Removes the Points attribute
		bool NOXPolyQuadraticBezierSegment::removePoints()
		{
			return (NAXPolyQuadraticBezierSegment_removePoints(&mHandler)!=0);
		}

		/// Sets the Points attribute
		void NOXPolyQuadraticBezierSegment::setPoints(NOXPoints pObject)
		{
			NAXPolyQuadraticBezierSegment_setPoints(&mHandler, pObject);
		}

		/// Get the IsStroked attribute
		NOXBoolean NOXPolyQuadraticBezierSegment::getIsStroked()
		{
			NOXBoolean lHandler;
			NAXPolyQuadraticBezierSegment_getIsStroked(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the IsStroked attribute
		bool NOXPolyQuadraticBezierSegment::hasIsStroked()
		{
			return (NAXPolyQuadraticBezierSegment_hasIsStroked(&mHandler)!=0);
		}

		/// Removes the IsStroked attribute
		bool NOXPolyQuadraticBezierSegment::removeIsStroked()
		{
			return (NAXPolyQuadraticBezierSegment_removeIsStroked(&mHandler)!=0);
		}

		/// Sets the IsStroked attribute
		void NOXPolyQuadraticBezierSegment::setIsStroked(NOXBoolean pObject)
		{
			NAXPolyQuadraticBezierSegment_setIsStroked(&mHandler, pObject);
		}

		/// Get the default IsStroked
		NOXBoolean NOXPolyQuadraticBezierSegment::getDefaultIsStroked()
		{
			return NAXPolyQuadraticBezierSegment_getDefaultIsStroked();
		}

		/// Initialize
		/*public*/ void intialize(NOXPoints pPoints)
		{
			NAXPolyQuadraticBezierSegment_intialize(&mHandler, pPoints);
		}

};

}

#endif
