// NOXRadialGradientBrush header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXRadialGradientBrush_h_
#define _NOXRadialGradientBrush_h_

/*! \file NOXRadialGradientBrush.h
	\brief Header file for the NOXRadialGradientBrush class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXRadialGradientBrush_getRadialGradientBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_getNumRadialGradientBrushTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXRadialGradientBrush_createRadialGradientBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_deleteRadialGradientBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXRadialGradientBrush_getRadialGradientBrushGradientStops(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_getNumRadialGradientBrushGradientStops(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXRadialGradientBrush_createRadialGradientBrushGradientStops(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_deleteRadialGradientBrushGradientStops(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXRadialGradientBrush_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXRadialGradientBrush_getDefaultOpacity();
DLLIMPORTEXPORT void NAXRadialGradientBrush_getColorInterpolationMode(NOXHandler *pHandler, NOXClrIntMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasColorInterpolationMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeColorInterpolationMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setColorInterpolationMode(NOXHandler *pHandler, NOXClrIntMode pObject);
DLLIMPORTEXPORT NOXClrIntMode NAXRadialGradientBrush_getDefaultColorInterpolationMode();
DLLIMPORTEXPORT void NAXRadialGradientBrush_getSpreadMethod(NOXHandler *pHandler, NOXSpreadMethod *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasSpreadMethod(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeSpreadMethod(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setSpreadMethod(NOXHandler *pHandler, NOXSpreadMethod pObject);
DLLIMPORTEXPORT NOXSpreadMethod NAXRadialGradientBrush_getDefaultSpreadMethod();
DLLIMPORTEXPORT void NAXRadialGradientBrush_getMappingMode(NOXHandler *pHandler, NOXMappingMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasMappingMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeMappingMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setMappingMode(NOXHandler *pHandler, NOXMappingMode pObject);
DLLIMPORTEXPORT void NAXRadialGradientBrush_getTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXRadialGradientBrush_getCenter(NOXHandler *pHandler, NOXPoint *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasCenter(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeCenter(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setCenter(NOXHandler *pHandler, NOXPoint pObject);
DLLIMPORTEXPORT void NAXRadialGradientBrush_getGradientOrigin(NOXHandler *pHandler, NOXPoint *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasGradientOrigin(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeGradientOrigin(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setGradientOrigin(NOXHandler *pHandler, NOXPoint pObject);
DLLIMPORTEXPORT void NAXRadialGradientBrush_getRadiusX(NOXHandler *pHandler, NOXGEZero *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasRadiusX(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeRadiusX(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setRadiusX(NOXHandler *pHandler, NOXGEZero pObject);
DLLIMPORTEXPORT void NAXRadialGradientBrush_getRadiusY(NOXHandler *pHandler, NOXGEZero *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_hasRadiusY(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_removeRadiusY(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXRadialGradientBrush_setRadiusY(NOXHandler *pHandler, NOXGEZero pObject);
DLLIMPORTEXPORT void NAXRadialGradientBrush_intialize(NOXHandler *pHandler, NOXMappingMode pMappingMode, NOXPoint pCenter, NOXPoint pGradientOrigin, NOXGEZero pRadiusX, NOXGEZero pRadiusY);
DLLIMPORTEXPORT NOXHandler NAXRadialGradientBrush_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXRadialGradientBrush_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXRadialGradientBrush NOXRadialGradientBrush.h "NOXPrefix.h"
 * Class NOXRadialGradientBrush
 */
class NOXRadialGradientBrush
{
	public:
		NOXHandler mHandler;
		NOXRadialGradientBrush()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXRadialGradientBrush(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get RadialGradientBrushTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXRadialGradientBrush::getRadialGradientBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_getRadialGradientBrushTransform(&mHandler, pIndex);
		}

		/// Calculate the number of RadialGradientBrushTransform elements that are present
		NCommon::UInt32 NOXRadialGradientBrush::getNumRadialGradientBrushTransform()
		{
			return NAXRadialGradientBrush_getNumRadialGradientBrushTransform(&mHandler);
		}

		/// Create an RadialGradientBrushTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXRadialGradientBrush::createRadialGradientBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_createRadialGradientBrushTransform(&mHandler, pIndex);
		}

		/// Delete an RadialGradientBrushTransform element at index pIndex
		NCommon::UInt32 NOXRadialGradientBrush::deleteRadialGradientBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_deleteRadialGradientBrushTransform(&mHandler, pIndex);
		}

		/// Get RadialGradientBrushGradientStops element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_GradientStops NOXRadialGradientBrush::getRadialGradientBrushGradientStops(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_getRadialGradientBrushGradientStops(&mHandler, pIndex);
		}

		/// Calculate the number of RadialGradientBrushGradientStops elements that are present
		NCommon::UInt32 NOXRadialGradientBrush::getNumRadialGradientBrushGradientStops()
		{
			return NAXRadialGradientBrush_getNumRadialGradientBrushGradientStops(&mHandler);
		}

		/// Create an RadialGradientBrushGradientStops element at index pIndex
		/*public*/ NOXCP_GradientStops NOXRadialGradientBrush::createRadialGradientBrushGradientStops(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_createRadialGradientBrushGradientStops(&mHandler, pIndex);
		}

		/// Delete an RadialGradientBrushGradientStops element at index pIndex
		NCommon::UInt32 NOXRadialGradientBrush::deleteRadialGradientBrushGradientStops(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_deleteRadialGradientBrushGradientStops(&mHandler, pIndex);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXRadialGradientBrush::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXRadialGradientBrush_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXRadialGradientBrush::hasOpacity()
		{
			return (NAXRadialGradientBrush_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXRadialGradientBrush::removeOpacity()
		{
			return (NAXRadialGradientBrush_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXRadialGradientBrush::setOpacity(NOXZeroOne pObject)
		{
			NAXRadialGradientBrush_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXRadialGradientBrush::getDefaultOpacity()
		{
			return NAXRadialGradientBrush_getDefaultOpacity();
		}

		/// Get the ColorInterpolationMode attribute
		NOXClrIntMode NOXRadialGradientBrush::getColorInterpolationMode()
		{
			NOXClrIntMode lHandler;
			NAXRadialGradientBrush_getColorInterpolationMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ColorInterpolationMode attribute
		bool NOXRadialGradientBrush::hasColorInterpolationMode()
		{
			return (NAXRadialGradientBrush_hasColorInterpolationMode(&mHandler)!=0);
		}

		/// Removes the ColorInterpolationMode attribute
		bool NOXRadialGradientBrush::removeColorInterpolationMode()
		{
			return (NAXRadialGradientBrush_removeColorInterpolationMode(&mHandler)!=0);
		}

		/// Sets the ColorInterpolationMode attribute
		void NOXRadialGradientBrush::setColorInterpolationMode(NOXClrIntMode pObject)
		{
			NAXRadialGradientBrush_setColorInterpolationMode(&mHandler, pObject);
		}

		/// Get the default ColorInterpolationMode
		NOXClrIntMode NOXRadialGradientBrush::getDefaultColorInterpolationMode()
		{
			return NAXRadialGradientBrush_getDefaultColorInterpolationMode();
		}

		/// Get the SpreadMethod attribute
		NOXSpreadMethod NOXRadialGradientBrush::getSpreadMethod()
		{
			NOXSpreadMethod lHandler;
			NAXRadialGradientBrush_getSpreadMethod(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the SpreadMethod attribute
		bool NOXRadialGradientBrush::hasSpreadMethod()
		{
			return (NAXRadialGradientBrush_hasSpreadMethod(&mHandler)!=0);
		}

		/// Removes the SpreadMethod attribute
		bool NOXRadialGradientBrush::removeSpreadMethod()
		{
			return (NAXRadialGradientBrush_removeSpreadMethod(&mHandler)!=0);
		}

		/// Sets the SpreadMethod attribute
		void NOXRadialGradientBrush::setSpreadMethod(NOXSpreadMethod pObject)
		{
			NAXRadialGradientBrush_setSpreadMethod(&mHandler, pObject);
		}

		/// Get the default SpreadMethod
		NOXSpreadMethod NOXRadialGradientBrush::getDefaultSpreadMethod()
		{
			return NAXRadialGradientBrush_getDefaultSpreadMethod();
		}

		/// Get the MappingMode attribute
		NOXMappingMode NOXRadialGradientBrush::getMappingMode()
		{
			NOXMappingMode lHandler;
			NAXRadialGradientBrush_getMappingMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the MappingMode attribute
		bool NOXRadialGradientBrush::hasMappingMode()
		{
			return (NAXRadialGradientBrush_hasMappingMode(&mHandler)!=0);
		}

		/// Removes the MappingMode attribute
		bool NOXRadialGradientBrush::removeMappingMode()
		{
			return (NAXRadialGradientBrush_removeMappingMode(&mHandler)!=0);
		}

		/// Sets the MappingMode attribute
		void NOXRadialGradientBrush::setMappingMode(NOXMappingMode pObject)
		{
			NAXRadialGradientBrush_setMappingMode(&mHandler, pObject);
		}

		/// Get the Transform attribute
		void NOXRadialGradientBrush::getTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXRadialGradientBrush_getTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Transform attribute
		bool NOXRadialGradientBrush::hasTransform()
		{
			return (NAXRadialGradientBrush_hasTransform(&mHandler)!=0);
		}

		/// Removes the Transform attribute
		bool NOXRadialGradientBrush::removeTransform()
		{
			return (NAXRadialGradientBrush_removeTransform(&mHandler)!=0);
		}

		/// Sets the Transform attribute
		void NOXRadialGradientBrush::setTransform(NOXRscRefMatrix pObject)
		{
			NAXRadialGradientBrush_setTransform(&mHandler, pObject);
		}

		/// Get the Center attribute
		void NOXRadialGradientBrush::getCenter(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXRadialGradientBrush_getCenter(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Center attribute
		bool NOXRadialGradientBrush::hasCenter()
		{
			return (NAXRadialGradientBrush_hasCenter(&mHandler)!=0);
		}

		/// Removes the Center attribute
		bool NOXRadialGradientBrush::removeCenter()
		{
			return (NAXRadialGradientBrush_removeCenter(&mHandler)!=0);
		}

		/// Sets the Center attribute
		void NOXRadialGradientBrush::setCenter(NOXPoint pObject)
		{
			NAXRadialGradientBrush_setCenter(&mHandler, pObject);
		}

		/// Get the GradientOrigin attribute
		void NOXRadialGradientBrush::getGradientOrigin(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXRadialGradientBrush_getGradientOrigin(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the GradientOrigin attribute
		bool NOXRadialGradientBrush::hasGradientOrigin()
		{
			return (NAXRadialGradientBrush_hasGradientOrigin(&mHandler)!=0);
		}

		/// Removes the GradientOrigin attribute
		bool NOXRadialGradientBrush::removeGradientOrigin()
		{
			return (NAXRadialGradientBrush_removeGradientOrigin(&mHandler)!=0);
		}

		/// Sets the GradientOrigin attribute
		void NOXRadialGradientBrush::setGradientOrigin(NOXPoint pObject)
		{
			NAXRadialGradientBrush_setGradientOrigin(&mHandler, pObject);
		}

		/// Get the RadiusX attribute
		NOXGEZero NOXRadialGradientBrush::getRadiusX()
		{
			NOXGEZero lHandler;
			NAXRadialGradientBrush_getRadiusX(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the RadiusX attribute
		bool NOXRadialGradientBrush::hasRadiusX()
		{
			return (NAXRadialGradientBrush_hasRadiusX(&mHandler)!=0);
		}

		/// Removes the RadiusX attribute
		bool NOXRadialGradientBrush::removeRadiusX()
		{
			return (NAXRadialGradientBrush_removeRadiusX(&mHandler)!=0);
		}

		/// Sets the RadiusX attribute
		void NOXRadialGradientBrush::setRadiusX(NOXGEZero pObject)
		{
			NAXRadialGradientBrush_setRadiusX(&mHandler, pObject);
		}

		/// Get the RadiusY attribute
		NOXGEZero NOXRadialGradientBrush::getRadiusY()
		{
			NOXGEZero lHandler;
			NAXRadialGradientBrush_getRadiusY(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the RadiusY attribute
		bool NOXRadialGradientBrush::hasRadiusY()
		{
			return (NAXRadialGradientBrush_hasRadiusY(&mHandler)!=0);
		}

		/// Removes the RadiusY attribute
		bool NOXRadialGradientBrush::removeRadiusY()
		{
			return (NAXRadialGradientBrush_removeRadiusY(&mHandler)!=0);
		}

		/// Sets the RadiusY attribute
		void NOXRadialGradientBrush::setRadiusY(NOXGEZero pObject)
		{
			NAXRadialGradientBrush_setRadiusY(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXMappingMode pMappingMode, NOXPoint pCenter, NOXPoint pGradientOrigin, NOXGEZero pRadiusX, NOXGEZero pRadiusY)
		{
			NAXRadialGradientBrush_intialize(&mHandler, pMappingMode, pCenter, pGradientOrigin, pRadiusX, pRadiusY);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXRadialGradientBrush::getChild(NCommon::UInt32 pIndex)
		{
			return NAXRadialGradientBrush_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXRadialGradientBrush::getNumChilds()
		{
			return NAXRadialGradientBrush_getNumChilds(&mHandler);
		}

};

}

#endif
