// NOXSection header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXSection_h_
#define _NOXSection_h_

/*! \file NOXSection.h
	\brief Header file for the NOXSection class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXSection_getParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_getNumParagraphStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXSection_createParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_deleteParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXSection_getListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_getNumListStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXSection_createListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_deleteListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXSection_getTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_getNumTableStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXSection_createTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_deleteTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXSection_getFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_getNumFigureStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXSection_createFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_deleteFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXSection_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXSection_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXSection_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXSection NOXSection.h "NOXPrefix.h"
 * Class NOXSection
 */
class NOXSection
{
	public:
		NOXHandler mHandler;
		NOXSection()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXSection(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ParagraphStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXParagraph NOXSection::getParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_getParagraphStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ParagraphStructure elements that are present
		NCommon::UInt32 NOXSection::getNumParagraphStructure()
		{
			return NAXSection_getNumParagraphStructure(&mHandler);
		}

		/// Create an ParagraphStructure element at index pIndex
		/*public*/ NOXParagraph NOXSection::createParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_createParagraphStructure(&mHandler, pIndex);
		}

		/// Delete an ParagraphStructure element at index pIndex
		NCommon::UInt32 NOXSection::deleteParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_deleteParagraphStructure(&mHandler, pIndex);
		}

		/// Get ListStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXList*/ NOXHandler NOXSection::getListStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_getListStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ListStructure elements that are present
		NCommon::UInt32 NOXSection::getNumListStructure()
		{
			return NAXSection_getNumListStructure(&mHandler);
		}

		/// Create an ListStructure element at index pIndex
		/*public*/ /*NOXList*/ NOXHandler NOXSection::createListStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_createListStructure(&mHandler, pIndex);
		}

		/// Delete an ListStructure element at index pIndex
		NCommon::UInt32 NOXSection::deleteListStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_deleteListStructure(&mHandler, pIndex);
		}

		/// Get TableStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXTable*/ NOXHandler NOXSection::getTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_getTableStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableStructure elements that are present
		NCommon::UInt32 NOXSection::getNumTableStructure()
		{
			return NAXSection_getNumTableStructure(&mHandler);
		}

		/// Create an TableStructure element at index pIndex
		/*public*/ /*NOXTable*/ NOXHandler NOXSection::createTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_createTableStructure(&mHandler, pIndex);
		}

		/// Delete an TableStructure element at index pIndex
		NCommon::UInt32 NOXSection::deleteTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_deleteTableStructure(&mHandler, pIndex);
		}

		/// Get FigureStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXFigure NOXSection::getFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_getFigureStructure(&mHandler, pIndex);
		}

		/// Calculate the number of FigureStructure elements that are present
		NCommon::UInt32 NOXSection::getNumFigureStructure()
		{
			return NAXSection_getNumFigureStructure(&mHandler);
		}

		/// Create an FigureStructure element at index pIndex
		/*public*/ NOXFigure NOXSection::createFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_createFigureStructure(&mHandler, pIndex);
		}

		/// Delete an FigureStructure element at index pIndex
		NCommon::UInt32 NOXSection::deleteFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXSection_deleteFigureStructure(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXSection_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXSection::getChild(NCommon::UInt32 pIndex)
		{
			return NAXSection_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXSection::getNumChilds()
		{
			return NAXSection_getNumChilds(&mHandler);
		}

};

}

#endif
