// NOXSolidColorBrush header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXSolidColorBrush_h_
#define _NOXSolidColorBrush_h_

/*! \file NOXSolidColorBrush.h
	\brief Header file for the NOXSolidColorBrush class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXSolidColorBrush_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXSolidColorBrush_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXSolidColorBrush_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXSolidColorBrush_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXSolidColorBrush_getDefaultOpacity();
DLLIMPORTEXPORT void NAXSolidColorBrush_getColor(NOXHandler *pHandler, NOXColor *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXSolidColorBrush_hasColor(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXSolidColorBrush_removeColor(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXSolidColorBrush_setColor(NOXHandler *pHandler, NOXColor pObject);
DLLIMPORTEXPORT void NAXSolidColorBrush_intialize(NOXHandler *pHandler, NOXColor pColor);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXSolidColorBrush NOXSolidColorBrush.h "NOXPrefix.h"
 * Class NOXSolidColorBrush
 */
class NOXSolidColorBrush
{
	public:
		NOXHandler mHandler;
		NOXSolidColorBrush()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXSolidColorBrush(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the Opacity attribute
		NOXZeroOne NOXSolidColorBrush::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXSolidColorBrush_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXSolidColorBrush::hasOpacity()
		{
			return (NAXSolidColorBrush_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXSolidColorBrush::removeOpacity()
		{
			return (NAXSolidColorBrush_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXSolidColorBrush::setOpacity(NOXZeroOne pObject)
		{
			NAXSolidColorBrush_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXSolidColorBrush::getDefaultOpacity()
		{
			return NAXSolidColorBrush_getDefaultOpacity();
		}

		/// Get the Color attribute
		void NOXSolidColorBrush::getColor(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXSolidColorBrush_getColor(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Color attribute
		bool NOXSolidColorBrush::hasColor()
		{
			return (NAXSolidColorBrush_hasColor(&mHandler)!=0);
		}

		/// Removes the Color attribute
		bool NOXSolidColorBrush::removeColor()
		{
			return (NAXSolidColorBrush_removeColor(&mHandler)!=0);
		}

		/// Sets the Color attribute
		void NOXSolidColorBrush::setColor(NOXColor pObject)
		{
			NAXSolidColorBrush_setColor(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXColor pColor)
		{
			NAXSolidColorBrush_intialize(&mHandler, pColor);
		}

};

}

#endif
