// NOXStory header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXStory_h_
#define _NOXStory_h_

/*! \file NOXStory.h
	\brief Header file for the NOXStory class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXStory_getStoryFragmentReference(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStory_getNumStoryFragmentReference(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStory_createStoryFragmentReference(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStory_deleteStoryFragmentReference(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXStory_getStoryName(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXStory_hasStoryName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXStory_removeStoryName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXStory_setStoryName(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXStory_intialize(NOXHandler *pHandler, NOXStringBase pStoryName);
DLLIMPORTEXPORT NOXHandler NAXStory_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStory_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXStory NOXStory.h "NOXPrefix.h"
 * Class NOXStory
 */
class NOXStory
{
	public:
		NOXHandler mHandler;
		NOXStory()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXStory(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get StoryFragmentReference element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXStoryFragmentReference NOXStory::getStoryFragmentReference(NCommon::UInt32 pIndex)
		{
			return NAXStory_getStoryFragmentReference(&mHandler, pIndex);
		}

		/// Calculate the number of StoryFragmentReference elements that are present
		NCommon::UInt32 NOXStory::getNumStoryFragmentReference()
		{
			return NAXStory_getNumStoryFragmentReference(&mHandler);
		}

		/// Create an StoryFragmentReference element at index pIndex
		/*public*/ NOXStoryFragmentReference NOXStory::createStoryFragmentReference(NCommon::UInt32 pIndex)
		{
			return NAXStory_createStoryFragmentReference(&mHandler, pIndex);
		}

		/// Delete an StoryFragmentReference element at index pIndex
		NCommon::UInt32 NOXStory::deleteStoryFragmentReference(NCommon::UInt32 pIndex)
		{
			return NAXStory_deleteStoryFragmentReference(&mHandler, pIndex);
		}

		/// Get the StoryName attribute
		void NOXStory::getStoryName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXStory_getStoryName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the StoryName attribute
		bool NOXStory::hasStoryName()
		{
			return (NAXStory_hasStoryName(&mHandler)!=0);
		}

		/// Removes the StoryName attribute
		bool NOXStory::removeStoryName()
		{
			return (NAXStory_removeStoryName(&mHandler)!=0);
		}

		/// Sets the StoryName attribute
		void NOXStory::setStoryName(NOXStringBase pObject)
		{
			NAXStory_setStoryName(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXStringBase pStoryName)
		{
			NAXStory_intialize(&mHandler, pStoryName);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXStory::getChild(NCommon::UInt32 pIndex)
		{
			return NAXStory_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXStory::getNumChilds()
		{
			return NAXStory_getNumChilds(&mHandler);
		}

};

}

#endif
