// NOXStoryFragment header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXStoryFragment_h_
#define _NOXStoryFragment_h_

/*! \file NOXStoryFragment.h
	\brief Header file for the NOXStoryFragment class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getStoryBreak(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumStoryBreak(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_createStoryBreak(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_deleteStoryBreak(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getSectionStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumSectionStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_createSectionStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_deleteSectionStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumParagraphStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_createParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_deleteParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumListStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_createListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_deleteListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumTableStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_createTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_deleteTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumFigureStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_createFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_deleteFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXStoryFragment_getStoryName(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_hasStoryName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_removeStoryName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXStoryFragment_setStoryName(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXStoryFragment_getFragmentName(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_hasFragmentName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_removeFragmentName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXStoryFragment_setFragmentName(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXStoryFragment_getFragmentType(NOXHandler *pHandler, NOXFragmentType *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_hasFragmentType(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_removeFragmentType(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXStoryFragment_setFragmentType(NOXHandler *pHandler, NOXFragmentType pObject);
DLLIMPORTEXPORT void NAXStoryFragment_intialize(NOXHandler *pHandler, NOXFragmentType pFragmentType);
DLLIMPORTEXPORT NOXHandler NAXStoryFragment_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragment_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXStoryFragment NOXStoryFragment.h "NOXPrefix.h"
 * Class NOXStoryFragment
 */
class NOXStoryFragment
{
	public:
		NOXHandler mHandler;
		NOXStoryFragment()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXStoryFragment(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get StoryBreak element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBreak NOXStoryFragment::getStoryBreak(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getStoryBreak(&mHandler, pIndex);
		}

		/// Calculate the number of StoryBreak elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumStoryBreak()
		{
			return NAXStoryFragment_getNumStoryBreak(&mHandler);
		}

		/// Create an StoryBreak element at index pIndex
		/*public*/ NOXBreak NOXStoryFragment::createStoryBreak(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_createStoryBreak(&mHandler, pIndex);
		}

		/// Delete an StoryBreak element at index pIndex
		NCommon::UInt32 NOXStoryFragment::deleteStoryBreak(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_deleteStoryBreak(&mHandler, pIndex);
		}

		/// Get SectionStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXSection NOXStoryFragment::getSectionStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getSectionStructure(&mHandler, pIndex);
		}

		/// Calculate the number of SectionStructure elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumSectionStructure()
		{
			return NAXStoryFragment_getNumSectionStructure(&mHandler);
		}

		/// Create an SectionStructure element at index pIndex
		/*public*/ NOXSection NOXStoryFragment::createSectionStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_createSectionStructure(&mHandler, pIndex);
		}

		/// Delete an SectionStructure element at index pIndex
		NCommon::UInt32 NOXStoryFragment::deleteSectionStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_deleteSectionStructure(&mHandler, pIndex);
		}

		/// Get ParagraphStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXParagraph NOXStoryFragment::getParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getParagraphStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ParagraphStructure elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumParagraphStructure()
		{
			return NAXStoryFragment_getNumParagraphStructure(&mHandler);
		}

		/// Create an ParagraphStructure element at index pIndex
		/*public*/ NOXParagraph NOXStoryFragment::createParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_createParagraphStructure(&mHandler, pIndex);
		}

		/// Delete an ParagraphStructure element at index pIndex
		NCommon::UInt32 NOXStoryFragment::deleteParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_deleteParagraphStructure(&mHandler, pIndex);
		}

		/// Get ListStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXList*/ NOXHandler NOXStoryFragment::getListStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getListStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ListStructure elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumListStructure()
		{
			return NAXStoryFragment_getNumListStructure(&mHandler);
		}

		/// Create an ListStructure element at index pIndex
		/*public*/ /*NOXList*/ NOXHandler NOXStoryFragment::createListStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_createListStructure(&mHandler, pIndex);
		}

		/// Delete an ListStructure element at index pIndex
		NCommon::UInt32 NOXStoryFragment::deleteListStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_deleteListStructure(&mHandler, pIndex);
		}

		/// Get TableStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXTable*/ NOXHandler NOXStoryFragment::getTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getTableStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableStructure elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumTableStructure()
		{
			return NAXStoryFragment_getNumTableStructure(&mHandler);
		}

		/// Create an TableStructure element at index pIndex
		/*public*/ /*NOXTable*/ NOXHandler NOXStoryFragment::createTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_createTableStructure(&mHandler, pIndex);
		}

		/// Delete an TableStructure element at index pIndex
		NCommon::UInt32 NOXStoryFragment::deleteTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_deleteTableStructure(&mHandler, pIndex);
		}

		/// Get FigureStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXFigure NOXStoryFragment::getFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getFigureStructure(&mHandler, pIndex);
		}

		/// Calculate the number of FigureStructure elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumFigureStructure()
		{
			return NAXStoryFragment_getNumFigureStructure(&mHandler);
		}

		/// Create an FigureStructure element at index pIndex
		/*public*/ NOXFigure NOXStoryFragment::createFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_createFigureStructure(&mHandler, pIndex);
		}

		/// Delete an FigureStructure element at index pIndex
		NCommon::UInt32 NOXStoryFragment::deleteFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_deleteFigureStructure(&mHandler, pIndex);
		}

		/// Get the StoryName attribute
		void NOXStoryFragment::getStoryName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXStoryFragment_getStoryName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the StoryName attribute
		bool NOXStoryFragment::hasStoryName()
		{
			return (NAXStoryFragment_hasStoryName(&mHandler)!=0);
		}

		/// Removes the StoryName attribute
		bool NOXStoryFragment::removeStoryName()
		{
			return (NAXStoryFragment_removeStoryName(&mHandler)!=0);
		}

		/// Sets the StoryName attribute
		void NOXStoryFragment::setStoryName(NOXStringBase pObject)
		{
			NAXStoryFragment_setStoryName(&mHandler, pObject);
		}

		/// Get the FragmentName attribute
		void NOXStoryFragment::getFragmentName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXStoryFragment_getFragmentName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the FragmentName attribute
		bool NOXStoryFragment::hasFragmentName()
		{
			return (NAXStoryFragment_hasFragmentName(&mHandler)!=0);
		}

		/// Removes the FragmentName attribute
		bool NOXStoryFragment::removeFragmentName()
		{
			return (NAXStoryFragment_removeFragmentName(&mHandler)!=0);
		}

		/// Sets the FragmentName attribute
		void NOXStoryFragment::setFragmentName(NOXStringBase pObject)
		{
			NAXStoryFragment_setFragmentName(&mHandler, pObject);
		}

		/// Get the FragmentType attribute
		NOXFragmentType NOXStoryFragment::getFragmentType()
		{
			NOXFragmentType lHandler;
			NAXStoryFragment_getFragmentType(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the FragmentType attribute
		bool NOXStoryFragment::hasFragmentType()
		{
			return (NAXStoryFragment_hasFragmentType(&mHandler)!=0);
		}

		/// Removes the FragmentType attribute
		bool NOXStoryFragment::removeFragmentType()
		{
			return (NAXStoryFragment_removeFragmentType(&mHandler)!=0);
		}

		/// Sets the FragmentType attribute
		void NOXStoryFragment::setFragmentType(NOXFragmentType pObject)
		{
			NAXStoryFragment_setFragmentType(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXFragmentType pFragmentType)
		{
			NAXStoryFragment_intialize(&mHandler, pFragmentType);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXStoryFragment::getChild(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragment_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXStoryFragment::getNumChilds()
		{
			return NAXStoryFragment_getNumChilds(&mHandler);
		}

};

}

#endif
