// NOXStoryFragmentReference header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXStoryFragmentReference_h_
#define _NOXStoryFragmentReference_h_

/*! \file NOXStoryFragmentReference.h
	\brief Header file for the NOXStoryFragmentReference class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT void NAXStoryFragmentReference_getFragmentName(NOXHandler *pHandler, NOXStringBase *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragmentReference_hasFragmentName(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragmentReference_removeFragmentName(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXStoryFragmentReference_setFragmentName(NOXHandler *pHandler, NOXStringBase pObject);
DLLIMPORTEXPORT void NAXStoryFragmentReference_getPage(NOXHandler *pHandler, NOXIntGEOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragmentReference_hasPage(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragmentReference_removePage(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXStoryFragmentReference_setPage(NOXHandler *pHandler, NOXIntGEOne pObject);
DLLIMPORTEXPORT void NAXStoryFragmentReference_intialize(NOXHandler *pHandler, NOXIntGEOne pPage);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXStoryFragmentReference NOXStoryFragmentReference.h "NOXPrefix.h"
 * Class NOXStoryFragmentReference
 */
class NOXStoryFragmentReference
{
	public:
		NOXHandler mHandler;
		NOXStoryFragmentReference()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXStoryFragmentReference(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get the FragmentName attribute
		void NOXStoryFragmentReference::getFragmentName(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXStoryFragmentReference_getFragmentName(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the FragmentName attribute
		bool NOXStoryFragmentReference::hasFragmentName()
		{
			return (NAXStoryFragmentReference_hasFragmentName(&mHandler)!=0);
		}

		/// Removes the FragmentName attribute
		bool NOXStoryFragmentReference::removeFragmentName()
		{
			return (NAXStoryFragmentReference_removeFragmentName(&mHandler)!=0);
		}

		/// Sets the FragmentName attribute
		void NOXStoryFragmentReference::setFragmentName(NOXStringBase pObject)
		{
			NAXStoryFragmentReference_setFragmentName(&mHandler, pObject);
		}

		/// Get the Page attribute
		NOXIntGEOne NOXStoryFragmentReference::getPage()
		{
			NOXIntGEOne lHandler;
			NAXStoryFragmentReference_getPage(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Page attribute
		bool NOXStoryFragmentReference::hasPage()
		{
			return (NAXStoryFragmentReference_hasPage(&mHandler)!=0);
		}

		/// Removes the Page attribute
		bool NOXStoryFragmentReference::removePage()
		{
			return (NAXStoryFragmentReference_removePage(&mHandler)!=0);
		}

		/// Sets the Page attribute
		void NOXStoryFragmentReference::setPage(NOXIntGEOne pObject)
		{
			NAXStoryFragmentReference_setPage(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXIntGEOne pPage)
		{
			NAXStoryFragmentReference_intialize(&mHandler, pPage);
		}

};

}

#endif
