// NOXStoryFragments header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXStoryFragments_h_
#define _NOXStoryFragments_h_

/*! \file NOXStoryFragments.h
	\brief Header file for the NOXStoryFragments class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXStoryFragments_getStoryFragment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragments_getNumStoryFragment(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragments_createStoryFragment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragments_deleteStoryFragment(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXStoryFragments_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXStoryFragments_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXStoryFragments_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXStoryFragments NOXStoryFragments.h "NOXPrefix.h"
 * Class NOXStoryFragments
 */
class NOXStoryFragments
{
	public:
		NOXHandler mHandler;
		NOXStoryFragments()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXStoryFragments(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get StoryFragment element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXStoryFragment NOXStoryFragments::getStoryFragment(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragments_getStoryFragment(&mHandler, pIndex);
		}

		/// Calculate the number of StoryFragment elements that are present
		NCommon::UInt32 NOXStoryFragments::getNumStoryFragment()
		{
			return NAXStoryFragments_getNumStoryFragment(&mHandler);
		}

		/// Create an StoryFragment element at index pIndex
		/*public*/ NOXStoryFragment NOXStoryFragments::createStoryFragment(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragments_createStoryFragment(&mHandler, pIndex);
		}

		/// Delete an StoryFragment element at index pIndex
		NCommon::UInt32 NOXStoryFragments::deleteStoryFragment(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragments_deleteStoryFragment(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXStoryFragments_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXStoryFragments::getChild(NCommon::UInt32 pIndex)
		{
			return NAXStoryFragments_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXStoryFragments::getNumChilds()
		{
			return NAXStoryFragments_getNumChilds(&mHandler);
		}

};

}

#endif
