// NOXTable header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXTable_h_
#define _NOXTable_h_

/*! \file NOXTable.h
	\brief Header file for the NOXTable class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXTable_getTableRowGroupStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTable_getNumTableRowGroupStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTable_createTableRowGroupStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTable_deleteTableRowGroupStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXTable_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTable_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTable_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXTable NOXTable.h "NOXPrefix.h"
 * Class NOXTable
 */
class NOXTable
{
	public:
		NOXHandler mHandler;
		NOXTable()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXTable(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get TableRowGroupStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXTableRowGroup NOXTable::getTableRowGroupStructure(NCommon::UInt32 pIndex)
		{
			return NAXTable_getTableRowGroupStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableRowGroupStructure elements that are present
		NCommon::UInt32 NOXTable::getNumTableRowGroupStructure()
		{
			return NAXTable_getNumTableRowGroupStructure(&mHandler);
		}

		/// Create an TableRowGroupStructure element at index pIndex
		/*public*/ NOXTableRowGroup NOXTable::createTableRowGroupStructure(NCommon::UInt32 pIndex)
		{
			return NAXTable_createTableRowGroupStructure(&mHandler, pIndex);
		}

		/// Delete an TableRowGroupStructure element at index pIndex
		NCommon::UInt32 NOXTable::deleteTableRowGroupStructure(NCommon::UInt32 pIndex)
		{
			return NAXTable_deleteTableRowGroupStructure(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXTable_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXTable::getChild(NCommon::UInt32 pIndex)
		{
			return NAXTable_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXTable::getNumChilds()
		{
			return NAXTable_getNumChilds(&mHandler);
		}

};

}

#endif
