// NOXTableCell header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXTableCell_h_
#define _NOXTableCell_h_

/*! \file NOXTableCell.h
	\brief Header file for the NOXTableCell class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXTableCell_getParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_getNumParagraphStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableCell_createParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_deleteParagraphStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXTableCell_getListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_getNumListStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableCell_createListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_deleteListStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXTableCell_getTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_getNumTableStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableCell_createTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_deleteTableStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXTableCell_getFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_getNumFigureStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableCell_createFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_deleteFigureStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXTableCell_getRowSpan(NOXHandler *pHandler, NOXTableSpan *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_hasRowSpan(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_removeRowSpan(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXTableCell_setRowSpan(NOXHandler *pHandler, NOXTableSpan pObject);
DLLIMPORTEXPORT NOXTableSpan NAXTableCell_getDefaultRowSpan();
DLLIMPORTEXPORT void NAXTableCell_getColumnSpan(NOXHandler *pHandler, NOXTableSpan *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_hasColumnSpan(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_removeColumnSpan(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXTableCell_setColumnSpan(NOXHandler *pHandler, NOXTableSpan pObject);
DLLIMPORTEXPORT NOXTableSpan NAXTableCell_getDefaultColumnSpan();
DLLIMPORTEXPORT void NAXTableCell_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableCell_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableCell_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXTableCell NOXTableCell.h "NOXPrefix.h"
 * Class NOXTableCell
 */
class NOXTableCell
{
	public:
		NOXHandler mHandler;
		NOXTableCell()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXTableCell(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get ParagraphStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXParagraph NOXTableCell::getParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_getParagraphStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ParagraphStructure elements that are present
		NCommon::UInt32 NOXTableCell::getNumParagraphStructure()
		{
			return NAXTableCell_getNumParagraphStructure(&mHandler);
		}

		/// Create an ParagraphStructure element at index pIndex
		/*public*/ NOXParagraph NOXTableCell::createParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_createParagraphStructure(&mHandler, pIndex);
		}

		/// Delete an ParagraphStructure element at index pIndex
		NCommon::UInt32 NOXTableCell::deleteParagraphStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_deleteParagraphStructure(&mHandler, pIndex);
		}

		/// Get ListStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXList*/ NOXHandler NOXTableCell::getListStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_getListStructure(&mHandler, pIndex);
		}

		/// Calculate the number of ListStructure elements that are present
		NCommon::UInt32 NOXTableCell::getNumListStructure()
		{
			return NAXTableCell_getNumListStructure(&mHandler);
		}

		/// Create an ListStructure element at index pIndex
		/*public*/ /*NOXList*/ NOXHandler NOXTableCell::createListStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_createListStructure(&mHandler, pIndex);
		}

		/// Delete an ListStructure element at index pIndex
		NCommon::UInt32 NOXTableCell::deleteListStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_deleteListStructure(&mHandler, pIndex);
		}

		/// Get TableStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ /*NOXTable*/ NOXHandler NOXTableCell::getTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_getTableStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableStructure elements that are present
		NCommon::UInt32 NOXTableCell::getNumTableStructure()
		{
			return NAXTableCell_getNumTableStructure(&mHandler);
		}

		/// Create an TableStructure element at index pIndex
		/*public*/ /*NOXTable*/ NOXHandler NOXTableCell::createTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_createTableStructure(&mHandler, pIndex);
		}

		/// Delete an TableStructure element at index pIndex
		NCommon::UInt32 NOXTableCell::deleteTableStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_deleteTableStructure(&mHandler, pIndex);
		}

		/// Get FigureStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXFigure NOXTableCell::getFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_getFigureStructure(&mHandler, pIndex);
		}

		/// Calculate the number of FigureStructure elements that are present
		NCommon::UInt32 NOXTableCell::getNumFigureStructure()
		{
			return NAXTableCell_getNumFigureStructure(&mHandler);
		}

		/// Create an FigureStructure element at index pIndex
		/*public*/ NOXFigure NOXTableCell::createFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_createFigureStructure(&mHandler, pIndex);
		}

		/// Delete an FigureStructure element at index pIndex
		NCommon::UInt32 NOXTableCell::deleteFigureStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_deleteFigureStructure(&mHandler, pIndex);
		}

		/// Get the RowSpan attribute
		NOXTableSpan NOXTableCell::getRowSpan()
		{
			NOXTableSpan lHandler;
			NAXTableCell_getRowSpan(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the RowSpan attribute
		bool NOXTableCell::hasRowSpan()
		{
			return (NAXTableCell_hasRowSpan(&mHandler)!=0);
		}

		/// Removes the RowSpan attribute
		bool NOXTableCell::removeRowSpan()
		{
			return (NAXTableCell_removeRowSpan(&mHandler)!=0);
		}

		/// Sets the RowSpan attribute
		void NOXTableCell::setRowSpan(NOXTableSpan pObject)
		{
			NAXTableCell_setRowSpan(&mHandler, pObject);
		}

		/// Get the default RowSpan
		NOXTableSpan NOXTableCell::getDefaultRowSpan()
		{
			return NAXTableCell_getDefaultRowSpan();
		}

		/// Get the ColumnSpan attribute
		NOXTableSpan NOXTableCell::getColumnSpan()
		{
			NOXTableSpan lHandler;
			NAXTableCell_getColumnSpan(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ColumnSpan attribute
		bool NOXTableCell::hasColumnSpan()
		{
			return (NAXTableCell_hasColumnSpan(&mHandler)!=0);
		}

		/// Removes the ColumnSpan attribute
		bool NOXTableCell::removeColumnSpan()
		{
			return (NAXTableCell_removeColumnSpan(&mHandler)!=0);
		}

		/// Sets the ColumnSpan attribute
		void NOXTableCell::setColumnSpan(NOXTableSpan pObject)
		{
			NAXTableCell_setColumnSpan(&mHandler, pObject);
		}

		/// Get the default ColumnSpan
		NOXTableSpan NOXTableCell::getDefaultColumnSpan()
		{
			return NAXTableCell_getDefaultColumnSpan();
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXTableCell_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXTableCell::getChild(NCommon::UInt32 pIndex)
		{
			return NAXTableCell_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXTableCell::getNumChilds()
		{
			return NAXTableCell_getNumChilds(&mHandler);
		}

};

}

#endif
