// NOXTableRow header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXTableRow_h_
#define _NOXTableRow_h_

/*! \file NOXTableRow.h
	\brief Header file for the NOXTableRow class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXTableRow_getTableCellStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableRow_getNumTableCellStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableRow_createTableCellStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableRow_deleteTableCellStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXTableRow_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableRow_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableRow_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXTableRow NOXTableRow.h "NOXPrefix.h"
 * Class NOXTableRow
 */
class NOXTableRow
{
	public:
		NOXHandler mHandler;
		NOXTableRow()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXTableRow(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get TableCellStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXTableCell NOXTableRow::getTableCellStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableRow_getTableCellStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableCellStructure elements that are present
		NCommon::UInt32 NOXTableRow::getNumTableCellStructure()
		{
			return NAXTableRow_getNumTableCellStructure(&mHandler);
		}

		/// Create an TableCellStructure element at index pIndex
		/*public*/ NOXTableCell NOXTableRow::createTableCellStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableRow_createTableCellStructure(&mHandler, pIndex);
		}

		/// Delete an TableCellStructure element at index pIndex
		NCommon::UInt32 NOXTableRow::deleteTableCellStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableRow_deleteTableCellStructure(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXTableRow_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXTableRow::getChild(NCommon::UInt32 pIndex)
		{
			return NAXTableRow_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXTableRow::getNumChilds()
		{
			return NAXTableRow_getNumChilds(&mHandler);
		}

};

}

#endif
