// NOXTableRowGroup header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXTableRowGroup_h_
#define _NOXTableRowGroup_h_

/*! \file NOXTableRowGroup.h
	\brief Header file for the NOXTableRowGroup class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXTableRowGroup_getTableRowStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableRowGroup_getNumTableRowStructure(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableRowGroup_createTableRowStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableRowGroup_deleteTableRowStructure(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXTableRowGroup_intialize(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXTableRowGroup_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXTableRowGroup_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXTableRowGroup NOXTableRowGroup.h "NOXPrefix.h"
 * Class NOXTableRowGroup
 */
class NOXTableRowGroup
{
	public:
		NOXHandler mHandler;
		NOXTableRowGroup()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXTableRowGroup(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get TableRowStructure element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXTableRow NOXTableRowGroup::getTableRowStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableRowGroup_getTableRowStructure(&mHandler, pIndex);
		}

		/// Calculate the number of TableRowStructure elements that are present
		NCommon::UInt32 NOXTableRowGroup::getNumTableRowStructure()
		{
			return NAXTableRowGroup_getNumTableRowStructure(&mHandler);
		}

		/// Create an TableRowStructure element at index pIndex
		/*public*/ NOXTableRow NOXTableRowGroup::createTableRowStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableRowGroup_createTableRowStructure(&mHandler, pIndex);
		}

		/// Delete an TableRowStructure element at index pIndex
		NCommon::UInt32 NOXTableRowGroup::deleteTableRowStructure(NCommon::UInt32 pIndex)
		{
			return NAXTableRowGroup_deleteTableRowStructure(&mHandler, pIndex);
		}

		/// Initialize
		/*public*/ void intialize()
		{
			NAXTableRowGroup_intialize(&mHandler);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXTableRowGroup::getChild(NCommon::UInt32 pIndex)
		{
			return NAXTableRowGroup_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXTableRowGroup::getNumChilds()
		{
			return NAXTableRowGroup_getNumChilds(&mHandler);
		}

};

}

#endif
