// NOXVisualBrush header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NOXVisualBrush_h_
#define _NOXVisualBrush_h_

/*! \file NOXVisualBrush.h
	\brief Header file for the NOXVisualBrush class
*/


#include "NOXPrefix.h"

extern "C" {
DLLIMPORTEXPORT NOXHandler NAXVisualBrush_getVisualBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_getNumVisualBrushTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXVisualBrush_createVisualBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_deleteVisualBrushTransform(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NOXHandler NAXVisualBrush_getVisualBrushVisual(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_getNumVisualBrushVisual(NOXHandler *pHandler);
DLLIMPORTEXPORT NOXHandler NAXVisualBrush_createVisualBrushVisual(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_deleteVisualBrushVisual(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT void NAXVisualBrush_getOpacity(NOXHandler *pHandler, NOXZeroOne *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeOpacity(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setOpacity(NOXHandler *pHandler, NOXZeroOne pObject);
DLLIMPORTEXPORT NOXZeroOne NAXVisualBrush_getDefaultOpacity();
DLLIMPORTEXPORT void NAXVisualBrush_getTransform(NOXHandler *pHandler, NOXRscRefMatrix *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeTransform(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setTransform(NOXHandler *pHandler, NOXRscRefMatrix pObject);
DLLIMPORTEXPORT void NAXVisualBrush_getViewbox(NOXHandler *pHandler, NOXViewBox *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasViewbox(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeViewbox(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setViewbox(NOXHandler *pHandler, NOXViewBox pObject);
DLLIMPORTEXPORT void NAXVisualBrush_getViewport(NOXHandler *pHandler, NOXViewBox *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasViewport(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeViewport(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setViewport(NOXHandler *pHandler, NOXViewBox pObject);
DLLIMPORTEXPORT void NAXVisualBrush_getTileMode(NOXHandler *pHandler, NOXTileMode *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasTileMode(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeTileMode(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setTileMode(NOXHandler *pHandler, NOXTileMode pObject);
DLLIMPORTEXPORT NOXTileMode NAXVisualBrush_getDefaultTileMode();
DLLIMPORTEXPORT void NAXVisualBrush_getViewboxUnits(NOXHandler *pHandler, NOXViewUnits *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasViewboxUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeViewboxUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setViewboxUnits(NOXHandler *pHandler, NOXViewUnits pObject);
DLLIMPORTEXPORT void NAXVisualBrush_getViewportUnits(NOXHandler *pHandler, NOXViewUnits *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasViewportUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeViewportUnits(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setViewportUnits(NOXHandler *pHandler, NOXViewUnits pObject);
DLLIMPORTEXPORT void NAXVisualBrush_getVisual(NOXHandler *pHandler, NOXRscRef *pOut);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_hasVisual(NOXHandler *pHandler);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_removeVisual(NOXHandler *pHandler);
DLLIMPORTEXPORT void NAXVisualBrush_setVisual(NOXHandler *pHandler, NOXRscRef pObject);
DLLIMPORTEXPORT void NAXVisualBrush_intialize(NOXHandler *pHandler, NOXViewBox pViewbox, NOXViewBox pViewport, NOXViewUnits pViewboxUnits, NOXViewUnits pViewportUnits);
DLLIMPORTEXPORT NOXHandler NAXVisualBrush_getChild(NOXHandler *pHandler, NCommon::UInt32 pIndex);
DLLIMPORTEXPORT NCommon::UInt32 NAXVisualBrush_getNumChilds(NOXHandler *pHandler);
}

namespace NiXPSObjects
{

using namespace NCommon;

/*!
 * \class NOXVisualBrush NOXVisualBrush.h "NOXPrefix.h"
 * Class NOXVisualBrush
 */
class NOXVisualBrush
{
	public:
		NOXHandler mHandler;
		NOXVisualBrush()
		{
			NIXPS_TRACE;

			mHandler.mDoc=0;
			mHandler.mType=0;
			mHandler.mCursor=0;
			mHandler.mError=0;
		}
		NOXVisualBrush(NOXHandler pHandler): mHandler(pHandler) {}

		/// Get VisualBrushTransform element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Transform NOXVisualBrush::getVisualBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_getVisualBrushTransform(&mHandler, pIndex);
		}

		/// Calculate the number of VisualBrushTransform elements that are present
		NCommon::UInt32 NOXVisualBrush::getNumVisualBrushTransform()
		{
			return NAXVisualBrush_getNumVisualBrushTransform(&mHandler);
		}

		/// Create an VisualBrushTransform element at index pIndex
		/*public*/ NOXCP_Transform NOXVisualBrush::createVisualBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_createVisualBrushTransform(&mHandler, pIndex);
		}

		/// Delete an VisualBrushTransform element at index pIndex
		NCommon::UInt32 NOXVisualBrush::deleteVisualBrushTransform(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_deleteVisualBrushTransform(&mHandler, pIndex);
		}

		/// Get VisualBrushVisual element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXCP_Visual NOXVisualBrush::getVisualBrushVisual(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_getVisualBrushVisual(&mHandler, pIndex);
		}

		/// Calculate the number of VisualBrushVisual elements that are present
		NCommon::UInt32 NOXVisualBrush::getNumVisualBrushVisual()
		{
			return NAXVisualBrush_getNumVisualBrushVisual(&mHandler);
		}

		/// Create an VisualBrushVisual element at index pIndex
		/*public*/ NOXCP_Visual NOXVisualBrush::createVisualBrushVisual(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_createVisualBrushVisual(&mHandler, pIndex);
		}

		/// Delete an VisualBrushVisual element at index pIndex
		NCommon::UInt32 NOXVisualBrush::deleteVisualBrushVisual(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_deleteVisualBrushVisual(&mHandler, pIndex);
		}

		/// Get the Opacity attribute
		NOXZeroOne NOXVisualBrush::getOpacity()
		{
			NOXZeroOne lHandler;
			NAXVisualBrush_getOpacity(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the Opacity attribute
		bool NOXVisualBrush::hasOpacity()
		{
			return (NAXVisualBrush_hasOpacity(&mHandler)!=0);
		}

		/// Removes the Opacity attribute
		bool NOXVisualBrush::removeOpacity()
		{
			return (NAXVisualBrush_removeOpacity(&mHandler)!=0);
		}

		/// Sets the Opacity attribute
		void NOXVisualBrush::setOpacity(NOXZeroOne pObject)
		{
			NAXVisualBrush_setOpacity(&mHandler, pObject);
		}

		/// Get the default Opacity
		NOXZeroOne NOXVisualBrush::getDefaultOpacity()
		{
			return NAXVisualBrush_getDefaultOpacity();
		}

		/// Get the Transform attribute
		void NOXVisualBrush::getTransform(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXVisualBrush_getTransform(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Transform attribute
		bool NOXVisualBrush::hasTransform()
		{
			return (NAXVisualBrush_hasTransform(&mHandler)!=0);
		}

		/// Removes the Transform attribute
		bool NOXVisualBrush::removeTransform()
		{
			return (NAXVisualBrush_removeTransform(&mHandler)!=0);
		}

		/// Sets the Transform attribute
		void NOXVisualBrush::setTransform(NOXRscRefMatrix pObject)
		{
			NAXVisualBrush_setTransform(&mHandler, pObject);
		}

		/// Get the Viewbox attribute
		void NOXVisualBrush::getViewbox(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXVisualBrush_getViewbox(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Viewbox attribute
		bool NOXVisualBrush::hasViewbox()
		{
			return (NAXVisualBrush_hasViewbox(&mHandler)!=0);
		}

		/// Removes the Viewbox attribute
		bool NOXVisualBrush::removeViewbox()
		{
			return (NAXVisualBrush_removeViewbox(&mHandler)!=0);
		}

		/// Sets the Viewbox attribute
		void NOXVisualBrush::setViewbox(NOXViewBox pObject)
		{
			NAXVisualBrush_setViewbox(&mHandler, pObject);
		}

		/// Get the Viewport attribute
		void NOXVisualBrush::getViewport(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXVisualBrush_getViewport(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Viewport attribute
		bool NOXVisualBrush::hasViewport()
		{
			return (NAXVisualBrush_hasViewport(&mHandler)!=0);
		}

		/// Removes the Viewport attribute
		bool NOXVisualBrush::removeViewport()
		{
			return (NAXVisualBrush_removeViewport(&mHandler)!=0);
		}

		/// Sets the Viewport attribute
		void NOXVisualBrush::setViewport(NOXViewBox pObject)
		{
			NAXVisualBrush_setViewport(&mHandler, pObject);
		}

		/// Get the TileMode attribute
		NOXTileMode NOXVisualBrush::getTileMode()
		{
			NOXTileMode lHandler;
			NAXVisualBrush_getTileMode(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the TileMode attribute
		bool NOXVisualBrush::hasTileMode()
		{
			return (NAXVisualBrush_hasTileMode(&mHandler)!=0);
		}

		/// Removes the TileMode attribute
		bool NOXVisualBrush::removeTileMode()
		{
			return (NAXVisualBrush_removeTileMode(&mHandler)!=0);
		}

		/// Sets the TileMode attribute
		void NOXVisualBrush::setTileMode(NOXTileMode pObject)
		{
			NAXVisualBrush_setTileMode(&mHandler, pObject);
		}

		/// Get the default TileMode
		NOXTileMode NOXVisualBrush::getDefaultTileMode()
		{
			return NAXVisualBrush_getDefaultTileMode();
		}

		/// Get the ViewboxUnits attribute
		NOXViewUnits NOXVisualBrush::getViewboxUnits()
		{
			NOXViewUnits lHandler;
			NAXVisualBrush_getViewboxUnits(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ViewboxUnits attribute
		bool NOXVisualBrush::hasViewboxUnits()
		{
			return (NAXVisualBrush_hasViewboxUnits(&mHandler)!=0);
		}

		/// Removes the ViewboxUnits attribute
		bool NOXVisualBrush::removeViewboxUnits()
		{
			return (NAXVisualBrush_removeViewboxUnits(&mHandler)!=0);
		}

		/// Sets the ViewboxUnits attribute
		void NOXVisualBrush::setViewboxUnits(NOXViewUnits pObject)
		{
			NAXVisualBrush_setViewboxUnits(&mHandler, pObject);
		}

		/// Get the ViewportUnits attribute
		NOXViewUnits NOXVisualBrush::getViewportUnits()
		{
			NOXViewUnits lHandler;
			NAXVisualBrush_getViewportUnits(&mHandler, &lHandler);
			return lHandler;
		}

		/// Check for the availability of the ViewportUnits attribute
		bool NOXVisualBrush::hasViewportUnits()
		{
			return (NAXVisualBrush_hasViewportUnits(&mHandler)!=0);
		}

		/// Removes the ViewportUnits attribute
		bool NOXVisualBrush::removeViewportUnits()
		{
			return (NAXVisualBrush_removeViewportUnits(&mHandler)!=0);
		}

		/// Sets the ViewportUnits attribute
		void NOXVisualBrush::setViewportUnits(NOXViewUnits pObject)
		{
			NAXVisualBrush_setViewportUnits(&mHandler, pObject);
		}

		/// Get the Visual attribute
		void NOXVisualBrush::getVisual(NOString &pString)
		{
			NOXStringBase lString=pString.getHandler();
			NAXVisualBrush_getVisual(&mHandler, &lString);
			return;
		}

		/// Check for the availability of the Visual attribute
		bool NOXVisualBrush::hasVisual()
		{
			return (NAXVisualBrush_hasVisual(&mHandler)!=0);
		}

		/// Removes the Visual attribute
		bool NOXVisualBrush::removeVisual()
		{
			return (NAXVisualBrush_removeVisual(&mHandler)!=0);
		}

		/// Sets the Visual attribute
		void NOXVisualBrush::setVisual(NOXRscRef pObject)
		{
			NAXVisualBrush_setVisual(&mHandler, pObject);
		}

		/// Initialize
		/*public*/ void intialize(NOXViewBox pViewbox, NOXViewBox pViewport, NOXViewUnits pViewboxUnits, NOXViewUnits pViewportUnits)
		{
			NAXVisualBrush_intialize(&mHandler, pViewbox, pViewport, pViewboxUnits, pViewportUnits);
		}

		/// Get child element at index pIndex
		/// @param pIndex index of the element you want to get
		/*public*/ NOXBase NOXVisualBrush::getChild(NCommon::UInt32 pIndex)
		{
			return NAXVisualBrush_getChild(&mHandler, pIndex);
		}

		/// Calculate the number of child elements that are present
		NCommon::UInt32 NOXVisualBrush::getNumChilds()
		{
			return NAXVisualBrush_getNumChilds(&mHandler);
		}

};

}

#endif
