// NTError.h
//
// (c) NiXPS NV, July 2007

#ifndef _NTERROR_H_
#define _NTERROR_H_

/*! \file NTError.h
    \brief Header file for error types
*/
namespace NCommon
{

typedef enum 
{
	ERR_DEFAULT_VISITHANDLER_CALLED				= 0x1001, /**< 0x1001 */
	ERR_OUT_OF_MEMORY							= 0x1002, /**< 0x1002 */
	ERR_CANNOT_CONVERT_TO_UTF8					= 0x1003, /**< 0x1003 */
	ERR_BUFFER_OVERFLOW							= 0x1004, /**< 0x1004 */
	ERR_GENERIC_ERROR							= 0x1005, /**< 0x1005 */
	ERR_UNKNOWN_CONTENT_TYPE					= 0x1006, /**< 0x1006 */
	ERR_INTERNAL_OVERFLOW						= 0x1007, /**< 0x1007 */
	ERR_HANDLER									= 0x1008, /**< 0x1008 */
	ERR_WRONG_LICENSE							= 0x1009, /**< 0x1009 */
	ERR_FILE_CANNOT_READ						= 0x1103, /**< 0x1103 */
	ERR_FILE_CANNOT_WRITE						= 0x1104, /**< 0x1104 */
	ERR_FILE_CORRUPT_READ						= 0x1105, /**< 0x1105 */
	ERR_INIT_TOO_MANY_PARTS						= 0x1201, /**< 0x1201 */
	ERR_INIT_TOO_MANY_RELATIONSHIPS				= 0x1202, /**< 0x1202 */
	ERR_INIT_FIXEDDOCUMENTSEQUENCE_NOT_FOUND	= 0x1203, /**< 0x1203 */
	ERR_INIT_DOCUMENTPART_NOT_FOUND				= 0x1204, /**< 0x1204 */
	ERR_INIT_UNKNOWN_RELATIONSHIP				= 0x1205, /**< 0x1205 */
	ERR_INIT_UNKNOWN_PART						= 0x1206, /**< 0x1206 */
	ERR_INIT_CANNOT_FIND_SOURCE_OF_RELATIONSHIP	= 0x1207, /**< 0x1207 */
	ERR_INIT_CANNOT_FIND_FILE					= 0x1208, /**< 0x1208 */
	ERR_INIT_PARSE_ERROR						= 0x1209, /**< 0x1209 */
	ERR_INIT_CANNOT_CREATE_RELATIONSHIP_NAME	= 0x1210, /**< 0x1210 */
	ERR_ZIP_CANNOT_READ							= 0x1301, /**< 0x1301 */
	ERR_ZIP_CORRUPT_READ						= 0x1302, /**< 0x1302 */
	ERR_ZIP_CANNOT_FIND_FILE					= 0x1303, /**< 0x1303 */
	ERR_ZIP_CANNOT_WRITE						= 0x1304, /**< 0x1304 */
	ERR_ACCESS_PART_ID_OUT_OF_RANGE				= 0x1401, /**< 0x1401 */
	ERR_ACCESS_PART_NOT_FOUND					= 0x1402, /**< 0x1402 */
	ERR_ACCESS_TARGET_RELATIONSHIP_NOT_FOUND	= 0x1403, /**< 0x1403 */
	ERR_ACCESS_CANNOT_CREATE					= 0x1404, /**< 0x1404 */
	ERR_ACCESS_SYNTAX_ERROR						= 0x1405, /**< 0x1405 */
	ERR_ACCESS_CANNOT_FIND_CONTENT_TYPES_PART	= 0x1406, /**< 0x1406 */
	ERR_ACCESS_UNKNOWN_PAGE						= 0x1407, /**< 0x1407 */
	ERR_ACCESS_INTERNAL_OVERFLOW				= 0x1408, /**< 0x1408 */
	ERR_ACCESS_CANNOT_ACCESS_EXTERNAL_FILE		= 0x1409, /**< 0x1409 */
	ERR_ACCESS_CANNOT_COPY_FILE					= 0x1410, /**< 0x1410 */
	ERR_ACCESS_UNKNOWN_DOCUMENT					= 0x1411, /**< 0x1411 */
	ERR_ACCESS_PART_NAME_ALREADY_IN_USE			= 0x1412, /**< 0x1412 */
	ERR_ACCESS_FONT_CANNOT_READ					= 0x1413, /**< 0x1413 */
	ERR_ACCESS_FONT_ILLEGAL_FILE				= 0x1414, /**< 0x1414 */
	ERR_ACCESS_FONT_ILLEGAL_UUID				= 0x1415, /**< 0x1415 */
	ERR_ACCESS_IMAGE_NOT_IN_MEMORY				= 0x1416, /**< 0x1416 */
	ERR_ACCESS_IMAGE_PNG_ERROR					= 0x1417, /**< 0x1417 */
	ERR_ACCESS_IMAGE_TIFF_ERROR					= 0x1418, /**< 0x1418 */
	ERR_ACCESS_UNKNOWN_IMAGE_FORMAT				= 0x1419, /**< 0x1419 */
//	FREE										= 0x1420, /**< 0x1420 */
	ERR_ACCESS_MALFORMED_XPS					= 0x1421, /**< 0x1421 */
	ERR_ACCESS_IMAGE_JPG_ERROR					= 0x1422, /**< 0x1422 */
	ERR_WRITE_CANNOT_DETERMINE_PART_DATA_SOURCE	= 0x1501, /**< 0x1501 */
	ERR_OBJECT_NO_CORE_PROPERTIES				= 0x1601, /**< 0x1601 */
	ERR_OBJECT_NO_FIXED_DOCUMENT_SEQUENCE		= 0x1602, /**< 0x1602 */
	ERR_OBJECT_DOCUMENT_NOT_FOUND				= 0x1603, /**< 0x1603 */
	ERR_OBJECT_NO_THUMBNAIL						= 0x1604, /**< 0x1604 */
	ERR_OBJECT_NO_PACKAGE						= 0x1605, /**< 0x1605 */
	ERR_OBJECT_PAGE_NOT_FOUND					= 0x1606, /**< 0x1606 */
	ERR_OBJECT_FONT_NOT_FOUND					= 0x1607, /**< 0x1607 */
	ERR_OBJECT_ATTRIBUTE_NOT_FOUND				= 0x1608, /**< 0x1608 */
	ERR_OBJECT_NOT_FOUND						= 0x1609, /**< 0x1609 */
	ERR_OBJECT_PARSE_ERROR_ENUM					= 0x1610, /**< 0x1610 */
	ERR_OBJECT_PARSE_ERROR						= 0x1611, /**< 0x1611 */
	ERR_OBJECT_CANNOT_FIND_DATA					= 0x1613, /**< 0x1613 */
	ERR_OBJECT_TYPE_MISMATCH					= 0x1614, /**< 0x1614 */
	ERR_OBJECT_RESOURCE_DICTIONARY_NOT_FOUND	= 0x1615, /**< 0x1615 */
	ERR_RUNNER_UNKNOWN_ACTION					= 0x1701, /**< 0x1701 */
	ERR_CANNOT_GENERATE_PREVIEW					= 0x1801, /**< 0x1801 */
	ERR_FREETYPE_FONT_SIZE						= 0x1901,  /**< 0x1901 */
	ERR_UNSUPPORTED								= 0x1902,  /**< 0x1902 */
	ERR_ACCESS_IMAGE_HDPHOTO_ERROR				= 0x8000  /**< 0x8000 - the 3rdPary error is added*/
} Error;


/*! \typedef NCommon::Error
 *  Error codes.
 */

};

#endif

