// NXTypes header file
//
// (c) NDR 2007-2008, NiXPS NV, All rights reserved

#ifndef _NXTypes_h_
#define _NXTypes_h_

/*! \file NXTypes.h
	\brief Header file for the NXTypes class
*/

namespace NCommon
{

enum NXType {
	xUnknown = 0,
	xDocumentStructure = 1,
	xCP_Outline = 2,
	xDocumentOutline = 3,
	xOutlineEntry = 4,
	xStory = 5,
	xStoryFragmentReference = 6,
	xStoryFragments = 7,
	xStoryFragment = 8,
	xBreak = 9,
	xSection = 10,
	xParagraph = 11,
	xTable = 12,
	xTableRowGroup = 13,
	xTableRow = 14,
	xTableCell = 15,
	xList = 16,
	xListItem = 17,
	xFigure = 18,
	xNamedElement = 19,
	xMatrixTransform = 20,
	xSolidColorBrush = 21,
	xImageBrush = 22,
	xVisualBrush = 23,
	xLinearGradientBrush = 24,
	xRadialGradientBrush = 25,
	xGradientStop = 26,
	xPathGeometry = 27,
	xGlyphs = 28,
	xPath = 29,
	xPathFigure = 30,
	xArcSegment = 31,
	xPolyQuadraticBezierSegment = 32,
	xPolyLineSegment = 33,
	xPolyBezierSegment = 34,
	xCanvas = 35,
	xResourceDictionary = 36,
	xFixedPage = 37,
	xFixedDocument = 38,
	xPageContent = 39,
	xFixedDocumentSequence = 40,
	xDocumentReference = 41,
	xLinkTarget = 42,
	xCP_LinkTargets = 43,
	xCP_Transform = 44,
	xCP_Visual = 45,
	xCP_GradientStops = 46,
	xCP_Geometry = 47,
	xCP_Brush = 48,
	xCP_Resources = 49,
};

enum NXVocabulary {
	eUnknown = 0,
	eArcSegment = 1,
	eCanvas = 2,
	eCanvasClip = 3,
	eCanvasOpacityMask = 4,
	eCanvasRenderTransform = 5,
	eCanvasResources = 6,
	eContentType = 7,
	eDefault = 8,
	eDocumentOutline = 9,
	eDocumentReference = 10,
	eDocumentStructureOutline = 11,
	eExtension = 12,
	eFigureStructure = 13,
	eFixedPageResources = 14,
	eGlyphs = 15,
	eGlyphsClip = 16,
	eGlyphsFill = 17,
	eGlyphsOpacityMask = 18,
	eGlyphsRenderTransform = 19,
	eGradientStop = 20,
	eImageBrush = 21,
	eImageBrushTransform = 22,
	eLinearGradientBrush = 23,
	eLinearGradientBrushGradientStops = 24,
	eLinearGradientBrushTransform = 25,
	eLinkTarget = 26,
	eListItemStructure = 27,
	eListStructure = 28,
	eMatrixTransform = 29,
	eNamedElement = 30,
	eOutlineEntry = 31,
	eOverride = 32,
	ePageContent = 33,
	ePageContentLinkTargets = 34,
	eParagraphStructure = 35,
	ePartName = 36,
	ePath = 37,
	ePathClip = 38,
	ePathData = 39,
	ePathFill = 40,
	ePathOpacityMask = 41,
	ePathRenderTransform = 42,
	ePathStroke = 43,
	ePathFigure = 44,
	ePathGeometry = 45,
	ePathGeometryTransform = 46,
	ePolyBezierSegment = 47,
	ePolyLineSegment = 48,
	ePolyQuadraticBezierSegment = 49,
	eRadialGradientBrush = 50,
	eRadialGradientBrushGradientStops = 51,
	eRadialGradientBrushTransform = 52,
	eResourceDictionary = 53,
	eSectionStructure = 54,
	eSolidColorBrush = 55,
	eStory = 56,
	eStoryBreak = 57,
	eStoryFragment = 58,
	eStoryFragmentReference = 59,
	eTableCellStructure = 60,
	eTableRowGroupStructure = 61,
	eTableRowStructure = 62,
	eTableStructure = 63,
	eTypes = 64,
	eVisualBrush = 65,
	eVisualBrushTransform = 66,
	eVisualBrushVisual = 67,
};


/*UTF8String gNXVocabularyStrings[] = {
	"Unknown", // = 0,
	"ArcSegment", // = 1,
	"Canvas", // = 2,
	"Canvas.Clip", // = 3,
	"Canvas.OpacityMask", // = 4,
	"Canvas.RenderTransform", // = 5,
	"Canvas.Resources", // = 6,
	"ContentType", // = 7,
	"Default", // = 8,
	"DocumentOutline", // = 9,
	"DocumentReference", // = 10,
	"DocumentStructure.Outline", // = 11,
	"Extension", // = 12,
	"FigureStructure", // = 13,
	"FixedPage.Resources", // = 14,
	"Glyphs", // = 15,
	"Glyphs.Clip", // = 16,
	"Glyphs.Fill", // = 17,
	"Glyphs.OpacityMask", // = 18,
	"Glyphs.RenderTransform", // = 19,
	"GradientStop", // = 20,
	"ImageBrush", // = 21,
	"ImageBrush.Transform", // = 22,
	"LinearGradientBrush", // = 23,
	"LinearGradientBrush.GradientStops", // = 24,
	"LinearGradientBrush.Transform", // = 25,
	"LinkTarget", // = 26,
	"ListItemStructure", // = 27,
	"ListStructure", // = 28,
	"MatrixTransform", // = 29,
	"NamedElement", // = 30,
	"OutlineEntry", // = 31,
	"Override", // = 32,
	"PageContent", // = 33,
	"PageContent.LinkTargets", // = 34,
	"ParagraphStructure", // = 35,
	"PartName", // = 36,
	"Path", // = 37,
	"Path.Clip", // = 38,
	"Path.Data", // = 39,
	"Path.Fill", // = 40,
	"Path.OpacityMask", // = 41,
	"Path.RenderTransform", // = 42,
	"Path.Stroke", // = 43,
	"PathFigure", // = 44,
	"PathGeometry", // = 45,
	"PathGeometry.Transform", // = 46,
	"PolyBezierSegment", // = 47,
	"PolyLineSegment", // = 48,
	"PolyQuadraticBezierSegment", // = 49,
	"RadialGradientBrush", // = 50,
	"RadialGradientBrush.GradientStops", // = 51,
	"RadialGradientBrush.Transform", // = 52,
	"ResourceDictionary", // = 53,
	"SectionStructure", // = 54,
	"SolidColorBrush", // = 55,
	"Story", // = 56,
	"StoryBreak", // = 57,
	"StoryFragment", // = 58,
	"StoryFragmentReference", // = 59,
	"TableCellStructure", // = 60,
	"TableRowGroupStructure", // = 61,
	"TableRowStructure", // = 62,
	"TableStructure", // = 63,
	"Types", // = 64,
	"VisualBrush", // = 65,
	"VisualBrush.Transform", // = 66,
	"VisualBrush.Visual", // = 67,
	"" // = 68,
};*/

}

#endif
