// Code
//
// example plug-in code
//
// (c) NiXPS NV, Februari 2008

#include <string>
#include <cstdio>
#include <sstream>
#include <ctime>
#include <windows.h>
#include <tchar.h>

#include "NTypes.h"
#include "Code.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
HWND hWnd,hEdit,hButton;
TCHAR szTitle[MAX_LOADSTRING]=_T("PlugIn");					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING]=_T("NIXPSPLUGIN");			// the main window class name
std::stringstream sBuffer;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

void logMessage(const char *pMessage)
{
	std::stringstream lStr;
	lStr << time(NULL) << ": " << pMessage << "\r\n" << sBuffer.str();
	sBuffer.str("");
	sBuffer << lStr.str();
	
	LPWSTR lWideCharStr=(LPWSTR)malloc((lStr.str().length()+1)*sizeof(WCHAR));
	int len=MultiByteToWideChar(CP_UTF8,0,lStr.str().c_str(),lStr.str().length(),lWideCharStr,lStr.str().length());     
	if (!len)
		return;
	lWideCharStr[len]=0;
	SetWindowText(hEdit,lWideCharStr);	
	free(lWideCharStr);
};

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass()
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= 0;
	wcex.hIcon			= 0; //LoadIcon(hInstance, MAKEINTRESOURCE(IDI_UITEST));
	wcex.hCursor		= 0; //LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= 0; //MAKEINTRESOURCE(IDC_UITEST);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= 0; //LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
void initUI(const char *pPath)
{
	MyRegisterClass();

	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
	  0, 0, 440, 400, NULL, NULL, 0, NULL);

	if (!hWnd)
	{
	  return;
	}

	hEdit = CreateWindow( 
						_T("EDIT"), 
						_T(""),	
						WS_CHILD | WS_VISIBLE | ES_LEFT | WS_BORDER | ES_MULTILINE ,
                        10, 10, 400, 300,
                        hWnd,
                        NULL,
                        0, 
						NULL );


	HMENU lButtonID=(HMENU)555;
	hButton = CreateWindow( 
						_T("BUTTON"), 
						_T("Clear"),	
						WS_CHILD | WS_VISIBLE | ES_LEFT  ,
                        310, 320, 100, 25,
                        hWnd,
                        lButtonID,
                        0, 
						NULL );

	UpdateWindow(hWnd);

	return;
}

void openUI()
{
	ShowWindow(hWnd, 1);
}

void closeUI()
{
	ShowWindow(hWnd, 0);
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
//		case IDM_ABOUT:
//			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
//			break;
//		case IDM_EXIT:
//			DestroyWindow(hWnd);
//			break;
		case 555:
				sBuffer.str("");
				logMessage("Clear");
				break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
/*
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
*/	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}


