// NOCorePropertiesDLL.cpp
//
// NOCoreProperties: CoreProperties class
//			
// (c) NiXPS NV, Juni 2007

/*! \file NOCoreProperties.cpp
    \brief Implementation of the NOCoreProperties class
*/

#include "NTypes.h"
#include "NTCorePropertyType.h"

#include "NOException.h"
#include "NOXMLPartBased.h"
#include "NOCoreProperties.h"

namespace NiXPSObjects
{

NOCoreProperties::NOCoreProperties(NOCorePropertiesHandler pHandler) : NOXMLPartBased(pHandler)
{
}

// destructor
NOCoreProperties::~NOCoreProperties()
{
}

// get property
const NCommon::UTF8String NOCoreProperties::getProperty(NCommon::CoreProperty::Type pType)
{
	NOString lString;
	NOCoreProperties_getProperty(&mHandler, (UInt32) pType, &lString.mHandler);
	if (mHandler.mError!=0)
		throw(NOException(mHandler));

	return lString.getUTF8String();
}

void NOCoreProperties::setProperty(NCommon::CoreProperty::Type pType, const NCommon::UTF8Char *pString)
{
	NOCoreProperties_setProperty(&mHandler, (UInt32) pType, const_cast<UTF8Char *>(pString));

	if (mHandler.mError!=0)
		throw(NOException(mHandler));
}

}