// NOPackageMap.cpp
//
// Object that represents a complete package
//			
// (c) NiXPS NV, February 2008

/*! \file NOPackageMap.cpp
    \brief Implementation of a map of packages
*/

#include "NTypes.h"
#include "NOPackage.h"
#include "NOPackageMap.h"

namespace NiXPSObjects
{

// doC# public NiXPS.NOPackageMapHandler mHandler;

NOPackageMap::NOPackageMap(NOPackageMapHandler pHandler)
{
	mHandler=NOPackageMap_new();
}

NOPackageMap::~NOPackageMap()
{
	NOPackageMap_delete(&mHandler);
}

// this function tis tagged with 'noC#', so it won't end up in the C# code output
NOPackageMap::NOPackageMap(const std::map<NCommon::UTF8String, NiXPSObjects::NOPackage *> &pOriginalMap) : mHandler(NOPackageMap_new()) // noC#
{ // noC#
	std::map<NCommon::UTF8String, NiXPSObjects::NOPackage *>::const_iterator it = pOriginalMap.begin(); // noC#
	for (; it != pOriginalMap.end(); it++) // noC#
	{ // noC#
		NOPackageHandler pHandler = (*it->second).mHandler; // noC#
		UTF8String lKeyString(it->first); // noC#
		NOPackageMap_addEntry(&mHandler,(UTF8Char*) lKeyString.c_str(),pHandler); // noC#
	} // noC#
} // noC#

// this is the C# version, based on the Dictionary generic
// noC# NOPackageMap( ref Dictionary<String, NOPackage> pOriginalMap)
// noC# {
// noC#     mHandler=NOPackageMap_new();
// noC# 	foreach (KeyValuePair it in pOriginalMap)
// noC# 	{
// noC# 		NiXPS.NOHandler pHandler = it.Value;
// noC# 		String lKeyString(it.Key);
// noC# 		NOPackageMap_addEntry(ref mHandler,System.Text.Encoding.UTF8.GetBytes(it.Key),pHandler);
// noC# 	}
// noC# }

}
