// NOSelection.cpp
//
// NOSelection
//
// (c) NiXPS NV, January 2008

/*! \file NOSelection.cpp
    \brief Implementation of the NOSelection class
*/

#include "NOXPrefix.h"

#include "NOException.h"
#include "NOSelection.h"

namespace NiXPSObjects
{

// doC# public NiXPS.NOSelectionHandler mHandler;

NOSelection::NOSelection(NOSelectionHandler pHandler)
{
	mHandler = pHandler;
}

NOSelection::NOSelection()
{
	mHandler.mPtr=0;
}

NOSelection::~NOSelection()
{
	NOSelection_delete(&mHandler);
}

NCommon::UInt32 NOSelection::getNumberOfSelectedObjects()
{
	UInt32 lReturnValue = NOSelection_getNumberOfSelectedObjects(&mHandler);
	if (mHandler.mError!=0)
		throw(NOException(mHandler.mError));
	return lReturnValue;
}

NOBase NOSelection::getSelectedObject(NCommon::UInt32 pIndex)
{
	NOXHandler lHandler;
	NOSelection_getSelectedObject(&mHandler,pIndex,&lHandler);
	if (mHandler.mError!=0)
		throw(NOException(mHandler.mError));
	return NOBase(lHandler);
}

void NOSelection::removeObjectFromSelection(NCommon::UInt32 pIndex)
{
	NOSelection_removeObjectFromSelection(&mHandler,pIndex);
}

UInt32 NOSelection::getSelectedObjectID(NCommon::UInt32 pIndex)
{
	UInt32 lReturnValue = NOSelection_getSelectedObjectID(&mHandler,pIndex);
	if (mHandler.mError!=0)
		throw(NOException(mHandler.mError));
	return lReturnValue;
}

bool NOSelection::hasObject(NCommon::UInt32 pId)
{
	UInt32 lReturnValue = NOSelection_hasObject(&mHandler,pId);
	if (mHandler.mError!=0)
		throw(NOException(mHandler.mError));	
	return lReturnValue;
}

NOSelection &NOSelection::operator=(const NOSelection &pSelection) // noC#
{ // noC#
	NOSelection_copy(&mHandler,(NOSelectionHandler *) &pSelection.mHandler); // noC#
	return *this; // noC#
} // noC#

NOSelection::NOSelection(const NOSelection &pSelection)// noC#
{// noC#
	mHandler.mPtr=0;// noC#
	NOSelection_copy(&mHandler,(NOSelectionHandler *) &pSelection.mHandler);// noC#
}// noC#
}