// NOString.cpp
//
// NOString
//
// (c) NiXPS NV, May 2007

/*! \file NOString.cpp
    \brief Implementation of the NOString class
*/

#include "NOString.h"

namespace NiXPSObjects
{

// doC# public NiXPS.NOStringHandler mHandler;

// constructor: object is always linked to a specific package (and probably also a specific part)
NOString::NOString()
{
	mHandler=NOString_new();
}

NOString::NOString(NOStringHandler &pHandler)// noC#
{// noC#
	mHandler=pHandler;// noC#
}// noC#
	
NOString::NOString(const UTF8String &pIn) // noC#
{ // noC#
	mHandler=NOString_newWithCString((UTF8Char *) pIn.c_str()); // noC#
} // noC#

// doC# public NOString(NiXPS.NOVoidHandler pHandler)
// doC# {
// doC#     mHandler = pHandler;
// doC# }

// doC# public NOString(byte[] pIn)
// doC# {
// doC#		mHandler = NOString_newWithCString(pIn);
// doC# }
 
// destructor
NOString::~NOString()
{
	NOString_delete(&mHandler);
}

// get handler
NOStringHandler NOString::getHandler()
{
	return mHandler;
} 

// get pointer to string
const NCommon::UTF8String NOString::getUTF8String() const // noC#
{ // noC#
	return NOString_c_str(&mHandler); // noC#
} // noC#
// doC# const NCommon::UTF8String NOString::getUTF8String() const
// doC# {
// doC#		return Marshal.PtrToStringAnsi(NOString_c_str(ref mHandler));
// doC# }

// returns the size of the vector
NCommon::UInt32 NOString::size()
{
	return NOString_size(&mHandler);
}


void NOString::initializeFrom(const NOString &pArgument) // noC#
{ // noC#
	UTF8String lString=pArgument.getUTF8String(); // noC#
	mHandler=NOString_newWithCString((UTF8Char *) lString.c_str()); // noC#
} // noC#
// doC# void NOString::initializeFrom(const NOString &pArgument)
// doC# {
// doC# 	string lString=pArgument.getUTF8String();
// doC# 	mHandler=NOString_newWithCString(System.Text.Encoding.UTF8.GetBytes(lString));
// doC# }

NOString::NOString(const NOString &pArgument)
{
	initializeFrom(pArgument);
}

NOString &NOString::operator=(const NOString &pArgument) // noC#
{ // noC#
	initializeFrom(pArgument); // noC#
	return *this; // noC#
} // noC#

}

