// NOTextSelection.cpp
//
// NOTextSelection
//
// (c) NiXPS NV, January 2008

/*! \file NOTextSelection.cpp
    \brief Implementation of the NOTextSelection class
*/

#include "NOString.h"

#include "NOTextSelection.h"

namespace NiXPSObjects
{

// doC# public NiXPS.NOTextSelectionHandler mHandler;

NOTextSelection::NOTextSelection()
{
	mHandler=NOTextSelection_new();
}

NOTextSelection::NOTextSelection(const NOTextSelectionHandler &pIn)
{
//	NOTextSelection_delete(&mHandler);
	mHandler=pIn;
}

UInt32 NOTextSelection::getNumberOfSelections()
{
	return NOTextSelection_getNumberOfSelections(&mHandler);
}

void NOTextSelection::getSelection(UInt32 pIndex, UInt32 &pId, doubleMatrix &pMatrix, doubleRect &pRect)
{
	doubleMatrixC lMatrix;
	doubleRectC lRect;
	NOTextSelection_getSelection(&mHandler,pIndex,&pId,&lMatrix,&lRect);
	pMatrix=lMatrix;
	pRect=lRect;
}

NOTextSelection::~NOTextSelection()
{
	NOTextSelection_delete(&mHandler);
}

NOTextSelection & NOTextSelection::operator=(const NOTextSelection &pSelection) // noC#
{ // noC#
	NOTextSelection_copy(&(this->mHandler), pSelection.mHandler); // noC#
	return *this; // noC#
} // noC#

NOTextSelection::NOTextSelection(const NOTextSelection &pSelection)
{
	mHandler=NOTextSelection_new();
	NOTextSelection_copy(&mHandler, pSelection.mHandler);	
}

NOString NOTextSelection::getSelectedTextPart(UInt32 pIndex)
{
	NOStringHandler lHandler = NOTextSelection_getSelectedTextPart(&this->mHandler, pIndex);
	return NOString(lHandler); // noC#
// doC# return NOString(lHandler);
}
}