// NOThumbnail.cpp
//
// NOThumbnail: NOThumbnail class
//
// (c) NiXPS NV, June 2007

/*! \file NOThumbnail.cpp
    \brief Implementation of the NOThumbnail class
*/

#include "NOThumbnail.h"
#include "NOPackage.h"
#include "NOException.h"
	
namespace NiXPSObjects
{
	
NOThumbnail::NOThumbnail(): NOPartBased() 
{
}

NOThumbnail::NOThumbnail(const NOThumbnailHandler pHandler): NOPartBased(pHandler) {}

// destructor
NOThumbnail::~NOThumbnail() {};

// get image size
NCommon::UInt32 NOThumbnail::getImageSize()
{
	UInt32 lRet=NOThumbnail_getImageSize(&mHandler);

	if (mHandler.mError!=0)
		throw(NOException(mHandler));

	return lRet;
}

// get image data
bool NOThumbnail::getImageData(NCommon::UInt8 *pBuffer, NCommon::UInt32 pSize)
{
	UInt32 lRet=NOThumbnail_getImageData(&mHandler,pBuffer,pSize);

	if (mHandler.mError!=0)
		throw(NOException(mHandler));

	return lRet;
}
}