// NOUtility.h
//
// NOUtility: NOUtility class
//			
//
// (c) NiXPS NV, January 2008

/*! \file NOUtility.cpp
    \brief Implementation of the NOUtility class
*/

#include "NTypes.h"
#include "NOUtility.h"
#include "NOStringVector.h"

namespace NiXPSObjects
{

/*static*/ void NOUtility::getCSVFileColumnNames(const NCommon::UTF8Char *pPathToFile, NOStringVector &pColumnNames)
{
	NOUtility_getCSVFileColumnNames(const_cast<UTF8Char *>(pPathToFile), &pColumnNames.mHandler);
}

/*static*/ void NOUtility::getColorFromXPSString(const NCommon::UTF8Char *pFillString, double &r, double &g, double &b, double &alpha)
{
	NOUtility_getColorFromXPSString(const_cast<UTF8Char *>(pFillString),&r,&g,&b,&alpha);
}

/*static*/ bool NOUtility::runScript(		NCommon::UInt8 *pXMLScript,
					NOPackageMap &pInputFiles,
					NOPackageMap &pOutputFiles,
					NOProgressReporter pReporter, 
					NCommon::UTF8String &pOutput
					)
{
	/*
	* FILE *debugScript = fopen("script.xml","wb");
	* if (debugScript)
	* {
	* 	const UTF8Char *pCharP = pXMLScript.c_str();
	* 	while (*pCharP)
	* 		fputc(*pCharP++,debugScript);
	* 	fclose (debugScript);
	* }
	*/
	NOString lString;
	//(const_cast<UTF8Char *>(pOutput));
	NOPackageMapHandler lHandlerIn = pInputFiles.mHandler;
	NOPackageMapHandler lHandlerOut = pOutputFiles.mHandler;
	bool lRet=NOUtility_runScript(	pXMLScript,
									&lHandlerIn,
									&lHandlerOut,
									pReporter.mHandler,
									&lString.mHandler);
	pOutput=lString.getUTF8String();
	return lRet;
}

/*static*/ bool NOUtility::convertToXPSViaPrinter(UTF8Char *pSource, UTF8Char *pDestination, UTF8Char *pPrinterOutputFile, UTF8Char *pXPSPrinterDriverName, UInt32 pTimeOut)
{
	return NOUtility_convertToXPSViaPrinter(const_cast<UTF8Char *>(pSource),const_cast<UTF8Char *>(pDestination),const_cast<UTF8Char *>(pPrinterOutputFile),const_cast<UTF8Char *>(pXPSPrinterDriverName),pTimeOut);
}

UTF8String NOUtility::getSuitableFontForFamilyAndStyle(const UTF8Char *pFamilyName, const UTF8Char *pStyleName,
														NOProgressReporter pReporter)
{
	NOString lString;
	NOUtility_getSuitableFontForFamilyAndStyle(	&lString.mHandler,
												const_cast<UTF8Char *>(pFamilyName),
												const_cast<UTF8Char *>(pStyleName),
												pReporter.mHandler);
	return lString.getUTF8String();
}

UInt32 NOUtility::haveCachedFontList()
{
	return NOUtility_haveCachedFontList();
}

};
