// NOVector.cpp
//
// NOVector
//
// (c) NiXPS NV, May 2007

/*! \file NOVector.cpp
    \brief Implementation of the NOVector class
*/

#include "NOVector.h"
#include "NOPartBased.h"
#include "NOPackage.h"

namespace NiXPSObjects
{

// doC# public NiXPS.NOVectorHandler mHandler;

void NOVector::addPart(NOHandler mPart)
{
	NOVector_addPart(&mHandler,mPart);
}

void NOVector::addPartID(const UInt16 mPartID)
{
	NOVector_addPartID(&mHandler,mPartID);
}

const UInt16 NOVector::getPartIDAtIndex(const UInt32 pIndex) const
{
	return NOVector_getPartIDAtIndex((NOVectorHandler *) &mHandler, pIndex);
}

NOVector::NOVector(NOPackage *pPackage)
{
	mHandler=NOVector_new(pPackage->mHandler);
}

NOVector::~NOVector()
{
	NOVector_delete(&mHandler);
}
		
NOVectorHandler NOVector::getHandler() const
{
	return mHandler;
}
		
NCommon::UInt32 NOVector::size() const
{
	return NOVector_size((NOVectorHandler *) &mHandler);
}

NOVector &NOVector::operator=(const NOVector &pArgument) // noC#
{ // noC#
	NOVector_copy(&mHandler,pArgument.mHandler); // noC#
	return *this; // noC#
} // noC#

}