// NOXMLPartBased.cpp
//
// NOXMLPartBased:	base class for all NiXPSObjects based on an xml part
//			
// (c) NiXPS NV, April 2007

/*! \file NOThumbnail.cpp
    \brief Implementation of the NOXMLPartBased class
*/

#include "NOXMLPartBased.h"
#include "NOException.h"

namespace NiXPSObjects
{

NOXMLPartBased::NOXMLPartBased(): NOPartBased()
{
}

NOXMLPartBased::NOXMLPartBased(const NOHandler pHandler): NOPartBased(pHandler)
{	
}

NOXMLPartBased::~NOXMLPartBased()
{
}

NOContentStreamNavigator NOXMLPartBased::getContentStreamNavigator()
{
	return NOContentStreamNavigator(*this);
}

void NOXMLPartBased::getContentStream(UInt8 *pBuffer, UInt32 pSize)
{
	NOXMLPartBased_getContentStream(&mHandler,pBuffer,pSize);
	
	if (mHandler.mError!=0)
		throw(NOException(mHandler));
}

NCommon::UInt32 NOXMLPartBased::getContentStreamLength()
{
	UInt32 lRet=NOXMLPartBased_getContentStreamLength(&mHandler);

	if (mHandler.mError!=0)
		throw(NOException(mHandler));
		
	return lRet;
}

void NOXMLPartBased::replaceContentStream(const UInt8 *pBuffer, UInt32 pLen)
{
	NOXMLPartBased_replaceContentStream(&mHandler,(UInt8 *) pBuffer, pLen);

	if (mHandler.mError!=0)
		throw(NOException(mHandler));
}

}
